
#include "DFLora_At.h"
#include <stdio.h>
#include <stdbool.h>
#include "LmHandler.h"
#include "LoRaMac.h"
#include "region/Region.h"
#include "NvmDataMgmt.h"
#include "math.h"
#include "MD5.h"
#include "NT3H.h"
#include "app_i2c.h"
#include "csv.h"
#include "radio.h"
#include <log.h>
#include <stateMachine.h>
#include "dfbc.h"
#include "test.h"
#include "comm.h"
#include "modbus.h"

uint8_t AT = 0;

pAtCmd atHead=NULL,atTail=NULL;
static uint8_t port = 0;
//static uint8_t state = 0;
static uint8_t pinState = 0;
static uint8_t ser = 0;
char str[1024]={0};
volatile uint8_t tansFlag = 0;
volatile uint8_t transImmed = 0;
struct msgBuf *msgBufHead    = NULL;
struct msgBuf *msgBufTail    = NULL;

static pDFSerial tempSerial;
static uint8_t modbus_channel;

extern volatile sDFBCEvents_t dfbcEvents;
extern uint8_t is_dfbc_valid;
extern uint8_t is_io_count;

//通信接口初始化
 tDFSerial dfserials[SENUM]={
         {
                  .print = uart1Print,
                  .write8 = uart1Write8,
                  .write16 = uart1Write16,
                  .flush = uart1Flush,
				  .index = 0,
         },
         {
                     .print = USB1Print,
                     .write8 = USB1Write8,
                     .write16 = USB1Write16,
                     .flush = USB1Flush,
					 .index = 0,
         },

         {
                     .print = LORAWANPrint,
                     .write8 = LORAWANWrite8,
                     .write16 = USB1Write16,
                     .flush = LORAWANFlush,
					 .index = 0,
         },
         {
                     .print = USB2Print,
                     .write8 = USB2Write8,
                     .write16 = USB2Write16,
                     .flush = USB2Flush,
					 .index = 0,
         },

         {
                     .print = NULL,
                     .write8 = NULL,
                     .write16 = NULL,
                     .flush = NULL,
					 .index = 0,
         },
         {
                     .print = NFCPrint,
                     .write8 = NULL,
                     .write16 = NULL,
                     .flush = NULL,
					 .index = 0,
         },

 };
 TimerEvent_t sleepTimer;
 TimerEvent_t hardwareLoopTimer;
 TimerEvent_t unixEpochTimer;
 TimerEvent_t transTimer;
 TimerEvent_t ioOut1Timer;
 TimerEvent_t ioOut2Timer;
 TimerEvent_t  rs485TimeOutTimer;

 static LmHandlerAppData_t AppData =                               //MAC层包数据
 {
     .Buffer = NULL,
     .BufferSize = 0,
     .Port = 0,
 };
static uint32_t sendCount = 0;
static uint8_t io1CmdIndex = 0;
static uint8_t io2CmdIndex = 0;

sDtuConfig_t dtuConfig;
//换成flash区的结构体数组，去掉注册AT
const uint8_t eirpUS915[]={22,20,18,16,14,12,10,8,6,4,2,0};
//CN470 eirp列表
const uint8_t eirpCN470[]={19,17,15,13,11,9,7,0};
//EU868 eirp列表
const uint8_t eirpEU868[]={16,14,12,10,8,6,4,2,0};

const uint8_t txpowerUS915[]={5,6,7,8,9,10,11,12,13,14};
//CN470 eirp列表
const uint8_t txpowerCN470[10]={0,1,2,3,4,5,6};
//EU868 eirp列表
const uint8_t txpowerEU868[]={0,1,2,3,4,5,6,7,8,9,10,11};
const uint32_t baudRates[] = {4800, 9600, 14400, 19200, 38400, 115200};

bool isEirpValid (uint8_t *eirp,uint8_t eripS,uint8_t * index){
    for (int i = 0; i < strlen(eirp); i++) {

        if (eirp[i] == eripS) {
            //isValid = true;
            *index = i;
            return true;
        }
    }

    return false;
}

bool isUartConfigValid (int baudRate,sUartConfig_t config) {

    int size = sizeof(baudRates) / sizeof(baudRates[0]);
    if(config.dataBits == 3 ||  config.dataBits == 2){

    }
    else{
        return false;
    }

    for (int i = 0; i < size; i++) {

        if (baudRates[i] == baudRate) {
            //isValid = true;
            return true;
        }
    }

    return false;
}

#define IOIN    0
#define IOOUT    1
#define IOCNT    2
#define IMMEDIATELY  1
#define PERIOD    2
void exclusive(uint8_t type,uint8_t io){


  if(type == IOIN){
       dtuConfig.loopOperation.ioCount[io-1].enable = 0;

      //dtuConfig.loopOperation.countMask = 0;
      dtuConfig.loopOperation.countMask = (dtuConfig.loopOperation.countMask) & (~(1<<(io-1)));
  }
  if(type == IOCNT){
          dtuConfig.loopOperation.ioIn[io-1].enable = 0;
          dtuConfig.loopOperation.ioMask = (dtuConfig.loopOperation.ioMask) & (~(1<<(io-1)));
  }

}
static tAtCmd doCmd[]={
{"JOINTYPE",doOtaa},  {"DEVEUI",doDeveui},  {"APPKEY",doAppkey},  {"DEVADDR",doDevaddr},  {"APPSKEY",doAppSkey},  {"NWKSKEY",doNwkSkey},
{"NETID",doNetID},  {"PORT",doPort},  {"JOIN",doJoin},  {"FREQS",doFreqs},  {"REGION",doRegion},  {"SUBBAND",doSubband},
{"ANTENNAGAIN",doAntennagain},  {"EIRP",doEirp},  {"DATARATE",doDatarate},  {"UPLINKTYPE",doUplinktype},  {"JOINEUI",doAppeui},  {"ADR",doADR},
{"TEXTTYPE",doText},  {"CLASS",doClass},  {"NBTRIALS",doNbtrials},  {"SEND",doSend},  {"RECV",doRecv},  {"POWERON",doSleep},
{"UARTBAUD",doBaud},  {"ATCHAN",doATChan},  {"MANUFACTURER",doManufacturer},  {"PRODUCT",doProduct},  {"SWVERSION",doSWVersion},  {"SN",doSN},
{"RECOVERY",doRecovery},  {"RS485ITEM",doRs485Item},  {"UPGRADE",doUpgrade},  {"REJOIN",doRejoin},  {"RS485SEND",doRs485send},
{"RS485NBTRIALS",doRs485Retry},  {"OUTPOWER",doOutpower},  {"ADC",doAdc},  {"IOOUT",doIoOut},{"UARTMODE",doUartMode},
{"IOIN",doIoIn},  {"LOSS",doLOSS},  {"PULSE",doPulse},  {"PRODUCTNAME",doPname},  {"PDATE",doPdata},  {"SERIESNUM",doSerialnum},
{"LOG",doLog},  {"SAVE",doSave},{"COORD",doCoord},  {"HWVERSION",doHwversion},  {"MD5",doMD5},  {"BATTERY",doBattery},
/*{"PASSWD",doPasswd}, */ {"LOOP",doLoop},{"SNR",doSnr},  {"NAME",doName},  {"RSSI",doRssi}, {"UARTPORT",doUartPort},
{"REBOOT",doReboot},{"IOCNT",doIocnt},{"MAC",doMacVersion},{"PID",doPid},{"VID",doVid},{"UNIXEPOCH",doUnixEpoch},{"CSV",doCSV},{"BC",doBC},{"UDISK",doUDISK},{"ADN", doADN},
};

void rs485TimeOut(){
    dfserials[4].dataFlag = 2;
}

void AtBegin() {
    //ioout1 ioout2 波形输出定时器
    TimerInit(&ioOut1Timer,ioOut1);
    TimerInit(&ioOut2Timer,ioOut2);
    TimerInit(&rs485TimeOutTimer,rs485TimeOut);
};

void IOinit(void){
  //ID初始化
  //GET_UNIQUE_ID(dtuConfig.hardPara.sn);

  //初始化供电引脚
  dtuConfig.loopOperation.power[0].pin = GPIO_Pin_3;
  dtuConfig.loopOperation.power[0].group = GPIOB;
  dtuConfig.loopOperation.power[1].pin = GPIO_Pin_6;
  dtuConfig.loopOperation.power[1].group = GPIOB;
 //初始化 ADC IO RS485引脚
  dtuConfig.loopOperation.adc[0].pin = GPIO_Pin_5;
  dtuConfig.loopOperation.adc[1].pin = GPIO_Pin_6;
  dtuConfig.loopOperation.adc[0].channel = 1;
  dtuConfig.loopOperation.adc[1].channel = 10;

  dtuConfig.loopOperation.ioCount[0].pin = GPIO_Pin_14;
  dtuConfig.loopOperation.ioCount[1].pin = GPIO_Pin_15;
  dtuConfig.loopOperation.ioCount[2].pin = GPIO_Pin_0;
  dtuConfig.loopOperation.ioCount[3].pin = GPIO_Pin_3;
  dtuConfig.loopOperation.io[0].pin =GPIO_Pin_15 ;
  dtuConfig.loopOperation.io[1].pin =GPIO_Pin_3 ;
  dtuConfig.loopOperation.ioIn[0].pin =GPIO_Pin_14 ;
  dtuConfig.loopOperation.ioIn[1].pin =GPIO_Pin_15 ;
  dtuConfig.loopOperation.ioIn[2].pin =GPIO_Pin_0 ;
  dtuConfig.loopOperation.ioIn[3].pin =GPIO_Pin_3 ;
  dtuConfig.loraWanPara.pid = 0x0001;
  dtuConfig.loraWanPara.vid = 0x0666;
  GPIOB_ModeCfg(GPIO_Pin_2, GPIO_ModeOut_PP_5mA);
  GPIOB_SetBits(GPIO_Pin_2);
  for(uint8_t i = 0;i<4;i++){
    if(dtuConfig.loopOperation.io[i].enable){
      GPIOB_ModeCfg(dtuConfig.loopOperation.io[i].pin, GPIO_ModeOut_PP_5mA);
      uint8_t value = dtuConfig.loopOperation.io[i].ioCmd[dtuConfig.loopOperation.io[i].cmdlen-2];
      if(value == 1){
        GPIOB_SetBits(dtuConfig.loopOperation.io[i].pin);
      }else if(value == 0){
        GPIOB_ResetBits(dtuConfig.loopOperation.io[i].pin);
      }
    }
  }
  //IOIN在断电后重新上电，如果使能了需要初始化
  //如果没有初始化，在中断里面查中断标志位会出错
  if(dtuConfig.loraWanPara.uartMode == 1){
      AT = 0;
  }else{
      AT = 1;
  }

  //printf("AT=%d\n",AT);
  for(uint8_t i = 0;i<4;i++){
      if(dtuConfig.loopOperation.ioIn[i].enable == 0x01) {
        GPIOB_ModeCfg(dtuConfig.loopOperation.ioIn[i].pin, GPIO_ModeIN_Floating);
        //printf("sadasd=%d\n",dtuConfig.loopOperation.ioIn[0].intType);
        if(dtuConfig.loopOperation.ioIn[i].intType == GPIO_ITMode_FallEdge || dtuConfig.loopOperation.ioIn[i].intType == GPIO_ITMode_RiseEdge){
            //printf("sadasd=%d\n",dtuConfig.loopOperation.ioIn[0].intType);
           GPIOB_ITModeCfg(dtuConfig.loopOperation.ioIn[i].pin,dtuConfig.loopOperation.ioIn[i].intType);
           PFIC_EnableIRQ(GPIO_B_IRQn);
        }
        if(dtuConfig.loopOperation.ioIn[i].intType == 4) {
            GPIOB_ITModeCfg(dtuConfig.loopOperation.ioIn[i].pin,GPIO_ITMode_RiseEdge);
            PFIC_EnableIRQ(GPIO_B_IRQn);
        }
      }
  }

  for(uint8_t i = 0;i<4;i++){
    if(dtuConfig.loopOperation.ioCount[i].enable == 0x01){
      GPIOB_ModeCfg(dtuConfig.loopOperation.ioCount[i].pin, GPIO_ModeIN_PD);
      GPIOB_ITModeCfg(dtuConfig.loopOperation.ioCount[i].pin,dtuConfig.loopOperation.ioCount[i].intType);
      PFIC_EnableIRQ(GPIO_B_IRQn);
    }
  }

  dtuConfig.loraWanPara.firstPacket = false;


  for(uint8_t i = 0;i<1;i++){
    uint8_t group = dtuConfig.loopOperation.power[i].group;
    uint32_t pin = dtuConfig.loopOperation.power[i].pin;

    if(dtuConfig.loopOperation.power[i].enable  && dtuConfig.loopOperation.power[i].supplyTime == 0){
      SETMODE(group,pin,GPIO_ModeOut_PP_5mA);
      SETHIGH(group,pin);
    }
  }

  for(uint8_t i = 0;i<2;i++){
    if(!dtuConfig.loopOperation.adc[i].enable){
      dtuConfig.loopOperation.adc[i].max =5000;
      dtuConfig.loopOperation.adc[i].max =0;
    }
  }
}

int roundToInt(float number) {
    return (int)(number + 0.5f);
}
void reverseString(char *str, int length) {
    for (int i = 0; i < length / 2; i++) {
        char temp = str[i];
        str[i] = str[length - i - 1];
        str[length - i - 1] = temp;
    }
}

BOOL doUDISK(void *param, pDFSerial s){
    s->print("+UDISK=OK\r\n");
    dtuConfig.hardPara.udiskMode = 1;
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    //NvmDataMgmtStore();
    NvmStoreDTUConfig();
    softReset();
}
void setEu868Channel(uint32_t frq,uint8_t id){
    dtuConfig.loraWanPara.frequency[id] = frq;
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
}

void setUpLinkCnt(uint32_t cnt){
    if(dtuConfig.loraWanPara.joinType == ACTIVATION_TYPE_ABP){
        dtuConfig.loraWanPara.frameCounter = cnt;
    }else{
        dtuConfig.loraWanPara.frameCounter = 0;

    }
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
}

void loadUpLinkCntAndEu8686Channel(){
  if(dtuConfig.loraWanPara.region == LORAMAC_REGION_EU868){

      if(dtuConfig.loraWanPara.joinType == ACTIVATION_TYPE_ABP){

          for(uint8_t i = 3;i<8;i++){
             recoverEu8686Channel(dtuConfig.loraWanPara.frequency[i-3], i);
          }
      }
    }

  if(dtuConfig.loraWanPara.joinType == ACTIVATION_TYPE_ABP){
     revoverUpLinkCnt(dtuConfig.loraWanPara.frameCounter);
  }
}

BOOL doBC(void *param, pDFSerial s){
    const char *p = (const char *)param;
    uint32_t index,len=0,value;

    static uint8_t buf[64],tmp8;
    if(strcmp(p, "?") == 0){
       s->print("+BC=");
       if(dfbc_valid()){
    	   uint32_t addr = 0;
    	   uint16_t len = 0;
    	   len = dfbc_meta(&addr);
    	   uint8_t *p = (uint8_t *)addr;
    	   for(int i = 0; i < len; i++){
    		   char buf[3]={0};
    		   sprintf(buf,"%02X",p[i]);
    		   s->print(buf);
    	   }
       }
       s->print("\r\n");
       return true;
    }

    if(p[0] == '=') p++;
    sscanf(p,"%4X",&index);

    printf("index=%04X\n",index);
    //printf("p=%s\n",p);
    DBG("p=%s\n",p);
    p += 4;
    DBG("p=%s\n",p);
    if(index == 0xffff){
        DBG("\n");
    	uint16_t calc_cs = 0, len;
        uint32_t cs=0;
    	sscanf(p,"%04X",&cs);
    	DBG("cs=%04X\n",cs);
    	uint8_t *p1 = DFBC_ADDR;
    	len = p1[0] + p1[1]*256;
    	DBG("len=%04X\n",len);
    	for(uint16_t i=0; i<len+4; i++){
    		calc_cs += p1[i];
    	}
    	DBG("calc_cs=%04X\n",calc_cs);
    	if(calc_cs == cs){
    		value = calc_cs + ('O' << 16) + ('K' << 24);
    		burn_dfbc_file(&value, 2048 - 4, 4);
    		//burn_dfbc_file("OK",len+2,2);
    		dfbc_init();
    		is_dfbc_valid = 1;
    		enable3V3();
    	}else{
    		if(!is_io_count){
    			disable3V3();
    		}
    	}
    	DBG("------%02X%02X%02X%02X\n", p1[len], p1[len+1], p1[len+2], p1[len+3]);
    	//dfbc_file_checksum();
    }else{
    	DBG("\n");
    	while(*p != '\0'){
    		sscanf(p,"%02X",&tmp8);
    		buf[len] = tmp8;
    		//printf("%2X",buf[len]);
    		len++;
    		p+=2;
    	}
    	for(int i=0; i<len;i++){
    		printf("%02X",buf[i]);
    	}
    	printf("\n");
    	burn_dfbc_file(buf,index,len);
    }
	DBG("\n");
    s->print("+BC=OK\r\n");
    return true;
}

BOOL doADN(void *param, pDFSerial s) {
    s->print("+ADN=OK\r\n");
    dtuConfig.cfgCnt++;
    dtuConfig.loopOperation.adnDisable = false;
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    return true;
}

BOOL doPid(void *param, pDFSerial s)
{

    const char *p = (const char *)param;
    if(strcmp(p, "?") == 0){
      sprintf(str, "+PID=%04X\r\n",dtuConfig.loraWanPara.pid);
       s->print(str);
      return true;
    }
    RtcInit( );
    //txtimeoutM = 1;
    s->print("+PID=FAIL\r\n");
    return false;

}
BOOL doVid(void *param, pDFSerial s)
{
    //txtimeoutM = 0;
    const char *p = (const char *)param;
    if(strcmp(p, "?") == 0){
      sprintf(str, "+VID=%04X\r\n",dtuConfig.loraWanPara.vid);
       s->print(str);
      return true;
    }
    s->print("+VID=FAIL\r\n");
    return false;

}

BOOL doUartPort(void *param, pDFSerial s){

    const char *p = (const char *)param;
    LoRaMacNvmData_t *nvm = GetNvmData();
    int port;
    int serialNum;
   // s->print(p);
    if(sscanf(p,"=%d,%d",&serialNum,&port) == 2){


    }else if(sscanf(p,"=%d?",&serialNum) == 1){
      uint8_t str1[100]={0};
      //tmp = inttoStr(dtuConfig.loraWanPara.uartPort);

      sprintf(str1,"+UARTPORT=%d,%d\r\n",serialNum,dtuConfig.loraWanPara.uartPort[serialNum]);
      s->print(str1);
      return true;
    }
    if((p[0] != '=') || (p[1] == '\0')){
      return false;
    }

    if(port > 0 && port < 255 && port != 224 && (port != dtuConfig.loraWanPara.port))
    {
        dtuConfig.loraWanPara.uartPort[serialNum] = port;
        sprintf(str,"+UARTPORT=%d,OK\r\n",serialNum);
        s->print(str);
        dtuConfig.cfgCnt++;
        NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);

        return true;
    }else{
        sprintf(str,"+UARTPORT=%d,FAIL\r\n",serialNum);
        s->print(str);
      return false;
    }
}
BOOL doUartMode(void *param, pDFSerial s){

    const char *p = (const char *)param;
    p++;
    uint32_t serialNum = strtoul(p, NULL, 10);
    p++;
    if(strcmp(p, "?") == 0){
        uint8_t str1[100]={0};
        //tmp = inttoStr(dtuConfig.loraWanPara.uartPort);
        if(dtuConfig.loraWanPara.uartMode == 0){
            sprintf(str,"+UARTMODE=%d,AT\r\n",serialNum);
        }else if(dtuConfig.loraWanPara.uartMode == 1){
            sprintf(str,"+UARTMODE=%d,TRANS\r\n",serialNum);
        }else{
            sprintf(str,"+UARTMODE=%d,NULL\r\n",serialNum);
        }
        s->print(str);
        return true;

    }

    p++;

    if(strncmp(p,"AT",2)==0){
        dtuConfig.loraWanPara.uartMode = 0;
        dtuConfig.loraWanPara.uartMode = 0;
        if(dtuConfig.hardPara.loopTime == 0){
            TimerSetValue( &hardwareLoopTimer, 60000);
            TimerStart( &hardwareLoopTimer );
        }
        sysLog("AT\n");
        printf("AT\n");
        dtuConfig.hardPara.loopTime = 60000;
    }else if(strncmp(p,"TRANS",5)==0){
        AT=0;
        dtuConfig.loraWanPara.uartMode = 1;
        dtuConfig.hardPara.loopTime = 0;
    }else{

    }

    sprintf(str,"+UARTMODE=%d,OK\r\n",serialNum);
    s->print(str);
    dtuConfig.cfgCnt++;
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    return true;


}
BOOL doMacVersion(void *param, pDFSerial s){

    const char *p = (const char *)param;
    if(strcmp(p, "?") == 0){
        dtuConfig.loraWanPara.macVersion[0] = 1;
        dtuConfig.loraWanPara.macVersion[1] = 0;
        dtuConfig.loraWanPara.macVersion[2] = 3;
        sprintf(str,"+MAC=V%d.%d.%d\r\n",dtuConfig.loraWanPara.macVersion[0],dtuConfig.loraWanPara.macVersion[1],dtuConfig.loraWanPara.macVersion[2]);

        s->print(str);
      return true;
    }
    s->print("+MAC=FAIL\r\n");
    return false;

    return true;
}
BOOL doPdata(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){
      sprintf(str,"+PDATE=%d,%d,%d\r\n",dtuConfig.hardPara.pdate[0]+dtuConfig.hardPara.pdate[1],dtuConfig.hardPara.pdate[2],dtuConfig.hardPara.pdate[3]);

        s->print(str);
      return true;
    }
    s->print("+PDATE=FAIL\r\n");
    return false;
}
BOOL doUnixEpoch(void *param, pDFSerial s){


    const char *p = (const char *)param;
    if(strcmp(p, "?") == 0){

          sprintf(str, "+UNIXEPOCH=%d\r\n", dtuConfig.hardPara.unixEpoch);
          s->print(str);

      return true;
    }
     if((p[0] != '=') || (p[1] == '\0')){
       return false;
      }
      p++;


     // char str[9]={0};
     // strncpy(str, p, 8);
      //str[8] = '\0';

      int unixEpoch = strtoul(p, NULL, 10);

      if(unixEpoch >= 0){
        dtuConfig.hardPara.unixEpoch = unixEpoch;
#ifdef UNIX_EPOCH_ENABLE
         TimerSetValue( &unixEpochTimer, 5000);
         TimerStart( &unixEpochTimer );
#endif
        //LoRaMacMibSetRequestConfirm( &mibReq );
         s->print("+UNIXEPOCH=OK\r\n");
      }else{
          s->print("+UNIXEPOCH=FAIL\r\n");


      }
      return true;

}
static int  startLine = 0;
static int  endLine = 0;

BOOL doCSV(void *param, pDFSerial s){

    const char *p = (const char *)param;
    tempSerial = s;

    if(strcmp(p, "?") == 0){
      sprintf(str,"+CSV=%d,%d\r\n",dtuConfig.hardPara.rowCsv,dtuConfig.hardPara.addr);
      s->print(str);
      return true;
    }



    if(sscanf(p,"=%d,%d\r\n",&startLine,&endLine) == 2){
       // s->print("time,AI1,AI2,DI1,DI2,DI3,DI4,RS485-1,RS485-2,RS485-3,RS485-4,RS485-5,RS485-6,RS485-7,RS485-8,uploaded\r\n");
    }else{
        sprintf(str,"+CSV=FAIL\r\n");
        s->print(str);
        return false;
    }


    return true;
}



BOOL doSerialnum(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){
   // sprintf(str,"+SERIESNUM=%2x%2x%2x%2x%2x%2x%2x%2x\r\n",dtuConfig.hardPara.seriesNum[0],dtuConfig.hardPara.seriesNum[1]
  //  ,dtuConfig.hardPara.seriesNum[2],dtuConfig.hardPara.seriesNum[3],dtuConfig.hardPara.seriesNum[4]
  //  ,dtuConfig.hardPara.seriesNum[5],dtuConfig.hardPara.seriesNum[6],dtuConfig.hardPara.seriesNum[7]
   //  );
    s->print(str);
    return true;
  }
  s->print("+SERIESNUM=FAIL\r\n");
  return false;
}
BOOL doPname(void *param, pDFSerial s){

    const char *p = (const char *)param;
    LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){
      //sprintf(str,"+SNR:%d\r\n",nvm->other.snr);
       // dtuConfig.hardPara.pname;
      s->print("+PRODUCTNAME=DF-LORA-RS485\r\n");
      return true;
    }
    s->print("+PRODUCTNAME=FAIL\r\n");
    return false;

}
BOOL doPulse(void *param, pDFSerial s){
    const char *p = (const char *)param;
    if(strncmp(p,"=IO1",4)==0){
        char *atTest = "AT+IOOUT=IO1,0,10,1,10,0,10";
        dfserials[2].dataFlag = 1;
        dfserials[2].datalength = strlen(atTest);
        strncpy(dfserials[2].recvBuffer,atTest,dfserials[2].datalength);
    }else if(strncmp(p, "=IO2",4)==0){
        char *atTest = "AT+IOOUT=IO2,0,10,1,10,0,10";
        dfserials[2].dataFlag = 1;
        dfserials[2].datalength = strlen(atTest);
        strncpy(dfserials[2].recvBuffer,atTest,dfserials[2].datalength);
    }else{
        s->print("+PULSE=FAIL\r\n");
        return false;
    }
    //strncpy(dfserials[2].recvBuffer,appData->Buffer,appData->BufferSize);
    s->print("+PULSE=OK\r\n");
    return true;
}
/*
BOOL doPasswd(void *param, pDFSerial s){

    const char *p = (const char *)param;
    LoRaMacNvmData_t *nvm = GetNvmData();
   // if((p[0] != '=') || (p[1] == '\0')){
    if((p[0] != '=') || (p[1] == '\0')){
      return false;
    }
    p++;

    uint8_t passwd_num[6];
    for(uint8_t i = 0;i<6;i++){
        passwd_num[i] = p[i];
    }
    //printf("plen=%d\n",strlen(p));
    if(strlen(p)==7){
      if(strncmp(p+6,"?",1)== 0){
          for (int i = 0; i < 6; i++) {
            if(passwd_num[i] != (dtuConfig.hardPara.passwd[i]))
            {
                s->print("+PASSWD=FAIL\r\n");
                return false;
            }
          }
        s->print("+PASSWD=OK\r\n");
        NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
        return true;
      }
    }
    //printf("plen=%d\n",strlen(p));
    if(strlen(p)==6){
        for(uint8_t i = 0;i<6;i++){
            if(p[i]>'9' ||  p[i]<'0'){
                s->print("+PASSWD=FAIL\r\n");
                return false;
            }else{
                dtuConfig.hardPara.passwd[i] = p[i];
            }
       }
      s->print("+PASSWD=OK\r\n");

    }else{
        s->print("+PASSWD=FAIL\r\n");
        return false;

    }
    return true;
}
*/
BOOL doSnr(void *param, pDFSerial s)
{

    const char *p = (const char *)param;
    //LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){

      if(dtuConfig.loraWanPara.joinState == 1 && dtuConfig.loraWanPara.firstPacket == true){

          sprintf(str,"+SNR=%d\r\n",dtuConfig.loraWanPara.snr);
      }else{
          sprintf(str,"+SNR=NULL\r\n");
      }
      s->print(str);
      return true;
    }
    s->print("+SNR=FAIL\r\n");
    return false;
}
BOOL doRssi(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    //LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){
        if(dtuConfig.loraWanPara.joinState == 1 && dtuConfig.loraWanPara.firstPacket == true){
        sprintf(str,"+RSSI=%d\r\n",dtuConfig.loraWanPara.rssi);
      }else{
        sprintf(str,"+RSSI=NULL\r\n");
      }
      s->print(str);
      return true;
    }
    s->print("+RSSI=FAIL\r\n");
    return false;

}
BOOL doLoop(void *param, pDFSerial s){
    const char *p = (const char *)param;
    LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){
      sprintf(str,"+LOOP=%u\r\n",dtuConfig.hardPara.loopTime);
      s->print(str);
    }
    if((p[0] != '=') || (p[1] == '\0')){
      return false;
    }
    p++;

    uint32_t loopTime = strtoul(p, NULL, 10);
    if(loopTime < 10000 && loopTime != 0){
        s->print("+LOOP=FAIL\r\n");
        return false;
    }
    if(loopTime != 0 && dtuConfig.hardPara.loopTime == 0){
        TimerSetValue( &hardwareLoopTimer, loopTime);
        TimerStart( &hardwareLoopTimer );
    }

    dtuConfig.hardPara.loopTime = loopTime;
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    s->print("+LOOP=OK\r\n");
    dtuConfig.cfgCnt++;
    sprintf(str,"AT+LOOP=%d\n",loopTime);
    //writeLog(str,getSysTime());
  return true;
}

BOOL doMD5(void *param, pDFSerial s){
    const char *p = (const char *)param;
    LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){
      sprintf(str,"+MD5=%s\r\n",gmd5);
      if(strlen(gmd5) == 0){
          sprintf(str,"+MD5=NULL\r\n");
      }
      s->print(str);
    }
    if((p[0] != '=') || (p[1] == '\0')){
      return false;
    }
    p++;
    if(strlen(p)==32){
      strncpy(gmd5,p,strlen(p));
      NvmmWrite(gmd5,33,1024+512+DF_BOOT_SIZE);
      s->print("+MD5=OK\r\n");
    }else{
      s->print("+MD5=FAIL\r\n");
    }
    return true;
}
BOOL doLog(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    #ifdef  FLASH_ROM_LOG
    LogBuffer* result = queryLog();
    #endif
    if(strcmp(p, "?") == 0){
        if(dtuConfig.logPrint == 1){
        //  sprintf(str,"+LOG=ON\r\n");
        }else if(dtuConfig.logPrint == 0){
         // sprintf(str,"+LOG=OFF\r\n");
        }
      // s->print(str);

        #ifdef  FLASH_ROM_LOG
        int index = (result->tail - 1 + LOG_BUFFER_SIZE) % LOG_BUFFER_SIZE;
        int printCount = result->count;
        memset(str,0,1024);
        for (int i = 0; i < printCount; i++) {
            sprintf(str+strlen(str),"%s",result->entries[index]);
            index = (index - 1 + LOG_BUFFER_SIZE) % LOG_BUFFER_SIZE;
        }
        sprintf(str+strlen(str),"\r\n");
        if(result->count == 0){
            sprintf(str,"+LOG=NULL\r\n");
        }
        s->print(str);
        if(result->count != 0){
          // s->print("--end--\n");
        }
       #else
        s->print("+LOG=NULL\n");
       #endif

       return true;
    }

    if((p[0] != '=') || (p[1] == '\0')){
       // s->print("+LOG=FAIL\r\n");
        return false;
    }
    p++;
    //strncpy(dtuConfig.hardPara.name,p,strlen(p));
    if(strcmp(p, "0") == 0){

        dtuConfig.logPrint =0;
    }else if(strcmp(p, "1") == 0){
        dtuConfig.logPrint = 1;
    }else if(strcmp(p, "NULL") == 0){
        resetLog();
    }else{
        s->print("+LOG=FAIL\r\n");
        return false;
    }
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);

    s->print("+LOG=OK\r\n");
    return true;

}
/*
uint16_t jionType: 1;
uint16_t devEui: 1;
uint16_t jionEui: 1;
uint16_t appKey: 1;
uint16_t devAddr: 1;
uint16_t appSKey: 1;
uint16_t nwkSkey: 1;
uint16_t region: 1;
uint16_t antenngain: 1;
uint16_t eirp: 1;
uint16_t nbtrials: 1;
uint16_t class: 1;
uint16_t adr: 1;
*/

void setDataRate(uint8_t dr){
    LoRaMacNvmData_t *nvm = GetNvmData();
   // MibRequestConfirm_t mibReq;
   // mibReq.Type = MIB_CHANNELS_DATARATE;
   // dtuConfig.loraWanPara.dataRate = dr;
   // mibReq.Param.ChannelsDatarate = dr;
    //LoRaMacMibSetRequestConfirm( &mibReq );
    nvm->MacGroup1.ChannelsDatarate =dr;
}
void syncConfig(){

    MibRequestConfirm_t mibReq;
    //入网类型同步
    LoRaMacStatus_t status;
    const char *tmp;
    uint8_t str1[100]={0};

    if(dtuConfig.saveMask.joinType == 1){
       mibReq.Type = MIB_NETWORK_ACTIVATION;
       if(dtuConfig.loraWanPara.joinType == ACTIVATION_TYPE_OTAA){
           //printf("ota1a\n");
           mibReq.Param.NetworkActivation = ACTIVATION_TYPE_NONE;
       }else{
           //printf("abp\n");
           mibReq.Param.NetworkActivation = dtuConfig.loraWanPara.joinType;
       }

       status = LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.joinType = 0 ;

       sprintf(str1,"[syns] jionType=%d,status=%d\n",mibReq.Param.NetworkActivation,status);
       //writeLog(str1,getSysTime());
    }
    //devEui
    if(dtuConfig.saveMask.devEui == 1){
       mibReq.Type = MIB_DEV_EUI;
       //memcpy(dtuConfig.loraWanPara.devEui,dtuConfig.hardPara.sn,8);
       mibReq.Param.DevEui = dtuConfig.loraWanPara.devEui;
       status = LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.devEui = 0;
       sprintf(str1,"[syns] devEui=%s,status=%d\n",arrtoStr(mibReq.Param.DevEui,8),status);
       //writeLog(str1,getSysTime());
    }

    //jionEui
    if(dtuConfig.saveMask.joinEui == 1){
       mibReq.Type = MIB_JOIN_EUI;
       mibReq.Param.JoinEui = dtuConfig.loraWanPara.joinEui;
       status = LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.joinEui = 0;
       sprintf(str1,"[syns] joinEui=%s,status=%d\n",arrtoStr(mibReq.Param.JoinEui,8),status);
       //writeLog(str1,getSysTime());
    }

    if(dtuConfig.saveMask.appKey == 1){
       mibReq.Type = MIB_NWK_KEY;
       mibReq.Param.AppKey = dtuConfig.loraWanPara.appKey;
       status = LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.appKey = 0;
       sprintf(str1,"[syns] appKey=%s,status=%d\n",arrtoStr(mibReq.Param.AppKey,16),status);
      // writeLog(str1,getSysTime());
    }
    if(dtuConfig.saveMask.devAddr == 1){
       mibReq.Type = MIB_DEV_ADDR;
       mibReq.Param.DevAddr = dtuConfig.loraWanPara.devAddr;
       status = LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.devAddr = 0;
       sprintf(str1,"[syns] devAddr=0x%08x,status=%d\n",mibReq.Param.DevAddr,status);
       //writeLog(str1,getSysTime());
    }

    if(dtuConfig.saveMask.appSKey == 1){
       mibReq.Type = MIB_APP_S_KEY;
       mibReq.Param.AppSKey = dtuConfig.loraWanPara.appSKey;
       status = LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.appSKey = 0;
       sprintf(str1,"[syns] appSKey=%s,status=%d\n",arrtoStr(mibReq.Param.AppSKey,16),status);
       //writeLog(str1,getSysTime());
    }

    if(dtuConfig.saveMask.nwkSkey == 1){
       mibReq.Type = MIB_S_NWK_S_INT_KEY;
       mibReq.Param.SNwkSIntKey = dtuConfig.loraWanPara.nwkSKey;
       status = LoRaMacMibSetRequestConfirm( &mibReq );


       mibReq.Type = MIB_NWK_S_ENC_KEY;
       mibReq.Param.NwkSEncKey = dtuConfig.loraWanPara.nwkSKey;
       status = LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.nwkSkey = 0;
       sprintf(str1,"[syns] nwkSkey=%s,status=%d\n",arrtoStr(mibReq.Param.NwkSEncKey,16),status);
       //writeLog(str1,getSysTime());
    }
    //通道掩码
    //mibReq.Type = MIB_CHANNELS_MASK;
    //mibReq.Param.ChannelsMask = dtuConfig.loraWanPara.channelsMask;
    //LoRaMacMibSetRequestConfirm( &mibReq );
    //速率
    if(dtuConfig.saveMask.dataRate== 1){
       mibReq.Type = MIB_CHANNELS_DATARATE;
       mibReq.Param.ChannelsDatarate = dtuConfig.loraWanPara.dataRate;
       status = LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.dataRate = 0;

    }
    if(dtuConfig.saveMask.antenngain == 1){
       mibReq.Type = MIB_ANTENNA_GAIN;
       uint8_t ant = dtuConfig.loraWanPara.antennGain;
       //printf(" ant=%d\n",ant);
       mibReq.Param.AntennaGain = dtuConfig.loraWanPara.antennGain;
       LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.antenngain = 0;
    }
    //发射功率同步
    if(dtuConfig.saveMask.eirp == 1){
       mibReq.Type = MIB_CHANNELS_TX_POWER;
      // (eirp - dtuConfig.loraWanPara.antennGain)/2;
       LoRaMacNvmData_t *nvm = GetNvmData();
       mibReq.Param.ChannelsTxPower = dtuConfig.loraWanPara.txpower;// (maxEirp - dtuConfig.loraWanPara.eirp-antennaGain)/2;

       status = LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.eirp = 0;


       mibReq.Type = MIB_CHANNELS_DEFAULT_TX_POWER;
       mibReq.Param.ChannelsDefaultTxPower = dtuConfig.loraWanPara.txpower;
       status = LoRaMacMibSetRequestConfirm( &mibReq );
       sprintf(str1,"[syns] ChannelsTxPower=%d,status=%d\n",mibReq.Param.ChannelsTxPower,status);
       //writeLog(str1,getSysTime());
    }
    //ADR同步
    if(dtuConfig.saveMask.adr == 1){
       mibReq.Type = MIB_ADR;
       mibReq.Param.AdrEnable = dtuConfig.loraWanPara.adr;
       status = LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.adr = 0;
       sprintf(str1,"[syns] adr=%d,status=%d\n",mibReq.Param.AdrEnable,status);
       //writeLog(str1,getSysTime());
    }

    //重传次数同步
    if(dtuConfig.saveMask.nbtrials == 1){
       mibReq.Type = MIB_CHANNELS_NB_TRANS;
       mibReq.Param.ChannelsNbTrans = dtuConfig.loraWanPara.nbtrials;
       status = LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.nbtrials = 0;
       sprintf(str1,"[syns] nbtrials=%d,status=%d\n",mibReq.Param.ChannelsNbTrans,status);
       //writeLog(str1,getSysTime());
    }

    //设备类
    if(dtuConfig.saveMask.class == 1){
       mibReq.Type = MIB_DEVICE_CLASS;
       mibReq.Param.Class = dtuConfig.loraWanPara.class;
       LoRaMacMibSetRequestConfirm( &mibReq );
       dtuConfig.saveMask.class = 0;
       sprintf(str1,"[syns] class=%d,status=%d\n",mibReq.Param.Class,status);
      // writeLog(str1,getSysTime());
    }

    if(dtuConfig.saveMask.recovery ==1 ){
        stopWdog();
        DelayMs(10);
        burn_dfbc_file("\0\0\0\0", 0, 0);
        EEPROM_ERASE(DF_BOOT_SIZE,  2*1024);
        DBG("recover\n");
        DelayMs(10);
        softReset();
    }
    dtuConfig.saveMask.region = 0;
    dtuConfig.saveMask.bit16 = 0;
}

BOOL doSave(const char *p, pDFSerial s){
    dtuConfig.saveConfig = 1;
    s->print("+SAVE=OK\r\n");
    return true;
}

BOOL doBattery(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    if(strcmp(p, "?") == 0){
        uint8_t battery = getBatteryLevel();
        sprintf(str, "+BATTERY=%d\r\n", battery);
        s->print(str);
        return true;
    }
    s->print("+BATTERY=FAIL\r\n");
  return false;
}

BOOL doName(void *param, pDFSerial s)
{

    const char *p = (const char *)param;
    if(strcmp(p, "?") == 0){
        sprintf(str,"+NAME=%s%\r\n",dtuConfig.hardPara.name);
        s->print(str);
        return true;
    }

    if((p[0] != '=') || (p[1] == '\0')){
        s->print("+NAME=FAIL\r\n");
      return false;
    }
    p++;
    if(strlen(p)>19){
        s->print("+NAME=FAIL\r\n");
        return false;
    }
    memset(dtuConfig.hardPara.name,0,20);
    strncpy(dtuConfig.hardPara.name,p,strlen(p));
    dtuConfig.cfgCnt++;
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    s->print("+NAME=OK\r\n");
    return true;
}

BOOL doRs485Retry(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    if(strcmp(p, "?") == 0){

        sprintf(str,"+RS485NBTRIALS=%d\r\n",dtuConfig.loopOperation.rs485Retry);
        s->print(str);
        return true;
    }

    if((p[0] != '=') || (p[1] == '\0')){
        s->print("+RS485NBTRIALS=FAIL\r\n");
      return false;
    }
    p++;
    int16_t  retry = strtoul(p, NULL, 10);

    if(retry > 3 || retry<0) {
        s->print("+RS485NBTRIALS=FAIL\r\n");
        return false;
    }else{
      dtuConfig.loopOperation.rs485Retry = retry;
      s->print("+RS485NBTRIALS=OK\r\n");
      dtuConfig.cfgCnt++;
      NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
      return true;
    }
}

BOOL doHwversion(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    if(strcmp(p, "?") == 0){
        dtuConfig.hardPara.hwVersion[9] = 0;
        dtuConfig.hardPara.hwVersion[0] = 'V';
        dtuConfig.hardPara.hwVersion[1] = '0';
        dtuConfig.hardPara.hwVersion[2] = '.';
        dtuConfig.hardPara.hwVersion[3] = '0';
        dtuConfig.hardPara.hwVersion[4] = '.';
        dtuConfig.hardPara.hwVersion[5] = '2';
        sprintf(str,"+HWVERSION=%s\r\n",dtuConfig.hardPara.hwVersion);
       s->print(str);
       return true;
    }
    s->print("+HWVERSION=FAIL\r\n");
    return false;
   // if((p[0] != '=') || (p[1] == '\0')){
     // return false;
    //}
    //p++;
   // strncpy(dtuConfig.hardPara.hwVersion,p,strlen(p));
   // NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    //s->print("+HWVERSION:OK\r\n");
}

int parse_rs485_item(char *cmd_str, sRs485Control_t *control, pDFSerial s,uint8_t number) {
    char *token;
    int count = 1;
    //4800、9600、14400、19200、38400、115200

    int baud_rate;
    int data_bits;
    int stop_bits;
    uint8_t dataBits;
    uint8_t stopBits;
    uint8_t parityEn;
    uint8_t parity = 0;
    char p1[10]={0};
    char p2[10]={0};
    char am[5]={0};
    char usf[10]={0};
    DBG("cmd---->%s\n",cmd_str);
    // Split string into tokens using comma delimiter
    token = strtok(cmd_str, ",");

    while (token != NULL) {
        count++;
        switch (count) {
            case 1:  // Ignore first token
                break;

            case 2:  //
                //printf("baud=%s\n",token);
                  baud_rate = atoi(token);

                  dtuConfig.loopOperation.rs485Baud[number] = baud_rate;
                  //dtuConfig.loopOperation.rs485Config[number].value =config.value;
                  //NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);


                break;
            case 3:  //
                //printf("baud=%s\n",token);
                if(sscanf(token, "%dN%d",&data_bits, &stop_bits) == 2){
                   // printf("baud1=%s\n",token);
                    dataBits = data_bits;
                    stopBits = stop_bits;
                    parityEn = 0;
                    parity = 0;
                }else if(sscanf(token, "%dO%d",&data_bits, &stop_bits) == 2){
                    dataBits = data_bits;
                    stopBits = stop_bits;
                    parityEn = 1;
                    parity = 0;
                   // printf("baud2=%s\n",token);
                }else if(sscanf(token, "%dE%d",&data_bits, &stop_bits) == 2){
                    dataBits = data_bits;
                    stopBits = stop_bits;
                    parityEn = 1;
                    parity = 1;
                  //  printf("baud3=%s\n",token);
                }else if(sscanf(token, "%dM%d" ,&data_bits, &stop_bits) == 2){
                    dataBits = data_bits;
                    stopBits = stop_bits;

                    parityEn = 1;
                    parity = 2;
                  //  printf("baud4=%s\n",token);
                }else if(sscanf(token, "%dS%d",&data_bits, &stop_bits) == 2){
                    dataBits = data_bits;
                    stopBits = stop_bits;
                   // printf("baud5=%s\n",token);
                    parityEn = 1;
                    parity = 3;
                }
                sUartConfig_t config ;
                config.value = 0;
                config.dataBits = dataBits-5 ;
                config.stopBits = stopBits-1;
                config.parityEn = parityEn;
                config.parity = parity;
                dtuConfig.loopOperation.rs485Config[number].value =config.value;
                sprintf(str,"uconfig=%d\n",config.value);
                sysLog(str);
                break;
            case 4:  //
                control->len = strlen(token) ;

                //sprintf(str,"strlen=%d \n", control->len);
                //s->print(str);
               // s->print(token);
                for (uint8_t i = 0; i < control->len; i += 2) {
                    unsigned int hex = 0;
                    sscanf(&token[i], "%2x", &hex);


                    control->item[(i)/2] = hex;
                    //s->print(str);
                }
                control->len = control->len/2;
                //strncpy(control->item,str,control->len);
                //sprintf(str,"d=%d\n", control->item[5]);
                // s->print(str);
                // s->print(control->item);
                break;
            case 5:  // Third token is the next delay
                //s->print(token);
                control->nextDelay = atoi(token);
                if(atoi(token)>3000)  control->nextDelay = 3000;
               // sprintf(str,"d=%d\n", control->nextDelay);
                // s->print(str);
                break;
            case 6:  // Sixth token is the byte order

               // if (strlen(token) == 2) {
                   // if (token[0] == 'A') {
                   //     control->byteOrder = 1;
                   // } else if (token[0] == 'B') {
                      //  control->byteOrder = 2;
                   // }
              //  }
               // s->print("TOKE:");
                //s->print(token);
                if(strncmp(token,"AB",2)==0){
                    control->byteOrder = 1;
                }else if(strncmp(token,"BA",2)==0){
                    control->byteOrder = 2;
                }

                if(strncmp(token,"ABCD",4)==0){
                    control->byteOrder = 3;
                }else if(strncmp(token,"DCBA",4)==0){
                    control->byteOrder = 4;
                }

                break;
            case 7:  // 第七个参数是
                if(strncmp(token,"U",1)==0){
                    strcpy(usf,"U");
                }else if(strncmp(token,"S",1)==0){
                	strcpy(usf,"S");
                }else if(strncmp(token,"F",1)==0){
                	strcpy(usf,"F");
                }
                control->dataType = token[0];

                DBG("token7=%s\n",token);
                break;
            case 8:  // p1
            	strcpy(control->param1_str,token);
            	control->param1 = strtof(control->param1_str, NULL);
                DBG("token8=%s\n",token);
                break;
            case 9:  // p2
            	strcpy(control->param2_str,token);
            	control->param2 = strtof(control->param2_str, NULL);
            	DBG("token9=%s\n",token);
                break;
            case 10:
            	control->am = token[0];
                DBG("token10=%s\n",token);
                break;
            default:
                break;
        }

        token = strtok(NULL, ",");
    }
    return count;
}

BOOL doRs485Item(void *param, pDFSerial s) {
    const char *p = (const char *)param;
    DBG("param--------->%s\n",p);
    if( *p != '=' ){
    	DBG("\n");
    	if(s)
    		s->print("+NOCOMMAND\r\n");
        return false;
    }

    char* rs485 = strchr(p, '=');  // 查找等号的位置
    if (rs485 == NULL) {
    	DBG("\n");
        s->print("+NOCOMMAND\r\n");
        return false;  // 没有找到等号，返回错误代码
    }
    int number = 0;
    rs485++;

    char temp[20];
    int index = 0;
    while(rs485[index] != ',' && rs485[index] != '?' && rs485[index] != 0) {
        index++;
    }
    memcpy(temp, rs485, index);
    temp[index] = '\0';
    number = atoi(temp);
    DBG("number=%d\n", number);
    modbus_channel = number;
    uint8_t oddEven = dtuConfig.loopOperation.rs485Config[number].parityEn;
    uint8_t par = dtuConfig.loopOperation.rs485Config[number].parity;
    char odd ;
    if(oddEven == 0){
        odd ='N';
    }else{
        if(par == 0){
            odd ='O';
        }else if(par == 1){
            odd ='E';
        }else if(par == 2){
            odd ='M';
        }else if(par == 3){
            odd ='S';
        }
    }
    DBG("oddEven=%d odd=%c\n", oddEven, odd);
    if ( number > 8) {
        return false;  // 数字超出合法范围，返回错误代码
    }
    p+=2;
    DBG("p=%s\n", p);
    if(p == NULL) return false;
    if(*p == '?'){
        // s->print("25\r\n");
        //DelayMs(100);
        if(dtuConfig.loopOperation.rs485item[number].enable == 1){
            char  temp[56]={0};
            memset(str,0,256);
            arrtoStr(dtuConfig.loopOperation.rs485item[number].item, dtuConfig.loopOperation.rs485item[number].len);
            memcpy(temp,str,dtuConfig.loopOperation.rs485item[number].len*2);
            //temp[dtuConfig.loopOperation.rs485item[number].len*2] == 0;
            char byteOder[10];
            if(dtuConfig.loopOperation.rs485item[number].byteOrder==1) {
                sprintf(byteOder,"AB");
            } else if(dtuConfig.loopOperation.rs485item[number].byteOrder==2) {
                sprintf(byteOder,"BA");
            } else if(dtuConfig.loopOperation.rs485item[number].byteOrder==3) {
                sprintf(byteOder,"ABCD");
            } else if(dtuConfig.loopOperation.rs485item[number].byteOrder==4) {
                sprintf(byteOder,"DCBA");
            }
#ifdef NEW_RS485
            sprintf(str,"+RS485ITEM=%d,%d,%d%c%d,%s,%d,%s,%c,%s,%s,%c\r\n",number,dtuConfig.loopOperation.rs485Baud[number],dtuConfig.loopOperation.rs485Config[number].dataBits+5, odd, dtuConfig.loopOperation.rs485Config[number].stopBits+1,
            		temp,
					dtuConfig.loopOperation.rs485item[number].nextDelay,
            		byteOder,
					dtuConfig.loopOperation.rs485item[number].dataType,
					dtuConfig.loopOperation.rs485item[number].param1_str,
					dtuConfig.loopOperation.rs485item[number].param2_str,
					dtuConfig.loopOperation.rs485item[number].am
					);
#else
            sprintf(str,"+RS485ITEM=%d,%d,%d%c%d,%s,%d,%s\r\n",number,dtuConfig.loopOperation.rs485Baud[number],dtuConfig.loopOperation.rs485Config[number].dataBits+5, odd, dtuConfig.loopOperation.rs485Config[number].stopBits+1, temp, dtuConfig.loopOperation.rs485item[number].nextDelay, byteOder);
#endif

        }else{
            sprintf(str,"+RS485ITEM=%d,NULL\r\n",number);
        }
        if(s)
        	s->print(str);
        return true;
    } /*end if(*p == '?')*/
    DBG("p=%s\n", p);
    if(p == NULL) return false;
    if(strncmp(p, ",NULL",5) == 0){    DBG("p=%s\n", p);
        dtuConfig.loopOperation.rs485item[number].enable = 0;
        dtuConfig.loopOperation.rs485Mask = (dtuConfig.loopOperation.rs485Mask) &(~(1<<number));
        sprintf(str,"+RS485ITEM=%d,OK\r\n",number);
        NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
        if(s)
        	s->print(str);
        //s->print("deletok\r\n");
        return true;
    }else if(strncmp(p, ",TEST",5) == 0){
    	if(dtuConfig.loopOperation.rs485item[number].enable == 1){
    		float value;
    		uint8_t rawdata[20], rawdatalen;
    		if(execModbusItem(number, rawdata, &rawdatalen, &value) == 0){
                int8_t buf[40]={0};
                for(int k = 0; k < rawdatalen; k++){
                	sprintf(buf + k*2,"%02X",rawdata[k]);
                }
                sprintf(str,"+RS485ITEM=%d,%s\r\n",number,buf);
                if(s)
                	s->print(str);
    		}else{
              sprintf(str,"+RS485ITEM=%d,FAIL\r\n",number);
              if(s)
            	  s->print(str);
    		}
            return true;
    	}
        /*tempSerial = s;
        if(dtuConfig.loopOperation.rs485item[number].enable == 1){
            //printf("value=%d\n",dtuConfig.loopOperation.rs485Config[number].value);
            GPIOA_ModeCfg(GPIO_Pin_3, GPIO_ModeOut_PP_5mA);
            GPIOA_SetBits(GPIO_Pin_3);
            uart0Iint( dtuConfig.loopOperation.rs485Baud[number],dtuConfig.loopOperation.rs485Config[number].value);
            rs485Flush();
            DelayMs(10);
            UART0_SendString(dtuConfig.loopOperation.rs485item[number].item, dtuConfig.loopOperation.rs485item[number].len);

            char  temp[56]={0};
            memset(str,0,256);
            arrtoStr(dtuConfig.loopOperation.rs485item[number].item,dtuConfig.loopOperation.rs485item[number].len);
            memcpy(temp,str,dtuConfig.loopOperation.rs485item[number].len*2);
            DBG("sending.... %s\n",temp);
            TimerSetValue( &rs485TimeOutTimer, 5000);
            TimerStart( &rs485TimeOutTimer );

            return true;
        }else{
            sprintf(str,"+RS485ITEM=%d,FAIL\r\n",number);
            s->print(str);
            return false;
        }*/
    }

    if(p == NULL) return false;
    if(parse_rs485_item(p,&dtuConfig.loopOperation.rs485item[number],s,number)==0){
        sprintf(str,"+RS485ITEM=%d,FAIL\r\n",number);
        if(s)
        	s->print(str);
        return false;
    } else {
        if(isUartConfigValid (dtuConfig.loopOperation.rs485Baud[number],dtuConfig.loopOperation.rs485Config[number])){
            dtuConfig.loopOperation.rs485item[number].enable = 1;
            dtuConfig.loopOperation.rs485Mask = (dtuConfig.loopOperation.rs485Mask) |(1<<number);
            sprintf(str,"+RS485ITEM=%d,OK\r\n",number);

            NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
        } else {
            sprintf(str,"+RS485ITEM=%d,FAIL\r\n",number);
        }
        if(s)
        	s->print(str);
        return true;
    }

    return true;
}

bool isNumeric(const char *str) {
    char *endptr;
    strtod(str, &endptr);
    if (endptr == str)
        return false;

    while (*endptr != '\0') {
        if (!isspace(*endptr))
            return false;
        endptr++;
    }

    return true;
}

BOOL parseNumbers(const char *str, float *num1, float *num2, int16_t *num3) {
    char *endptr;

    // 解析第一个浮点数
    *num1 = strtof(str, &endptr);
    if (*endptr != ',' || endptr == str) {
        return false;
    }
    str = endptr + 1;

    // 解析第二个浮点数
    *num2 = strtof(str, &endptr);
    if (*endptr != ',' || endptr == str) {
        return false;
    }
    str = endptr + 1;

    // 解析整数
    *num3 = (int16_t) strtol(str, &endptr, 10);
    if (*endptr != '\0' || endptr == str) {
        return false;
    }

    return true;
}
BOOL doCoord(void *param, pDFSerial s){


    const char *p = (const char *)param;
    if(strcmp(p, "?") == 0){
      //  BOOL isEast = dtuConfig.loopOperation.coord.longitude >= 0;
        //BOOL isNorth = dtuConfig.loopOperation.coord.latitude >= 0;
        // 经度部分
        char floatValue1[10];
        char floatValue2[10];
        floatToString(dtuConfig.loopOperation.coord.longitude,floatValue1,2);
        //sprintf(str, "%s%c,",floatValue,dtuConfig.loopOperation.coord.isEast );
        floatToString(dtuConfig.loopOperation.coord.latitude,floatValue2,2);
        // 纬度部分
        //sprintf(str + strlen(str), "%s%c,",floatValue,dtuConfig.loopOperation.coord.isNorth );
        // 海拔部分
        sprintf(str , "+COORD=%s,%s,%d\r\n", floatValue1,floatValue2,dtuConfig.loopOperation.coord.altitude);
        s->print(str);
        return true;
    }
     sCoordinates_t *coords = &dtuConfig.loopOperation.coord;



     if((p[0] != '=') || (p[1] == '\0')){
         s->print("+COORD=FAIL\r\n");
         return false;
     }
     p++;

     float num1;
     float num2;
     int16_t num3;

     if(parseNumbers(p,&num1,&num2,&num3)){
       coords->longitude = num1;
       coords->latitude = num2;
       coords->altitude = num3;
       dtuConfig.cfgCnt++;
       s->print("+COORD=OK\r\n");
     }else{
         s->print("+COORD=FAIL\r\n");
         return false;
     }

     NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
     return true;


}

int parseIOData(char *str, uint16_t *buffer) {
    int len = strlen(str);
    int count = 0;
    char* token = strtok(str, ",");
    while (token != NULL && count < len) {
        buffer[count] = atoi(token);
        count++;
        token = strtok(NULL, ",");
    }
    return count;
}
int mapVoltageToRange(float voltage,int minValue,int maxValue) {
    float minVoltage = 0.0; // 输入电压的最小值
    float maxVoltage = 2.5; // 输入电压的最大值
    // 计算电压在给定范围内的比例
    float voltageRatio = (voltage - minVoltage) / (maxVoltage - minVoltage);

    // 计算映射后的值
    int mappedValue = minValue + (int)(voltageRatio * (maxValue - minValue));

    // 确保映射后的值在指定范围内
    if (mappedValue < minValue) {
        mappedValue = minValue;
    } else if (mappedValue > maxValue) {
        mappedValue = maxValue;
    }

    return mappedValue;
}

uint16_t readADC(uint8_t ch,uint32_t gpio,int16_t min,int16_t max){

    /* 单通道采样：选择adc通道0做采样，对应 PA4引脚， 带数据校准功能 */
    signed short RoughCalib_Value = 0;

    //PRINT("\n2.Single channel sampling...\n");
    GPIOA_ModeCfg(gpio, GPIO_ModeIN_Floating);
    ADC_ExtSingleChSampInit(SampleFreq_3_2, ADC_PGA_1_2);

    RoughCalib_Value = ADC_DataCalib_Rough(); // 用于计算ADC内部偏差，记录到全局变量 RoughCalib_Value中
    //PRINT("RoughCalib_Value =%d \n", RoughCalib_Value);
    //if(RoughCalib_Value <= 0)RoughCalib_Value=0;
    ADC_ChannelCfg(ch);
    //uint16_t adcBuff[10];



    float data = ADC_ExcutSingleConver()+RoughCalib_Value;
    data = (data/1024-1)*(1.05);


    char floatValue[10];
    floatToString(data,floatValue,3);

    uint16_t adc = mapVoltageToRange(data,min,max);

    return adc;

}

void ioOut1(void){

 TimerStop( &ioOut1Timer );
 if(io1CmdIndex >= dtuConfig.loopOperation.io[0].cmdlen){
     TimerStop( &ioOut1Timer );
     return;
 }
 if(dtuConfig.loopOperation.io[0].ioCmd[io1CmdIndex] == 1){
     GPIOB_SetBits(dtuConfig.loopOperation.io[0].pin);
 }else if(dtuConfig.loopOperation.io[0].ioCmd[io1CmdIndex] == 0){
     GPIOB_ResetBits(dtuConfig.loopOperation.io[0].pin);
 }
 int16_t  delay = dtuConfig.loopOperation.io[0].ioCmd[io1CmdIndex+1];
 //printf("delay=%d\n",delay);
 TimerSetValue( &ioOut1Timer, delay);
 TimerStart( &ioOut1Timer );
 io1CmdIndex += 2;
}
void ioOut2(void){

  TimerStop( &ioOut2Timer );
 if(io2CmdIndex >= dtuConfig.loopOperation.io[1].cmdlen){
     TimerStop( &ioOut2Timer );
     return;
  }
 if(dtuConfig.loopOperation.io[1].ioCmd[io2CmdIndex] == 1){
    GPIOB_SetBits(dtuConfig.loopOperation.io[1].pin);
 }else if(dtuConfig.loopOperation.io[1].ioCmd[io2CmdIndex] == 0){
    GPIOB_ResetBits(dtuConfig.loopOperation.io[1].pin);
 }

 int16_t  delay = dtuConfig.loopOperation.io[1].ioCmd[io2CmdIndex+1];
 //printf("delay2=%d\n",delay);
 TimerStop( &ioOut2Timer );
 TimerSetValue( &ioOut2Timer, delay);
 TimerStart( &ioOut2Timer );
 io2CmdIndex += 2;
}
/*
BOOL doIoOut(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    int channel = 0;
    if(sscanf(p,"=%d",&channel) == 1){
        //printf("channel=%d\n",channel);
         channel--;
    }else{
        sprintf(str,"+IOOUT=FAIL\r\n");
        s->print(str);
        return false;
    }


    if(strncmp(p, "=1?",3) == 0 ||strncmp(p, "=2?",3) == 0||strncmp(p, "=3?",3) == 0||strncmp(p, "=4?",3) == 0){
      if(dtuConfig.loopOperation.io[channel].enable ==1){
          uint8_t len = dtuConfig.loopOperation.io[channel].cmdlen;
          uint16_t *iocmd = dtuConfig.loopOperation.io[channel].ioCmd;
          uint8_t i;
          for(i=0;i<len;i+=2){
              if(i==0){
                 sprintf(str,"+IOOUT=%d,%d,%d,",channel+1,iocmd[i],iocmd[i+1]);
              }else{
                 sprintf(str + strlen(str),"%d,%d,",iocmd[i],iocmd[i+1]);
              }
          }
          str[strlen(str)-1] = '\r';
          str[strlen(str)] = '\n';
      }else{

          sprintf(str,"+IOOUT=%d,D\r\n",channel+1);
      }

      s->print(str);
      memset(str,0,255);
      return false;
    }

    if((p[0] != '=') || (p[1] == '\0')){
        s->print("+IOOUT1=FAIL\r\n");
        return false;
    }
    p+=3;
    if(strncmp(p, "D",1) == 0){
        dtuConfig.loopOperation.io[channel].enable = 0;
        dtuConfig.loopOperation.ioMask = (dtuConfig.loopOperation.ioMask) & (~(1<<(4+channel)));
        sprintf(str,"+IOOUT=%d,OK\r\n",channel+1);
        s->print(str);
        NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
        return true;
    }
    int cmdLen = parseIOData(p,dtuConfig.loopOperation.io[channel].ioCmd);
    if(cmdLen > 1){
        dtuConfig.loopOperation.io[channel].cmdlen= cmdLen;
        dtuConfig.loopOperation.io[channel].enable = 1;
        dtuConfig.loopOperation.ioMask = (dtuConfig.loopOperation.ioMask) | ((1)<<(4+channel));
        sprintf(str,"+IOOUT=%d,OK\r\n",channel+1);
        s->print(str);
        GPIOB_ModeCfg(dtuConfig.loopOperation.ioIn[channel].pin, GPIO_ModeIN_Floating);
        GPIOB_ModeCfg(dtuConfig.loopOperation.io[channel].pin, GPIO_ModeOut_PP_5mA);
        if(channel == 0){
        //使用定时器开始执行out序列
            io1CmdIndex = 0;
            ioOut1();
        }else if(channel == 1) {
            io2CmdIndex = 0;
            ioOut2();
        }else if(channel == 2) {
            io2CmdIndex = 0;
           // ioOut2();
        }else if(channel == 3) {
            io2CmdIndex = 0;
            //ioOut2();
        }
    }else{

        sprintf(str,"+IOOUT=%d,FAIL\r\n",channel+1);
        s->print(str);
    }


    if(dtuConfig.loopOperation.io[channel].enable == 1){

        exclusive(IOOUT,channel+1);
    }
    dtuConfig.cfgCnt++;
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    return true;
}
*/

BOOL doIoOut(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    int channel = 0;
    int ret = sscanf(p,"=%d",&channel);
    if(ret == 1){
         channel--;
    }

    if((channel != 0) || (ret != 1)){
        sprintf(str,"+IOOUT=FAIL\r\n");
        s->print(str);
        return false;
    }
    p += 2;
    if(*p == '?'){
    	if(dtuConfig.loopOperation.io[0].enable){
    		uint8_t v = GPIOB_ReadPortPin(GPIO_Pin_0);
    		sprintf(str, "+IOOUT=1,%d\r\n", v);
    		s->print(str);
    	} else {
    		s->print("+IOOUT=1,D\r\n");
    	}
    	return true;
    }else if(*p == ','){
    	p++;
    }else{
        sprintf(str,"+IOOUT=FAIL\r\n");
        s->print(str);
        return false;
    }

    if((*p == '1') || (*p == '0')){
    	uint8_t v = *p - '0';
    	dtuConfig.loopOperation.io[0].enable = 1;
    	NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    	DBG("digitalWrite %d\n", v);
    	GPIOB_ModeCfg(GPIO_Pin_0, GPIO_ModeOut_PP_5mA);
    	if(v) GPIOB_SetBits(GPIO_Pin_0);
    	else  GPIOB_ResetBits(GPIO_Pin_0);
    	s->print("+IOOUT=OK\r\n");
    }else if(*p == 'D'){
    	s->print("+IOOUT=OK\r\n");
    	dtuConfig.loopOperation.io[0].enable = 0;
    	GPIOB_ModeCfg(GPIO_Pin_0, GPIO_ModeIN_PD);
    	NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    }

    return true;
}


BOOL doIoOut2(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    if(strncmp(p, "?",1) == 0){
      if(dtuConfig.loopOperation.io[1].enable ==1){
          uint8_t len = dtuConfig.loopOperation.io[1].cmdlen;
          uint16_t *iocmd = dtuConfig.loopOperation.io[1].ioCmd;
          uint8_t i;
          for(i=0;i<len;i+=2){
              if(i==0){
                 sprintf(str,"+IOOUT2=%d,%d,",iocmd[i],iocmd[i+1]);
              }else{
                 sprintf(str + strlen(str),"%d,%d,",iocmd[i],iocmd[i+1]);
              }
          }
          str[strlen(str)-1] = 0;

      }else{

          sprintf(str,"+IOOUT2=D\r\n");
      }

      s->print(str);
      memset(str,0,255);
      return false;
    }

    if((p[0] != '=') || (p[1] == '\0')){
        s->print("+IOOUT2=FAIL\r\n");
        return false;
    }
    p++;
    if(strncmp(p, "D",1) == 0){
        dtuConfig.loopOperation.io[1].enable = 0;
        dtuConfig.loopOperation.ioMask = (dtuConfig.loopOperation.ioMask) & (~(0x02<<4));
        s->print("+IOOUT2=OK\r\n");
        NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
        return true;
    }
    int cmdLen = parseIOData(p,dtuConfig.loopOperation.io[1].ioCmd);
    if(cmdLen > 1){
        dtuConfig.loopOperation.io[1].cmdlen= cmdLen;
        dtuConfig.loopOperation.io[1].enable = 1;
        dtuConfig.loopOperation.ioMask = (dtuConfig.loopOperation.ioMask) | (0x02<<4);
        s->print("+IOOUT2=OK\r\n");
        GPIOA_ModeCfg(dtuConfig.loopOperation.ioIn[1].pin, GPIO_ModeIN_Floating);
        GPIOB_ModeCfg(dtuConfig.loopOperation.io[1].pin, GPIO_ModeOut_PP_5mA);
        //使用定时器开始执行out序列
        io2CmdIndex = 0;
        ioOut2();
    }else{
        s->print("+IOOUT2=FAIL\r\n");
    }
    if(dtuConfig.loopOperation.io[1].enable == 1){

        exclusive(IOOUT,2);
    }
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    return true;

}
uint8_t reverseIntDetect(uint8_t number){
    if(dtuConfig.loopOperation.ioIn[number].intType == 4 ){
        PFIC_DisableIRQ(GPIO_B_IRQn);
        GPIOB_ModeCfg(dtuConfig.loopOperation.ioIn[number].pin, GPIO_ModeIN_Floating);
       if(dtuConfig.loopOperation.ioIn[number].mode == GPIO_ITMode_RiseEdge){

           dtuConfig.loopOperation.ioIn[number].mode = GPIO_ITMode_FallEdge;
           GPIOB_ITModeCfg(dtuConfig.loopOperation.ioIn[number].pin,GPIO_ITMode_FallEdge);
           PFIC_EnableIRQ(GPIO_B_IRQn);
       }else if(dtuConfig.loopOperation.ioIn[number].mode == GPIO_ITMode_FallEdge){
            dtuConfig.loopOperation.ioIn[number].mode = GPIO_ITMode_RiseEdge;
           GPIOB_ITModeCfg(dtuConfig.loopOperation.ioIn[number].pin,GPIO_ITMode_RiseEdge);
           PFIC_EnableIRQ(GPIO_B_IRQn);
       }

    }
    if( dtuConfig.loopOperation.ioCount[number].intTyp == 4){
       if(dtuConfig.loopOperation.ioCount[number].intType == GPIO_ITMode_RiseEdge){

           dtuConfig.loopOperation.ioCount[number].intType = GPIO_ITMode_FallEdge;
           GPIOB_ITModeCfg(dtuConfig.loopOperation.ioCount[number].pin,GPIO_ITMode_FallEdge);
           PFIC_EnableIRQ(GPIO_B_IRQn);
       }else if(dtuConfig.loopOperation.ioCount[number].intType == GPIO_ITMode_FallEdge){
            dtuConfig.loopOperation.ioCount[number].intType = GPIO_ITMode_RiseEdge;
           GPIOB_ITModeCfg(dtuConfig.loopOperation.ioCount[number].pin,GPIO_ITMode_RiseEdge);
           PFIC_EnableIRQ(GPIO_B_IRQn);
       }


    }
}


BOOL doIoIn(void *param, pDFSerial s){
    const char *p = (const char *)param;

    int channel = 0;
    if(sscanf(p,"=%d",&channel) == 1){
        //printf("channel=%d\n",channel);
         channel--;

    }else{
        sprintf(str,"+IOIN=FAIL\r\n");
        s->print(str);
        return false;
    }


    if(strncmp(p, "=1?",3) == 0 || strncmp(p, "=2?",3) == 0|| strncmp(p, "=3?",3) == 0|| strncmp(p, "=4?",3) == 0){
    	enable3V3();
    	DelayMs(50);
        if(dtuConfig.loopOperation.ioIn[channel].enable ==1 ){
            if(GPIOB_ReadPortPin(dtuConfig.loopOperation.ioIn[channel].pin) !=0){
                dtuConfig.loopOperation.ioIn[channel].pinValue = 0;
            }else{
                dtuConfig.loopOperation.ioIn[channel].pinValue = 1;
            }
            uint8_t intType = dtuConfig.loopOperation.ioIn[channel].intType;
            if(intType== 0){
                sprintf(str,"+IOIN=%d,FLOATING,%d\r\n",channel+1,dtuConfig.loopOperation.ioIn[channel].pinValue);
            }else if(intType== 1){
                sprintf(str,"+IOIN=%d,PULLDOWN,%d\r\n",channel+1,dtuConfig.loopOperation.ioIn[channel].pinValue);
            }else if(intType== 2){
                sprintf(str,"+IOIN=%d,RISING,%d\r\n",channel+1,dtuConfig.loopOperation.ioIn[channel].pinValue);
            }else if(intType== 3){
                sprintf(str,"+IOIN=%d,FALLING,%d\r\n",channel+1,dtuConfig.loopOperation.ioIn[channel].pinValue);
            }else if(intType== 4){
                sprintf(str,"+IOIN=%d,BOTH,%d\r\n",channel+1,dtuConfig.loopOperation.ioIn[channel].pinValue);
            }
            s->print(str);
        }else{
            sprintf(str,"+IOIN=%d,D\r\n",channel+1);
            s->print(str);
        }
        disable3V3();
        return true;
    }

    if((p[0] != '=') || (p[1] == '\0')){

        sprintf(str,"+IOIN=%d,FAIL\r\n",channel+1);
        s->print(str);
        return false;
    }
    p+=3;


    if(strncmp(p, "FLOATING",6) == 0){
        dtuConfig.loopOperation.ioIn[channel].enable = 1;
        dtuConfig.loopOperation.ioIn[channel].intType = 0;
        dtuConfig.loopOperation.ioIn[channel].mode = GPIO_ModeIN_Floating;
        dtuConfig.loopOperation.ioMask = (dtuConfig.loopOperation.ioMask) | (1<<channel);
        GPIOB_ModeCfg(dtuConfig.loopOperation.ioIn[channel].pin, GPIO_ModeIN_Floating);

    }else if(strncmp(p, "BOTH",8) == 0){
        dtuConfig.loopOperation.ioIn[channel].enable = 1;
        dtuConfig.loopOperation.ioIn[channel].intType = 4;
        dtuConfig.loopOperation.ioIn[channel].mode = GPIO_ITMode_FallEdge;
        dtuConfig.loopOperation.ioMask = (dtuConfig.loopOperation.ioMask) | (1<<channel);
        PFIC_DisableIRQ(GPIO_B_IRQn);
        GPIOB_ModeCfg(dtuConfig.loopOperation.ioIn[channel].pin, GPIO_ModeIN_Floating);
        GPIOB_ITModeCfg(dtuConfig.loopOperation.ioIn[channel].pin,GPIO_ITMode_FallEdge);
        PFIC_EnableIRQ(GPIO_B_IRQn);
    }else if(strncmp(p, "RISING",8) == 0){
        dtuConfig.loopOperation.ioIn[channel].enable = 1;
        dtuConfig.loopOperation.ioIn[channel].intType = 2;
        dtuConfig.loopOperation.ioIn[channel].mode = GPIO_ITMode_FallEdge;
        dtuConfig.loopOperation.ioMask = (dtuConfig.loopOperation.ioMask) | (1<<channel);
        PFIC_DisableIRQ(GPIO_B_IRQn);
        GPIOB_ModeCfg(dtuConfig.loopOperation.ioIn[channel].pin, GPIO_ModeIN_Floating);
        GPIOB_ITModeCfg(dtuConfig.loopOperation.ioIn[channel].pin,GPIO_ITMode_FallEdge);
        PFIC_EnableIRQ(GPIO_B_IRQn);
    }else if(strncmp(p, "FALLING",8) == 0){
        dtuConfig.loopOperation.ioIn[channel].enable = 1;
        dtuConfig.loopOperation.ioIn[channel].intType = 3;
        dtuConfig.loopOperation.ioIn[channel].mode = GPIO_ITMode_RiseEdge;
        dtuConfig.loopOperation.ioMask = (dtuConfig.loopOperation.ioMask) | (1<<channel);
        PFIC_DisableIRQ(GPIO_B_IRQn);
        GPIOB_ModeCfg(dtuConfig.loopOperation.ioIn[channel].pin, GPIO_ModeIN_Floating);
        GPIOB_ITModeCfg(dtuConfig.loopOperation.ioIn[channel].pin,GPIO_ITMode_RiseEdge);
        PFIC_EnableIRQ(GPIO_B_IRQn);
    }else if(strncmp(p, "D",1) == 0){
        dtuConfig.loopOperation.ioIn[channel].enable = 0;
       // PFIC_DisableIRQ(GPIO_B_IRQn);
        dtuConfig.loopOperation.ioMask = (dtuConfig.loopOperation.ioMask) & (~(1<<channel));
        dtuConfig.loopOperation.ioIn[channel].enable = 0;
    }else{
        sprintf(str,"+IOIN=%d,FAIL\r\n",channel+1);
        s->print(str);
        return false;
    }

    if(dtuConfig.loopOperation.ioIn[channel].enable == 1){

        exclusive(IOIN,channel+1);
    }

    if(dtuConfig.loopOperation.countMask){
    	is_io_count = 1;
    	enable3V3();
    }else{
    	is_io_count = 0;
    	if(!is_dfbc_valid){
    		disable3V3();
    	}
    }

    dtuConfig.cfgCnt++;
    sprintf(str,"+IOIN=%d,OK\r\n",channel+1);
    s->print(str);
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    return true;
}
BOOL doLOSS(void *param, pDFSerial s){
    const char *p = (const char *)param;

     if(strcmp(p, "?") == 0){
      const char* tmp;
     uint8_t str1[100];
     floatToString(dtuConfig.hardPara.loss,str1,2);


      sprintf(str,"+LOSS=%s\r\n",str1);
      s->print(str);
      return true;
     }
     if((p[0] != '=') || (p[1] == '\0')){
       return false;
     }

     p++;
     float lossa = strtof(p, NULL);
     if(lossa>10){
         s->print("+LOSS=FAIL\r\n");
         return false;
     }

     s->print("+LOSS=OK\r\n");

     dtuConfig.hardPara.loss = lossa;
     NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
     return true;

}

BOOL doIocnt(void *param, pDFSerial s){
    const char *p = (const char *)param;
    sIoCounter_t* counter = NULL;

    int channel = 0;
    if(sscanf(p,"=%d",&channel) == 1){
        //printf("channel=%d\n",channel);
         channel--;

    }else{
        sprintf(str,"+IOCNT=FAIL\r\n");
        s->print(str);
        return false;
    }

    counter = &dtuConfig.loopOperation.ioCount[channel];

    if(strncmp(p, "=1?",3) == 0 || strncmp(p, "=2?",3) == 0|| strncmp(p, "=3?",3) == 0|| strncmp(p, "=4?",3) == 0){
      if(dtuConfig.loopOperation.ioCount[channel].enable ==1){
          sprintf(str,"+IOCNT=%d,%s,%d\r\n",channel+1,dtuConfig.loopOperation.ioCount[channel].mode,dtuConfig.loopOperation.ioCount[channel].Count);
      }else{
          sprintf(str,"+IOCNT=%d,D\r\n",channel+1);
      }

      s->print(str);
      memset(str,0,255);
      return false;
    }
    if((p[0] != '=') || (p[1] == '\0')){
        sprintf(str,"+IOCNT=%d,FAIL\r\n",channel+1);
        s->print(str);
      return false;
    }

    p+=3;
    uint8_t initFlag = 0;
    int count = 0;

    //scanf(p,"%s,%d\r\n",str,&count);
    //printf("count=%d\n",count);
    char *token;

    // 使用逗号作为分隔符解析字符串
    token = strtok(p, ",");
    char *mode;
    mode = token;
    // 继续解析，获取下一个结果
    token = strtok(NULL, ",");

    int countValue = atoi(token);
    memset(dtuConfig.loopOperation.ioCount[channel].mode,0,10);



     //在3v3供电后 PB14，PB15和io1,io2的状态是相反的，所以FALLING 对应的中断是GPIO_ITMode_RiseEdge
    if(strncmp(mode, "FALLING",7) == 0){

        initFlag=1;
        memcpy(dtuConfig.loopOperation.ioCount[channel].mode,"FALLING",7);
        counter->intType = GPIO_ITMode_RiseEdge;
        counter->intTyp = GPIO_ITMode_RiseEdge;
        counter->enable = 1;
        counter->Count = countValue;
        dtuConfig.loopOperation.countMask = (dtuConfig.loopOperation.countMask) | (1<<channel);

    }else if(strncmp(mode, "RISING",6) == 0){
        initFlag=1;
        counter->intType = GPIO_ITMode_FallEdge;
        memcpy(dtuConfig.loopOperation.ioCount[channel].mode,"RISING",6);
        counter->enable = 1;
        counter->Count = countValue;
        counter->intTyp = 2;
        dtuConfig.loopOperation.countMask = (dtuConfig.loopOperation.countMask) | (1<<channel);
    }else if(strncmp(mode, "BOTH",4) == 0){
        initFlag=1;
        memcpy(dtuConfig.loopOperation.ioCount[channel].mode,"BOTH",4);
        counter->intType = GPIO_ITMode_RiseEdge;
        counter->intTyp = 4;
        counter->enable = 1;
        counter->Count = countValue;
        dtuConfig.loopOperation.countMask = (dtuConfig.loopOperation.countMask) | (1<<channel);
    }else if(strncmp(mode, "D",1) == 0){
        counter->enable = 0;
        PFIC_DisableIRQ(GPIO_B_IRQn);
        dtuConfig.loopOperation.countMask = (dtuConfig.loopOperation.countMask) & (~(1<<channel));
    }else{
        sprintf(str,"+IOCNT=%d,FAIL\r\n",channel+1);
        s->print(str);
        return false;
    }


    //3v3 使能会给io口一个电平跳变，先关闭中断
    PFIC_DisableIRQ(GPIO_B_IRQn);
    if(dtuConfig.loopOperation.countMask){
        is_io_count = 1;
        enable3V3();
    }else{
        is_io_count = 0;
        if(!is_dfbc_valid){
            disable3V3();
        }
    }
    //3v3 使能引脚需要时间完成跳变
    DelayMs(3);
    if(initFlag == 1){

        GPIOB_ModeCfg(dtuConfig.loopOperation.ioCount[channel].pin, GPIO_ModeIN_PD);

        GPIOB_ITModeCfg(dtuConfig.loopOperation.ioCount[channel].pin,dtuConfig.loopOperation.ioCount[channel].intType);
        //
        if(dtuConfig.loopOperation.ioCount[channel].enable == 1){
            exclusive(IOCNT, channel+1);
        }


        PFIC_EnableIRQ(GPIO_B_IRQn);
    }



    dtuConfig.cfgCnt++;
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    sprintf(str,"+IOCNT=%d,OK\r\n",channel+1);
    s->print(str);
    return true;
}

BOOL doIocnt2(void *param, pDFSerial s){

    const char *p = (const char *)param;
    sIoCounter_t* counter = NULL;
    counter = &dtuConfig.loopOperation.ioCount[1];

    if(strncmp(p, "?",1) == 0){
      if(dtuConfig.loopOperation.ioCount[1].enable ==1){
          sprintf(str,"+IOCNT2=%s,%d\r\n",dtuConfig.loopOperation.ioCount[1].mode,dtuConfig.loopOperation.ioCount[1].Count);

      }else{

          sprintf(str,"+IOCNT2=D\r\n");
      }

      s->print(str);
      memset(str,0,255);
      return false;
    }

    if((p[0] != '=') || (p[1] == '\0')){
        s->print("+IOCNT2=FAIL\r\n");
      return false;
    }

    p++;
    uint8_t initFlag = 0;
    memset(dtuConfig.loopOperation.ioCount[1].mode,0,10);
    if(strncmp(p, "FALLING",7) == 0){
        initFlag=1;
        counter->intType = GPIO_ITMode_FallEdge;
        memcpy(dtuConfig.loopOperation.ioCount[1].mode,"FALLING",7);
        counter->enable = 1;

    }else if(strncmp(p, "RISING",6) == 0){
        initFlag=1;
        memcpy(dtuConfig.loopOperation.ioCount[1].mode,"RISING",6);
        counter->intType = GPIO_ITMode_RiseEdge;
        counter->enable = 1;
    }else if(strncmp(p, "D",1) == 0){
        counter->enable = 0;
        //PFIC_DisableIRQ(GPIO_A_IRQn);
    }else{
        s->print("+IOCNT2=FAIL\r\n");
        return false;
    }

    if(initFlag == 1){

        GPIOB_ModeCfg(dtuConfig.loopOperation.io[1].pin, GPIO_ModeOut_PP_5mA);
        GPIOB_ResetBits(dtuConfig.loopOperation.io[1].pin);

        GPIOA_ModeCfg(dtuConfig.loopOperation.ioCount[1].pin, GPIO_ModeIN_PD);
        PFIC_EnableIRQ(GPIO_A_IRQn);
        GPIOA_ITModeCfg(dtuConfig.loopOperation.ioCount[1].pin,dtuConfig.loopOperation.ioCount[1].intType);
        if(dtuConfig.loopOperation.ioCount[1].enable == 1){

            exclusive(IOCNT,2);
        }
    }
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    s->print("+IOCNT2=OK\r\n");
    return true;

}

BOOL doOutpower(void *param, pDFSerial s){
    int channel = 0;
    int voltage;
    int supplyTime;
    const char *p = (const char *)param;

    if(strncmp(p, "=0?",3) == 0){
        if(is_dfbc_valid) {
        	s->print("+OUTPOWER=0,12V,0\r\n");
        	return true;
        }
        sprintf(str,"+OUTPOWER=%d,%dV,%d\r\n",0,dtuConfig.loopOperation.power[0].voltage,dtuConfig.loopOperation.power[0].supplyTime);
       s->print(str);
       return true;
    }else if(strncmp(p, "=1?",3) == 0){
        //sprintf(str,"+OUTPOWER=%d,%dV,%d\r\n",1,dtuConfig.loopOperation.power[1].voltage,dtuConfig.loopOperation.power[1].supplyTime);
        //s->print(str);
        //return true;
        s->print("+OUTPOWER=FAIL\r\n");
        return true;

    }

    if((p[0] != '=') || (p[1] == '\0')){
      return false;
    }

    //GPIOA_ModeCfg(GPIO_Pin_3, GPIO_ModeOut_PP_5mA);
    //writeLog(p,getSysTime());
    if(sscanf(p, "=%d,%dV,%d",&channel, &voltage, &supplyTime)!=0){
    	if (channel != 0){
    		s->print("+OUTPOWER=FAIL\r\n");
    		return;
    	}
        uint8_t group = dtuConfig.loopOperation.power[0].group;
        uint32_t pin = dtuConfig.loopOperation.power[0].pin;

        SETMODE(group,pin,GPIO_ModeOut_PP_5mA);
        sprintf(str,"+OUTPOWER=%d,OK\r\n",0);
        if(supplyTime == -1) {
            SETLOW(group,pin);
            dtuConfig.loopOperation.power[0].enable = 0;
            dtuConfig.loopOperation.power[0].voltage= voltage;
            dtuConfig.loopOperation.power[0].supplyTime =  -1;
            if(is_dfbc_valid){
            	sprintf(str,"+OUTPOWER=FAIL\r\n");
            }
        }else{
            SETHIGH(group,pin);
            dtuConfig.loopOperation.power[0].enable = 1;
            dtuConfig.loopOperation.power[0].voltage= voltage;
            dtuConfig.loopOperation.power[0].supplyTime =  supplyTime;
            if(is_dfbc_valid && supplyTime){
            	sprintf(str,"+OUTPOWER=FAIL\r\n");
            }
        }

        s->print(str);
        NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
        dtuConfig.cfgCnt++;
        return true;
    }else{
        //s->print("+OUTPOWER=OK\r\n");
        return false;
    }
}

BOOL doAdc(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    uint16_t val;
    if(*p == '='){
    	p++;
    	//channel =*p-'0';
    	p++;
    }
    if(strncmp(p, "?",1) == 0){
    	if(dtuConfig.loopOperation.adc[0].enable){
    		enable3V3();
            tla202xBegin();
            val = tla202xADC0();
            disable3V3();
            sprintf(str,"+ADC=1,%d\r\n",val*5);
            DBG("%s",str);
            //val = 5535;
            //sprintf(str,"+ADC=1,%d\r\n",val);
            s->print(str);
    	}else{
            sprintf(str,"+ADC=1,D\r\n");
            s->print(str);
    	}
        return true;
    }
    if(strncmp(p, ",D",2) == 0){
    	dtuConfig.loopOperation.adc[0].enable = 0;
        sprintf(str,"+ADC=1,OK\r\n");
        s->print(str);
        return true;
    } else if(strncmp(p, ",V",2) == 0){
    	dtuConfig.loopOperation.adc[0].enable = 1;
        sprintf(str,"+ADC=1,OK\r\n");
        s->print(str);
        return true;
    }
    return false;
}


/**************************************************
  查询入网方式，默认OTAA
***************************************************/
BOOL doOtaa(void *param, pDFSerial s)
{
  const char *p = (const char *)param;
  MibRequestConfirm_t mibReq;
  mibReq.Type = MIB_NETWORK_ACTIVATION;
  LoRaMacMibGetRequestConfirm( &mibReq );
  
  if(strcmp(p, "?") == 0){
          if(dtuConfig.loraWanPara.joinType == ACTIVATION_TYPE_OTAA){
              s->print("+JOINTYPE=OTAA\r\n");
          }else if(dtuConfig.loraWanPara.joinType == ACTIVATION_TYPE_ABP){
              s->print("+JOINTYPE=ABP\r\n");
          }
	return true;
  }
  //s->print("?????-??");
  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
  mibReq.Type = MIB_NETWORK_ACTIVATION;


  if(strncmp(p, "OTAA",4) == 0){
      mibReq.Param.NetworkActivation = ACTIVATION_TYPE_NONE;
      dtuConfig.loraWanPara.joinType = ACTIVATION_TYPE_OTAA;
  }else if(strncmp(p, "ABP",3) == 0){
      mibReq.Param.NetworkActivation = ACTIVATION_TYPE_ABP;
      dtuConfig.loraWanPara.joinType = ACTIVATION_TYPE_ABP;
      dtuConfig.loopOperation.adnDisable = true;
  }else{
      s->print("+JOINTYPE=FAIL\r\n");
    return false;
  }
  //LoRaMacMibSetRequestConfirm( &mibReq );
  s->print("+JOINTYPE=OK\r\n");
  dtuConfig.cfgCnt++;
  dtuConfig.saveMask.joinType = 1;
  //}else{
   //   s->print("+JOINTYPE:FAIL\r\n");

  //}
  NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
  return true;
}

/**************************************************
  查询和设置DEVEUI
***************************************************/
BOOL doDeveui(void *param, pDFSerial s)
{
  const char *p = (const char *)param;

  MibRequestConfirm_t mibReq;
  mibReq.Type = MIB_DEV_EUI;
  LoRaMacMibGetRequestConfirm( &mibReq );
  if(strcmp(p, "?") == 0){
    const char *tmp;
    uint8_t str1[30]={0};
    uint8_t *eui = dtuConfig.loraWanPara.devEui;
    sprintf(str1,"+DEVEUI=%02X%02X%02X%02X%02X%02X%02X%02X\r\n",eui[0],eui[1],eui[2],eui[3],eui[4],eui[5],eui[6],eui[7]);
    s->print(str1);
	return true;
  }
  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
  char str[17]={0};
  strncpy(str, p, 16);


  uint32_t tmp;
  uint8_t eui[8];
  int ret;
  for(uint8_t x=0; x<8; x++){
     ret = sscanf(p,"%02X",&tmp);
     p+=2;
     eui[x] = tmp;
     if(ret != 1){
    	 break;
     }
  }
  if((eui[0]!=0x84)  || (eui[1]!=0xBE) || (eui[2]!=0x8B) || (!ret)){
	  s->print("+DEVEUI=FAIL\r\n");
	  return false;
  }
  memcpy(dtuConfig.loraWanPara.devEui, eui, 8);
  DBG("DEVEUI=%02X%02X%02X%02X%02X%02X%02X%02X",eui[0],eui[1],eui[2],eui[3],eui[4],eui[5],eui[6],eui[7]);
  mibReq.Type = MIB_DEV_EUI;
  mibReq.Param.DevEui = dtuConfig.loraWanPara.devEui;

  //LoRaMacMibSetRequestConfirm( &mibReq );
  s->print("+DEVEUI=OK\r\n");
  dtuConfig.saveMask.devEui = 1;
  dtuConfig.cfgCnt++;
  NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
  return true;
}

BOOL doRs485send(void *param, pDFSerial s)
{
  const char *p = (const char *)param;

  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
  uint8_t *dataHex = (uint8_t *)malloc(strlen(p));
  memset(dataHex,0,255);
  if(dtuConfig.hardPara.coding == 1){
    //HEX方式发送
    stringToHexArray(p,dataHex);
  }else{
    //ASSCI码方式发送
    stringToHex(p,dataHex);
    //return false;
  }
  UART0_SendString(dataHex, strlen(dataHex));
  s->print("+RS485SEND=OK\r\n");
  free(dataHex);
  //TimerStop( &sleepTimer );
  return true;
}


/**************************************************
  查询和设置APPEUI
***************************************************/
BOOL doAppeui(void *param, pDFSerial s)
{
  const char *p = (const char *)param;
  MibRequestConfirm_t mibReq;
  mibReq.Type = MIB_JOIN_EUI;
  LoRaMacMibGetRequestConfirm( &mibReq );
  if(strcmp(p, "?") == 0){
    const char *tmp;
    uint8_t str1[100]={0};
    tmp = arrtoStr(dtuConfig.loraWanPara.joinEui, 8);
    sprintf(str1,"+JOINEUI=%s\r\n",tmp);
    s->print(str1);
	return true;
  }
  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
  
    char str[9]={0};
    strncpy(str, p, 8);
    str[8] = '\0';
    uint32_t appEUI = strtoul(str, NULL, 16);
    uint8_t i = 3;
    for (uint8_t j=0; j<4; j++) {
      //lora.APPEUI[i] = (appEUI >> (j * 8)) & 0xff;
      dtuConfig.loraWanPara.joinEui[i] = (appEUI >> (j * 8)) & 0xff;
      i--;
    }
    p += 8;
    strncpy(str, p, 8);
    str[8] = '\0';
    appEUI = strtoul(str, NULL, 16);
    i=7;
    for (uint8_t j=0; j<4; j++) {
        dtuConfig.loraWanPara.joinEui[i] = (appEUI >> (j * 8)) & 0xff;
      i--;
    }
    mibReq.Type = MIB_JOIN_EUI;
    mibReq.Param.JoinEui = dtuConfig.loraWanPara.joinEui;
    //LoRaMacMibSetRequestConfirm( &mibReq );
    s->print("+JOINEUI=OK\r\n");
    dtuConfig.saveMask.joinEui = 1;
    dtuConfig.cfgCnt++;
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
	return true;

}

/**************************************************
  查询和设置APPKEY
***************************************************/
BOOL doAppkey(void *param, pDFSerial s)
{
  const char *p = (const char *)param;
  const char *tmp;
  LoRaMacNvmData_t *nvm = GetNvmData();
  MibRequestConfirm_t mibReq;
 // mibReq.Type = MIB_NWK_KEY;
 // LoRaMacMibGetRequestConfirm( &mibReq );
  if(strcmp(p, "?") == 0){
      uint8_t str1[100]={0};
    tmp = arrtoStr(dtuConfig.loraWanPara.appKey, 16);

    sprintf(str1,"+APPKEY=%s\r\n",tmp);
    s->print(str1);
	return true;
  }
  
  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
    char str[9]={0};
    strncpy(str, p, 8);
    str[8] = '\0';
    uint32_t appKEY = strtoul(str, NULL, 16);
    uint8_t i = 3;
    for (uint8_t j=0; j<4; j++) {
      //lora.APPKEY[i] = (appKEY >> (j * 8)) & 0xff;
      dtuConfig.loraWanPara.appKey[i]= (appKEY >> (j * 8)) & 0xff;
      i--;
    }
    p += 8;
    strncpy(str, p, 8);
    str[8] = '\0';
    appKEY = strtoul(str, NULL, 16);
    i=7;
    for (uint8_t j=0; j<4; j++) {
        dtuConfig.loraWanPara.appKey[i] = (appKEY >> (j * 8)) & 0xff;
      i--;
    }
	p += 8;
    strncpy(str, p, 8);
    str[8] = '\0';
    appKEY = strtoul(str, NULL, 16);
    i=11;
    for (uint8_t j=0; j<4; j++) {
        dtuConfig.loraWanPara.appKey[i] = (appKEY >> (j * 8)) & 0xff;
      i--;
    }
	p += 8;
    strncpy(str, p, 8);
    str[8] = '\0';
    appKEY = strtoul(str, NULL, 16);
    i=15;
    for (uint8_t j=0; j<4; j++) {
        dtuConfig.loraWanPara.appKey[i] = (appKEY >> (j * 8)) & 0xff;
      i--;
    }
    //tmp = arrtoStr( lora.APPKEY, 16);
    //s->print(tmp);
    mibReq.Type = MIB_NWK_KEY;
    mibReq.Param.AppKey = dtuConfig.loraWanPara.appKey ;
    //LoRaMacMibSetRequestConfirm( &mibReq );
        s->print("+APPKEY=OK\r\n");
        dtuConfig.cfgCnt++;
        dtuConfig.saveMask.appKey = 1;
    	dtuConfig.loopOperation.adnDisable = true;
        NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    //}else{

    //    s->print("+APPKEY:FAIL\r\n");

    //}
	return true;
}

/**************************************************
  查询和设置DEVADDR
***************************************************/
BOOL doDevaddr(void *param, pDFSerial s){

  const char *p = (const char *)param;	
  MibRequestConfirm_t mibReq;
  mibReq.Type = MIB_DEV_ADDR;
  LoRaMacMibGetRequestConfirm( &mibReq );

  if(strcmp(p, "?") == 0){

    const char *tmp;
    if(dtuConfig.loraWanPara.joinState ==1 && dtuConfig.loraWanPara.joinType == ACTIVATION_TYPE_OTAA){
        uint8_t str1[100]={0};
        sprintf(str1, "+DEVADDR=%06X\r\n", dtuConfig.loraWanPara.devAddr);
        s->print(str1);
    }else if(dtuConfig.loraWanPara.joinType == ACTIVATION_TYPE_ABP){

      uint8_t str1[100]={0};
      sprintf(str1, "+DEVADDR=%06X\r\n", dtuConfig.loraWanPara.devAddr);
      s->print(str1);
    }else{
        s->print("+DEVADDR=NULL\r\n");
    }
	return true;
  }
   if((p[0] != '=') || (p[1] == '\0')){
     return false;
    }
    p++;

    mibReq.Type = MIB_NETWORK_ACTIVATION;
    LoRaMacMibGetRequestConfirm( &mibReq );


    if( dtuConfig.loraWanPara.joinType != ACTIVATION_TYPE_ABP)
    {
        s->print("+DEVADDR=FAIL\r\n");
        return true;
    }

    char str[9]={0};
    strncpy(str, p, 8);
    str[8] = '\0';

    uint32_t devADDR = strtoul(str, NULL, 16);
    dtuConfig.loraWanPara.devAddr = devADDR;
    mibReq.Type = MIB_DEV_ADDR;
    mibReq.Param.DevAddr = dtuConfig.loraWanPara.devAddr ;
    //LoRaMacMibSetRequestConfirm( &mibReq );
    s->print("+DEVADDR=OK\r\n");
    dtuConfig.cfgCnt++;
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    dtuConfig.saveMask.devAddr = 1;
	return true;
}

BOOL doAppSkey(void *param, pDFSerial s)
{
  const char *p = (const char *)param;
  MibRequestConfirm_t mibReq;
 // mibReq.Type = MIB_APP_S_KEY;
  LoRaMacNvmData_t *nvm = GetNvmData();
  if(strcmp(p, "?") == 0){
  //LoRaMacMibGetRequestConfirm( &mibReq );
    const char *tmp;
    uint8_t str1[100]={0};
    tmp = arrtoStr(dtuConfig.loraWanPara.appSKey, 16);

    sprintf(str1,"+APPSKEY=%s\r\n",tmp);
    s->print(str1);
	return true;
  }
  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
  mibReq.Type = MIB_NETWORK_ACTIVATION;
  LoRaMacMibGetRequestConfirm( &mibReq );

  if( dtuConfig.loraWanPara.joinType != ACTIVATION_TYPE_ABP)
  {
      s->print("+APPSKEY=FAIL\r\n");
      return true;
  }

    char str[9]={0};
    strncpy(str, p, 8);
    str[8] = '\0';
    uint32_t appSKEY = strtoul(str, NULL, 16);
    uint8_t i = 3;
    for (uint8_t j=0; j<4; j++) {
      //lora.APPSKEY[i] = (appSKEY >> (j * 8)) & 0xff;
      dtuConfig.loraWanPara.appSKey[i]= (appSKEY >> (j * 8)) & 0xff;
      i--;
    }
    p += 8;
    strncpy(str, p, 8);
    str[8] = '\0';
    appSKEY = strtoul(str, NULL, 16);
    i=7;
    for (uint8_t j=0; j<4; j++) {
        dtuConfig.loraWanPara.appSKey[i] = (appSKEY >> (j * 8)) & 0xff;
      i--;
    }
	p += 8;
    strncpy(str, p, 8);
    str[8] = '\0';
    appSKEY = strtoul(str, NULL, 16);
    i=11;
    for (uint8_t j=0; j<4; j++) {
        dtuConfig.loraWanPara.appSKey[i] = (appSKEY >> (j * 8)) & 0xff;
      i--;
    }
	p += 8;
    strncpy(str, p, 8);
    str[8] = '\0';
    appSKEY = strtoul(str, NULL, 16);
    i=15;
    for (uint8_t j=0; j<4; j++) {
        dtuConfig.loraWanPara.appSKey[i] = (appSKEY >> (j * 8)) & 0xff;
      i--;
    }
    mibReq.Type = MIB_APP_S_KEY;
    //mibReq.Param.AppSKey = dtuConfig.loraWanPara.appSKey;
    //LoRaMacMibSetRequestConfirm( &mibReq );
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    s->print("+APPSKEY=OK\r\n");
    dtuConfig.cfgCnt++;

    dtuConfig.saveMask.appSKey = 1;
  return true;
}
BOOL doNwkSkey(void *param, pDFSerial s){

    const char *p = (const char *)param;
    MibRequestConfirm_t mibReq;
    //mibReq.Type = NWK_S_ENC_KEY;
    //LoRaMacMibGetRequestConfirm( &mibReq );
    LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){
      const char *tmp;
      uint8_t str1[100]={0};
      tmp = arrtoStr(dtuConfig.loraWanPara.nwkSKey, 16);

      sprintf(str1,"+NWKSKEY=%s\r\n",tmp);
      s->print(str1);
      return true;
    }
    if((p[0] != '=') || (p[1] == '\0')){
      return false;
    }
    p++;

    mibReq.Type = MIB_NETWORK_ACTIVATION;
    LoRaMacMibGetRequestConfirm( &mibReq );

    if( dtuConfig.loraWanPara.joinType != ACTIVATION_TYPE_ABP){
        s->print("+NWKSKEY=FAIL\r\n");
        return true;
    }

      char str[9]={0};
      strncpy(str, p, 8);
      str[8] = '\0';
      uint32_t nwkSKey = strtoul(str, NULL, 16);
      uint8_t i = 3;
      for (uint8_t j=0; j<4; j++) {
        //lora.APPSKEY[i] = (appSKEY >> (j * 8)) & 0xff;
        dtuConfig.loraWanPara.nwkSKey[i]= (nwkSKey >> (j * 8)) & 0xff;
        i--;
      }
      p += 8;
      strncpy(str, p, 8);
      str[8] = '\0';
      nwkSKey = strtoul(str, NULL, 16);
      i=7;
      for (uint8_t j=0; j<4; j++) {
          dtuConfig.loraWanPara.nwkSKey[i] = (nwkSKey >> (j * 8)) & 0xff;
        i--;
      }
      p += 8;
      strncpy(str, p, 8);
      str[8] = '\0';
      nwkSKey = strtoul(str, NULL, 16);
      i=11;
      for (uint8_t j=0; j<4; j++) {
          dtuConfig.loraWanPara.nwkSKey[i] = (nwkSKey >> (j * 8)) & 0xff;
        i--;
      }
      p += 8;
      strncpy(str, p, 8);
      str[8] = '\0';
      nwkSKey = strtoul(str, NULL, 16);
      i=15;
      for (uint8_t j=0; j<4; j++) {
          dtuConfig.loraWanPara.nwkSKey[i] = (nwkSKey >> (j * 8)) & 0xff;
        i--;
      }
      mibReq.Type = MIB_S_NWK_S_INT_KEY;
     // mibReq.Param.SNwkSIntKey = dtuConfig.loraWanPara.nwkSKey ;
      //LoRaMacMibSetRequestConfirm( &mibReq );
      s->print("+NWKSKEY=OK\r\n");
      NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
      //}else{
      //    s->print("+NWKSKEY:FAIL\r\n");
      //}
      dtuConfig.cfgCnt++;
      dtuConfig.saveMask.nwkSkey = 1;
    return true;
}

//需要知道ABP模式入网的netid 如何传下来的
BOOL doNetID(void *param, pDFSerial s)
{
  const char *p = (const char *)param;
  MibRequestConfirm_t mibReq;
  mibReq.Type = MIB_NET_ID;
  LoRaMacMibGetRequestConfirm( &mibReq );
  if(strcmp(p, "?") == 0)
  {
	static char str[sizeof(lora.NETID)*2 + 1];
    if(dtuConfig.loraWanPara.joinState == 1 ){
	    sprintf(str, "+NETID=%06x\r\n", mibReq.Param.NetID);
    }else{
        sprintf(str, "+NETID=FAIL\r\n");
    }
	s->print((const char *)str);
	return true;
  }else{
    return false;	
  }
}

BOOL doPort(void *param, pDFSerial s)
{
  const char *p = (const char *)param;
  LoRaMacNvmData_t *nvm = GetNvmData();
  if(strcmp(p, "?") == 0){
	const char* tmp;
    uint8_t str1[100]={0};
	tmp = inttoStr(dtuConfig.loraWanPara.port);

	sprintf(str1,"+PORT=%s\r\n",tmp);

	s->print(str1);
    return true;
  }
  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
  int port = strtoul(p, NULL, 10);
  if(port > 0 && port < 255 && port != 224 && port != dtuConfig.loraWanPara.uartPort[0])
  {
       dtuConfig.loraWanPara.port = port;
      s->print("+PORT=OK\r\n");

      dtuConfig.cfgCnt++;
      NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);

      return true;
  }else{
      s->print("+PORT=FAIL\r\n");
	return false;  
  }
  
}

BOOL doJoin(void *param, pDFSerial s)
{
  const char *p = (const char *)param;

  uint8_t isJoin = dtuConfig.loraWanPara.joinState;
  if(strcmp(p, "?") == 0){
	char* tmp;
    uint8_t str1[100]={0};
	if(isJoin == 1){
	   tmp = inttoStr(1);
	}else{
	   tmp = inttoStr(0);
	}
    sprintf(str1,"+JOIN=%s\r\n",(char *)tmp);
	s->print(str1);
    return true;	
  }

  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }

  p++;
  if(strncmp(p, "1",1) == 0 && !LoRaMacIsBusy( )){
      LmHandlerReJoinRequest(MLME_JOIN);
      s->print("+JOIN=OK\r\n");
  }else{
      s->print("+JOIN=FAIL\r\n");

  }
  return true;
}

BOOL doFreqs(void *param, pDFSerial s)
{
  const char *p = (const char *)param;
  //LDBG(p);

  MibRequestConfirm_t mibReq;
  MibRequestConfirm_t mibReq1;
  LoRaMacNvmData_t *nvm = GetNvmData();
  GetPhyParams_t getPhy;
  PhyParam_t phyParam;

  ChannelAddParams_t channelAdd;
  ChannelRemoveParams_t channelRemove;
  ChannelParams_t newChannel;

  mibReq.Type = MIB_CHANNELS;
  mibReq1.Type = MIB_CHANNELS_MASK;
  LoRaMacMibGetRequestConfirm( &mibReq );
  LoRaMacMibGetRequestConfirm( &mibReq1 );


  getPhy.Attribute = PHY_MAX_NB_CHANNELS;
  phyParam = RegionGetPhyParam( nvm->MacGroup2.Region, &getPhy );
  uint8_t maxNB = phyParam.Value;

  if(strcmp(p, "?") == 0){
	static char str1[sizeof(lora.FREQS) * 3 + 1];
	memset(str1, 0, sizeof(str1));

    uint8_t i = 0;
    uint8_t j = 0;
    uint8_t numOfCh= 0;

   static char temp[40];
   //printf("maxNB=%d\n", maxNB);
   for(uint8_t k = 0;k<maxNB;k++){
	   //printf("mibReq1.Param.ChannelsMask[%d]=0x%x\n",i,mibReq1.Param.ChannelsMask[i]);
	   //printf("mibReq.Param.ChannelList[%d].Frequency=%d\n",k,mibReq.Param.ChannelList[k].Frequency);
       if(((mibReq1.Param.ChannelsMask[i]>>j) & 0x01)   == 0x01 ){
           sprintf(temp, "%d,", mibReq.Param.ChannelList[k].Frequency);
           strcat(str1, temp);
           numOfCh++;
       }
       if(j == 15) {
           j = 0;
           i++;
       }else{
           j++;
       }
       if(numOfCh > 8) break;

   }

	str1[(numOfCh)*10-1] = '\0';

    sprintf(str,"+FREQS=%s\r\n",(const char *)str1);
    s->print(str);
	return true;
  }else{
	uint32_t freq;
    if(*p == '=') p++;
	int ret = sscanf(p,"%d",&freq);
	if(ret != 1){
		s->print("+FREQS=FAIL\r\n");
	    return true;
	}
	dtuConfig.loraWanPara.singleFreq = freq;
	printf("%d\n",freq);

	for(uint8_t j = 0;j < 16; j++){
	  if(((mibReq1.Param.ChannelsMask[0]>>j) & 0x01) == 0x01 ){
			channelRemove.ChannelId = j;
			RegionEU868ChannelsRemove(&channelRemove);
	  }
	}
	newChannel.Frequency = freq;
	newChannel.DrRange.Fields.Min=0;
	newChannel.DrRange.Fields.Max=5;
	newChannel.Rx1Frequency = freq;
	channelAdd.ChannelId = 0;
	channelAdd.NewChannel = &newChannel;
	RegionEU868ChannelAdd( &channelAdd );
	NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
	NvmStoreDTUConfig();
	s->print("+FREQS=OK\r\n");
    return true;
  }
}

BOOL doRegion(void *param, pDFSerial s)
{
  const char *p = (const char *)param;

  LoRaMacNvmData_t *nvm = GetNvmData();

  if(strcmp(p, "?") == 0){
    s->print("+REGION="ACTIVE_REGION_STR"\r\n");
	return true;
  }
  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
    if (strcmp(p, "CN470") == 0) {
        dtuConfig.loraWanPara.region  = LORAMAC_REGION_CN470;
        nvm->MacGroup2.Region         = LORAMAC_REGION_CN470;
        dtuConfig.loraWanPara.subBand = 11;
        dtuConfig.loraWanPara.eirp    = 20;
    } else if (strcmp(p, "US915") == 0) {
        dtuConfig.loraWanPara.region  = LORAMAC_REGION_US915;
        nvm->MacGroup2.Region         = LORAMAC_REGION_US915;
        dtuConfig.loraWanPara.subBand = 2;
        dtuConfig.loraWanPara.eirp    = 22;
    } else if (strcmp(p, "AU915") == 0) {
        nvm->MacGroup2.Region         = LORAMAC_REGION_AU915;
        dtuConfig.loraWanPara.region  = LORAMAC_REGION_AU915;
        dtuConfig.loraWanPara.subBand = 2;
        dtuConfig.loraWanPara.eirp    = 22;
    } else if (strcmp(p, "KR920") == 0) {
        nvm->MacGroup2.Region         = LORAMAC_REGION_KR920;
        dtuConfig.loraWanPara.region  = LORAMAC_REGION_KR920;
        dtuConfig.loraWanPara.subBand = 0;
        dtuConfig.loraWanPara.eirp    = 14;
    } else if (strcmp(p, "EU868") == 0) {
        nvm->MacGroup2.Region         = LORAMAC_REGION_EU868;
        dtuConfig.loraWanPara.region  = LORAMAC_REGION_EU868;
        dtuConfig.loraWanPara.subBand = 0;
        dtuConfig.loraWanPara.eirp    = 16;
    } else if (strcmp(p, "IN865") == 0) {
        nvm->MacGroup2.Region         = LORAMAC_REGION_IN865;
        dtuConfig.loraWanPara.region  = LORAMAC_REGION_IN865;
        dtuConfig.loraWanPara.subBand = 0;
        dtuConfig.loraWanPara.eirp    = 22;
    } else if (strcmp(p, "RU864") == 0) {
        nvm->MacGroup2.Region         = LORAMAC_REGION_RU864;
        dtuConfig.loraWanPara.region  = LORAMAC_REGION_RU864;
        dtuConfig.loraWanPara.subBand = 0;
        dtuConfig.loraWanPara.eirp    = 22;
    } else {
        s->print("+REGION=FAIL");
        return false;
    }
  dtuConfig.saveMask.region = 1;
  NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
  dtuConfig.cfgCnt++;
  s->print("+REGION=OK\r\n");
  return true;
}
BOOL doText(void *param, pDFSerial s)
{
  const char *p = (const char *)param;

  if(strcmp(p, "?") == 0){
    if( dtuConfig.hardPara.coding == 0){
        s->print("+TEXTTYPE=ASCII\r\n");
    }else if(dtuConfig.hardPara.coding = 1){
        s->print("+TEXTTYPE=HEX\r\n");
    }
    return true;
  }
  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
  if(strcmp(p, "ASCII") == 0){
      dtuConfig.hardPara.coding = 0;
  }else if(strcmp(p, "HEX") == 0){
      dtuConfig.hardPara.coding = 1;
  }else{
      s->print("+TEXTTYPE=FAIL\r\n");
    return false;
  }
  NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
  s->print("+TEXTTYPE=OK\r\n");
  return true;
}
BOOL getMcuSleep(){
    LoRaMacNvmData_t *nvm = GetNvmData();
    if(dtuConfig.hardPara.mcuSleep == 0){
        return false;
    }else if(dtuConfig.hardPara.mcuSleep = 1){
        return true;
    }
   return true;
}

BOOL doSleep(void *param, pDFSerial s){

    const char *p = (const char *)param;

    LoRaMacNvmData_t *nvm = GetNvmData();

    if(strcmp(p, "?") == 0){
      if(dtuConfig.hardPara.mcuSleep == 0){
          s->print("+POWERON=1\r\n");
      }else if(dtuConfig.hardPara.mcuSleep = 1){
          s->print("+POWERON=0\r\n");
      }
      return true;
    }
    if((p[0] != '=') || (p[1] == '\0')){
      return false;
    }
    p++;
    if(strcmp(p, "0") == 0){

        if(dtuConfig.hardPara.mcuSleep == 0){
          dtuConfig.hardPara.powerChangeFlag = true;
        }
        dtuConfig.hardPara.mcuSleep= 1;
    }else if(strcmp(p, "1") == 0){

        if(dtuConfig.hardPara.mcuSleep == 1){
          dtuConfig.hardPara.powerChangeFlag = true;
        }
        dtuConfig.hardPara.mcuSleep = 0;
    }else{
      s->print("+POWERON=FAIL\r\n");
      return false;
    }
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    s->print("+POWERON=OK\r\n");
    return true;

}
bool setSubBand(uint8_t subBand) {
    uint16_t subBandChannelMask[6] = {0}, maxMask = 0;
    LoRaMacNvmData_t *nvm = GetNvmData();

    switch (nvm->MacGroup2.Region) {
    case LORAMAC_REGION_CN470:
        maxMask = 6;
        if (subBand > 12) {
            return false;
        }
        subBandChannelMask[(subBand - 1) / 2] = ((subBand - 1) % 2) ? 0xFF00 : 0x00FF;
        // have not test yet! if meets any problems, see original logic below.
        break;
    case LORAMAC_REGION_AU915: // same as US915
    case LORAMAC_REGION_US915:
        maxMask = 6;
        if (subBand > 8) {
            return false;
        }
        subBandChannelMask[(subBand - 1) / 2] = ((subBand - 1) % 2) ? 0xFF00 : 0x00FF;
        subBandChannelMask[4]                 = 1 << (subBand - 1);
        // set DR4 channel mask before getting CFList, for adn use.
        break;
    default:
        return false;
    }

    RegionCommonChanMaskCopy(nvm->RegionGroup2.ChannelsDefaultMask, subBandChannelMask, maxMask);
    RegionCommonChanMaskCopy(nvm->RegionGroup2.ChannelsMask, subBandChannelMask, maxMask);
    NvmDataMgmtEvent(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    return true;

    // ----- original logic code -----

    // const uint16_t upperMask = 0xFF00, lowerMask = 0x00FF;
    // uint16_t           subBandChannelMask[6] = {0};
    // uint8_t            maxBand               = 1;
    // LoRaMacNvmData_t  *nvm                   = GetNvmData();

    // switch (nvm->MacGroup2.Region)
    // {
    // case LORAMAC_REGION_CN470:
    //     maxBand = 12;
    //     break;
    // case LORAMAC_REGION_AU915:
    // case LORAMAC_REGION_US915:
    //     maxBand = 8;
    //     break;
    // default:
    //     return false;
    // }

    // // Check for valid sub band
    // if ((subBand == 0) || (subBand > maxBand))
    // {
    //     // Invalid sub band requested
    //     return false;
    // }

    // switch (subBand)
    // {
    // case 1:
    //     subBandChannelMask[0] = lowerMask;
    //     break;
    // case 2:
    //     if (maxBand >= 2)
    //     {
    //         subBandChannelMask[0] = upperMask;
    //     }
    //     break;
    // case 3:
    //     if (maxBand >= 3)
    //     {
    //         subBandChannelMask[1] = lowerMask;
    //     }
    //     break;
    // case 4:
    //     if (maxBand >= 4)
    //     {
    //         subBandChannelMask[1] = upperMask;
    //     }
    //     break;
    // case 5:
    //     if (maxBand >= 5)
    //     {
    //         subBandChannelMask[2] = lowerMask;
    //     }
    //     break;
    // case 6:
    //     if (maxBand >= 6)
    //     {
    //         subBandChannelMask[2] = upperMask;
    //     }
    //     break;
    // case 7:
    //     if (maxBand >= 7)
    //     {
    //         subBandChannelMask[3] = lowerMask;
    //     }
    //     break;
    // case 8:
    //     if (maxBand >= 8)
    //     {
    //         subBandChannelMask[3] = upperMask;
    //     }
    //     break;
    // case 9:
    //     if (maxBand >= 9)
    //     {
    //         subBandChannelMask[4] = lowerMask;
    //     }
    //     break;
    // case 10:
    //     if (maxBand >= 10)
    //     {
    //         subBandChannelMask[4] = upperMask;
    //     }
    //     break;
    // case 11:
    //     if (maxBand >= 11)
    //     {
    //         subBandChannelMask[5] = lowerMask;
    //     }
    //     break;
    // case 12:
    //     if (maxBand >= 12)
    //     {
    //         subBandChannelMask[5] = upperMask;
    //     }
    //     break;
    // default:
    //     return false;
    // }
    // if (maxBand > 2)
    // {
    //     // printf("12315\n");
    //     RegionCommonChanMaskCopy(nvm->RegionGroup2.ChannelsDefaultMask,
    //     subBandChannelMask, 6);
    //     RegionCommonChanMaskCopy(nvm->RegionGroup2.ChannelsMask,
    //     subBandChannelMask, 6);
    // }
    // else
    // {
    //     RegionCommonChanMaskCopy(nvm->RegionGroup2.ChannelsDefaultMask,
    //     subBandChannelMask, 1);
    //     RegionCommonChanMaskCopy(nvm->RegionGroup2.ChannelsMask,
    //     subBandChannelMask, 1);
    // }
    // NvmDataMgmtEvent(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    // return true;
}
BOOL doSubband(void *param, pDFSerial s){
  const char *p = (const char *)param;

  LoRaMacNvmData_t *nvm = GetNvmData();
  if(strcmp(p, "?") == 0){
    uint8_t str1[20]={0};
	if(nvm->MacGroup2.Region == LORAMAC_REGION_EU868){
	    s->print("+SUBBAND=NULL\r\n");
	    return true;
	}

    sprintf(str1,"+SUBBAND=%d\r\n",dtuConfig.loraWanPara.subBand);
	s->print(str1);

	return true;
  }
  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
  uint8_t subband = strtoul(p, NULL, 10);
  if(subband == 0 || subband > 12){
      s->print("+SUBBAND=FAIL\r\n");
      return false;
  }
  dtuConfig.loraWanPara.subBand = subband;
  if(setSubBand(subband)){
      s->print("+SUBBAND=OK\r\n");
      dtuConfig.cfgCnt++;
      NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
  }else{
      s->print("+SUBBAND=FAIL\r\n");
      return false;
  }
  return true;
}

BOOL doAntennagain(void *param, pDFSerial s){
  const char *p = (const char *)param;
  MibRequestConfirm_t mibReq;
  mibReq.Type = MIB_ANTENNA_GAIN;
  LoRaMacMibGetRequestConfirm( &mibReq );
   if(strcmp(p, "?") == 0){
	//const char tmp[5];
    //floatToString(dtuConfig.loraWanPara.antennGain,tmp,2);
    sprintf(str,"+ANTENNAGAIN=%.2f\r\n",dtuConfig.loraWanPara.antennGain);
	s->print(str);
	return true;
   }
   if((p[0] != '=') || (p[1] == '\0')){
     return false;
   }

   p++;
   float ant = strtof(p, NULL);
   if(ant>10){
       s->print("+ANTENNAGAIN=FAIL\r\n");
       return false;
   }
   mibReq.Type = MIB_ANTENNA_GAIN;
   mibReq.Param.AntennaGain = ant;
   LoRaMacMibSetRequestConfirm( &mibReq );
   s->print("+ANTENNAGAIN=OK\r\n");
   dtuConfig.cfgCnt++;
   dtuConfig.saveMask.antenngain = 1;
   dtuConfig.loraWanPara.antennGain = ant;
   NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
   return true;
}

BOOL doEirp(void *param, pDFSerial s)
{
  const char *p = (const char *)param;
  LoRaMacNvmData_t *nvm = GetNvmData();
  MibRequestConfirm_t mibReq;
  GetPhyParams_t getPhy;
  PhyParam_t phyParam;
  mibReq.Type = MIB_CHANNELS_TX_POWER;
  LoRaMacMibGetRequestConfirm( &mibReq );

  if(strcmp(p, "?") == 0){
    uint16_t erip = dtuConfig.loraWanPara.eirp;
	static char str[8];
	sprintf(str, "+EIRP=%d\r\n", erip);
	s->print((const char*)str);
	return true;
  }
  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
  //float eirp = strtof(p,NULL);
  uint8_t eirp = strtoul(p, NULL, 10);
  mibReq.Type = MIB_CHANNELS_TX_POWER;

   //LoRaMacNvmData_t *nvm = GetNvmData();
   //最大的eirp
   //float maxEirp = nvm->MacGroup2.MacParams.MaxEirp;
   //天线增益
   //float antennaGain = nvm->MacGroup2.MacParams.AntennaGain;
 // txPowerIndex = (maxEirp - dtuConfig.loraWanPara.eirp+antennaGain)/2;

  //getPhy.Attribute = PHY_DEF_MAX_EIRP;
  //phyParam = RegionGetPhyParam( nvm->MacGroup2.Region, &getPhy );

  //if(eirp < dtuConfig.loraWanPara.antennGain  || eirp >phyParam.fValue) {
  //    s->print("+EIRP=FAIL\r\n");
  //    return true;
  //}

  //uint8_t eirpUS915[10]={20,18,16,14,12,10,8,6,4,2};
  //CN470 eirp列表
  //uint8_t eirpCN470[10]={19,17,15,13,11,9,7};
  //EU868 eirp列表
  //uint8_t eirpEU868[10]={16,14,12,10,8,6,4,2};

  uint8_t index = 0;
  switch(dtuConfig.loraWanPara.region){
    case LORAMAC_REGION_CN470:
        if(isEirpValid(eirpCN470,eirp,&index)){
          mibReq.Param.ChannelsTxPower = index;//(maxEirp - dtuConfig.loraWanPara.eirp - antennaGain)/2;
        }else{
            s->print("+EIRP=FAIL\r\n");
            return false;
        }
      break;
    case LORAMAC_REGION_US915:
        if(isEirpValid(eirpUS915,eirp,&index)){
          mibReq.Param.ChannelsTxPower = index;//(maxEirp - dtuConfig.loraWanPara.eirp - antennaGain)/2;
        }else{
          s->print("+EIRP=FAIL\r\n");
         return false;
        }
      break;
    case LORAMAC_REGION_EU868:
        if(isEirpValid(eirpEU868,eirp,&index)){
          mibReq.Param.ChannelsTxPower = index;//(maxEirp - dtuConfig.loraWanPara.eirp - antennaGain)/2;
          DBG("index=%d",index);
        }else{
          s->print("+EIRP=FAIL\r\n");
          return false;
        }
      break;
    default:
      //s->print("+EIRP=FAIL");
      break;
  }
  //printf("index=%d\n",index);
  LoRaMacMibSetRequestConfirm( &mibReq );
  dtuConfig.loraWanPara.eirp = eirp;
  dtuConfig.loraWanPara.txpower = index;
  //30-26-2.15
  DBG("dtuConfig.loraWanPara.eirp=%d dtuConfig.loraWanPara.txpower=%d\n",dtuConfig.loraWanPara.eirp,dtuConfig.loraWanPara.txpower);
  s->print("+EIRP=OK\r\n");
  dtuConfig.cfgCnt++;
  dtuConfig.saveMask.eirp = 1;

  NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);

  return true;
}

BOOL doDatarate(void *param, pDFSerial s){
  const char *p = (const char *)param;
  LoRaMacNvmData_t *nvm = GetNvmData();
  MibRequestConfirm_t mibReq;
  mibReq.Type = MIB_CHANNELS_DATARATE;
  LoRaMacMibGetRequestConfirm( &mibReq );
  if(strcmp(p, "?") == 0){
	const char* tmp;
	uint8_t str1[100]={0};
	tmp = inttoStr(dtuConfig.loraWanPara.dataRate);
	sprintf(str1,"+DATARATE=%s\r\n",tmp);
	s->print(str1);
	return true;
  }
  if((p[0] != '=') || (p[1] == '\0')){
      s->print("+DATARATE=FAIL\r\n");
    return false;
  }
  p++;
  uint8_t dataRate = strtoul(p, NULL, 10);
  if(nvm->MacGroup2.Region == LORAMAC_REGION_CN470){
     if(dataRate > 5)
         {
         s->print("+DATARATE=FAIL\r\n");
         return false;
         }
  }

  if(nvm->MacGroup2.Region == LORAMAC_REGION_US915){
      if(dataRate > 4 && dataRate < 8){
          s->print("+DATARATE=FAIL\r\n");
          return false;
      }
  }

  if(nvm->MacGroup2.Region== LORAMAC_REGION_EU868){
      if(dataRate > 5) {
          s->print("+DATARATE=FAIL\r\n");
          return false;
      }
  }

  mibReq.Type = MIB_CHANNELS_DATARATE;
  mibReq.Param.ChannelsDatarate = dataRate;
  //LoRaMacMibSetRequestConfirm( &mibReq );
 s->print("+DATARATE=OK\r\n");

      dtuConfig.saveMask.dataRate = 1;
      dtuConfig.cfgCnt++;
      DBG("dtuConfig.loraWanPara.dataRate=%d\n",dtuConfig.loraWanPara.dataRate);
  dtuConfig.loraWanPara.dataRate = dataRate;
  NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
  return true;
}
BOOL doNbtrials(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    MibRequestConfirm_t mibReq;
    mibReq.Type = MIB_CHANNELS_NB_TRANS;
    LoRaMacMibGetRequestConfirm( &mibReq );
    LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){
      const char* tmp;
      uint8_t str1[100]={0};
      //tmp = inttoStr(mibReq.Param.ChannelsNbTrans);
      tmp = inttoStr(dtuConfig.loraWanPara.nbtrials);
      sprintf(str1,"+NBTRIALS=%s\r\n",tmp);

      s->print(str1);
      return true;
    }
    if((p[0] != '=') || (p[1] == '\0')){
      return false;
    }
    p++;
    uint8_t nbtrials = strtoul(p, NULL, 10);
    if(nbtrials<4){
       mibReq.Type = MIB_CHANNELS_NB_TRANS;
       mibReq.Param.ChannelsNbTrans = nbtrials;
       LoRaMacMibSetRequestConfirm( &mibReq );
       s->print("+NBTRIALS=OK\r\n");
       dtuConfig.cfgCnt++;
       dtuConfig.saveMask.nbtrials = 1;
       dtuConfig.loraWanPara.nbtrials = nbtrials;
       NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    }else{
        s->print("+NBTRIALS=FAIL\r\n");
    }
    return true;

}
BOOL doClass(void *param, pDFSerial s){

    const char *p = (const char *)param;
    MibRequestConfirm_t mibReq;
    LoRaMacNvmData_t *nvm = GetNvmData();
    mibReq.Type = MIB_DEVICE_CLASS;
    LoRaMacMibGetRequestConfirm( &mibReq );
    if(strcmp(p, "?") == 0){
      const char* tmp;

      if(dtuConfig.loraWanPara.class == 0){
          s->print("+CLASS=A\r\n");
          //mibReq.Param.Class
      }else if(dtuConfig.loraWanPara.class == 2){
          s->print("+CLASS=C\r\n");
      }else{
          s->print("+CLASS=NULL\r\n");
          return false;
      }
      return true;
    }
    if((p[0] != '=') || (p[1] == '\0')){
      return false;
    }
    p++;


    mibReq.Type = MIB_DEVICE_CLASS;

    if(strncmp(p, "A",1) == 0){

       mibReq.Param.Class = 0;
    }else if(strncmp(p, "C",1) == 0){
        mibReq.Param.Class = 2;
    }else{
        s->print("+CLASS=FAIL\r\n");
        return false;

    }
   // nvm->MacGroup2.DeviceClass = 0;
    //LoRaMacMibSetRequestConfirm( &mibReq );
    dtuConfig.saveMask.class = 1;
    s->print("+CLASS=OK\r\n");
    dtuConfig.cfgCnt++;
    dtuConfig.loraWanPara.class = mibReq.Param.Class;
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);

    return true;

}
BOOL doRejoin(void *param, pDFSerial s){

    const char *p = (const char *)param;

    if( LoRaMacIsBusy( ) == true )
     {
        s->print("+REJION=FAIL\r\n");
     }else{
       LmHandlerReJoinRequest(MLME_JOIN);
       s->print("+REJION=OK\r\n");
     }
  // printf("----------------rejoin-------------------\r\n");
   return true;
}
BOOL doADR(void *param, pDFSerial s){
  const char *p = (const char *)param;

  MibRequestConfirm_t mibReq;
  mibReq.Type = MIB_ADR;
  LoRaMacMibGetRequestConfirm( &mibReq );
  if(strcmp(p, "?") == 0){
    const char* tmp;
    uint8_t str1[100]={0};
    //tmp = inttoStr(mibReq.Param.AdrEnable);
    tmp = inttoStr(dtuConfig.loraWanPara.adr);

    sprintf(str1,"+ADR=%s\r\n",tmp);

    s->print(str1);
    return true;
  }
  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
  int adr = strtoul(p, NULL, 10);
  if(adr < 2  && p[0] < '9'){
  mibReq.Type = MIB_ADR;
  mibReq.Param.AdrEnable = adr;
  //LoRaMacMibSetRequestConfirm( &mibReq );
  s->print("+ADR=OK\r\n");
  dtuConfig.saveMask.adr = 1;
  //}else{
  //    s->print("+ADR:FAIL\r\n");
  //}
  dtuConfig.cfgCnt++;
  dtuConfig.loraWanPara.adr = adr;

  NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
  }else{
      s->print("+ADR=FAIL\r\n");

  }
  return true;
}

void stringToHexArray(char* input, unsigned char* output )
{
    int i, len;
    char temp[3] = {0};
    len = strlen(input);
    if (len % 2 != 0) {
       // printf("Invalid input string or output array length.\n");
        return;
    }
    for (i = 0; i < len; i += 2) {
        temp[0] = input[i];
        temp[1] = input[i + 1];
        output[i / 2] = (unsigned char)strtol(temp, NULL, 16);
    }
}
void stringToHex(char* input, char* output)
{
    int i, len;
    len = strlen(input);
    for (i = 0; i < len; i++) {
        sprintf(output + i * 2, "%02X", input[i]);
    }
}

BOOL doSend(void *param, pDFSerial s)
{
    const char *p = (const char *)param;
    static uint8_t state = 0;
    if(strcmp(p, "?") == 0){
        if(state == 1){
         s->print("+SEND=OK\r\n");
        }else if(state ==2){

          s->print("+SEND=FAIL\r\n");
        }else if(state ==0){
            s->print("+SEND=IDLE\r\n");
          }
        return false;
    }



    if((p[0] != '=') || (p[1] == '\0')){
        return false;
    }
      p++;
      p++;
      uint8_t *dataHex = (uint8_t *)malloc(strlen(p)+10);
    //  memset(dataHex,0,255);

      if(dtuConfig.hardPara.coding == 1){
          //HEX方式发送
          stringToHexArray(p,dataHex);
      }else{
          //ASSCI码方式发送
          stringToHex(p,dataHex);
        //return false;
      }

      if( LmHandlerIsBusy( ) == true )
      {
          s->print("+SEND:loraWan IsBusy\r\n");
          return false;
      }
      //s->print(dataHex);
      dataHex[0] = 0x24;
      dataHex[1] = 0x21;
      AppData.Port = 2;
      AppData.Buffer = dataHex;
      AppData.BufferSize = 2;
     // printf("datalen=%d\n",AppData.BufferSize);
      if( LmHandlerSend( &AppData, false) == LORAMAC_HANDLER_SUCCESS )
      {
          //sendCount++;
          state = 1;
          s->print("+SEND=QUEUE\r\n");
          data_blink(300);
      }else{
          s->print("+SEND=FAIL\r\n");
          state = 2;
         // return false;
      }
      //s->print("+SEND=OK\r\n");
      //uint8_t printD[100];
      //sprintf(printD,"sendCount =%d\n",sendCount);
      //s->print(printD);
      free(dataHex);

  return true;
}
void hexTostring(unsigned char* hex_array, int len, char* str) {
    int i;
    for (i = 0; i < len; i++) {
        sprintf(str + i * 2, "%02x", hex_array[i]);
    }
    str[len * 2] = '\0';
}

BOOL doRecv(void *param, pDFSerial s)
{
    Node_t *node =  readNode();
    const char *p = (const char *)param;
    if(strcmp(p, "?") == 0){
      if(node ==NULL){
          s->print("+RECV:NO DATA\r\n");
          return false;
      }

      uint8_t *dataStr = (uint8_t*)malloc(sizeof(Node_t)+node->dataLen);
      LoRaMacNvmData_t *nvm = GetNvmData();
      memset(dataStr,0,sizeof(Node_t)+node->dataLen);
      hexTostring(node->data,node->dataLen,dataStr);
      sprintf(str, "0.1%f", node->data);
      s->print("R:C:");
      if(dtuConfig.hardPara.coding == 1){
         sprintf(dataStr,"%d:%d:%d:%s\n",node->port,node->rssi,node->snr,dataStr);
      }else if(dtuConfig.hardPara.coding == 0){
         sprintf(dataStr,"%d:%d:%d:%s\n",node->port,node->rssi,node->snr,node->data);

      }
      s->print(dataStr);
      free(node->data);
      free(node);
      free(dataStr);
    }else{

        s->print("+RECV:ERROR\r\n");

    }
    return true;
}


BOOL doUplinktype(void *param, pDFSerial s)
{
  
  const char *p = (const char *)param;
  LoRaMacNvmData_t *nvm = GetNvmData();
  if(strcmp(p, "?") == 0){
	if(dtuConfig.loraWanPara.isTxConfirmed == 1){
	  s->print("+UPLINKTYPE=CONFIRMED\r\n");
    }else if(dtuConfig.loraWanPara.isTxConfirmed == 0){
      s->print("+UPLINKTYPE=UNCONFIRMED\r\n");
	}else{
	  s->print("+UPLINKTYPE=FAIL\r\n");
	  return false;	
	}

	return true;
  }
  if((p[0] != '=') || (p[1] == '\0')){
    return false;
  }
  p++;
  if(strcmp(p, "CONFIRMED") == 0){
	//lora.UPLINKTYPE = CONFIRMED;
      dtuConfig.loraWanPara.isTxConfirmed = 1;
  }else if(strcmp(p, "UNCONFIRMED") == 0){
	//lora.UPLINKTYPE = UNCONFIRMED;
      dtuConfig.loraWanPara.isTxConfirmed = 0;
  }else{
      s->print("+UPLINKTYPE=FAIL\r\n");
	  return false;
  }
  sprintf(str,"AT+UPLINKTYPE=%d\n",dtuConfig.loraWanPara.isTxConfirmed);
  writeLog(str,getSysTime());
  NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
  s->print("+UPLINKTYPE=OK\r\n");
  dtuConfig.cfgCnt++;
  return true;
  
}
BOOL doBaud(void *param, pDFSerial s){


    const char *p = (const char *)param;
    LoRaMacNvmData_t *nvm = GetNvmData();
    uint8_t dataBaud[20]={0};



    int number = strtoul(p+1, NULL, 10);
    uint8_t oddEven = dtuConfig.hardPara.uartConfig[number].parityEn;
    uint8_t par = dtuConfig.hardPara.uartConfig[number].parity;
    char odd ;
    if(oddEven == 0){
        odd ='N';

    }else{
        if(par == 0){
            odd ='O';
        }else if(par == 1){
            odd ='E';
        }else if(par == 2){
            odd ='M';
        }else if(par == 3){
            odd ='S';
        }
    }
    memset(dataBaud,0,20);
    if(strcmp(p+2, "?") == 0){
      sprintf(dataBaud,"+UARTBAUD=%d,%ld,%d%c%d\r\n",number,dtuConfig.hardPara.baud[number],dtuConfig.hardPara.uartConfig[number].dataBits+5,odd,dtuConfig.hardPara.uartConfig[number].stopBits+1);
      s->print(dataBaud);
      return true;
    }

    if((p[0] != '=') || (p[1] == '\0')){
      return false;
    }

    p+=3;
    int baud_rate;
    int data_bits;
    int stop_bits;


    uint8_t dataBits;
    uint8_t stopBits;
    uint8_t parityEn;
    uint8_t parity = 0;

    if(sscanf(p, "%d,%dN%d\r\n", &baud_rate,&data_bits, &stop_bits) == 3){
        dataBits = data_bits;
        stopBits = stop_bits;
        parityEn = 0;
        parity = 0;
    }else if(sscanf(p, "%d,%dO%d\r\n", &baud_rate,&data_bits, &stop_bits) == 3){
        dataBits = data_bits;
        stopBits = stop_bits;
        parityEn = 1;
        parity = 0;
    }else if(sscanf(p, "%d,%dE%d\r\n", &baud_rate,&data_bits, &stop_bits) == 3){
        dataBits = data_bits;
        stopBits = stop_bits;
        parityEn = 1;
        parity = 1;
    }else if(sscanf(p, "%d,%dM%d\r\n", &baud_rate,&data_bits, &stop_bits) == 3){
        dataBits = data_bits;
        stopBits = stop_bits;
        parityEn = 1;
        parity = 2;
    }else if(sscanf(p, "%d,%dS%d\r\n", &baud_rate,&data_bits, &stop_bits) == 3){
        dataBits = data_bits;
        stopBits = stop_bits;
        parityEn = 1;
        parity = 3;
    }
    sUartConfig_t config ;
    config.dataBits = dataBits-5 ;
    config.stopBits = stopBits-1;
    config.parityEn = parityEn;
    config.parity = parity;
    //4800、9600、14400、19200、38400、115200
    if(isUartConfigValid (baud_rate,config)){
      dtuConfig.hardPara.baud[number] = baud_rate;
      dtuConfig.hardPara.uartConfig[number].value =config.value;
      NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
      uart1Iint( dtuConfig.hardPara.baud[number],dtuConfig.hardPara.uartConfig[number].value);
     //  sprintf(str,"baud_rate%d,%d\n",baud_rate,dtuConfig.hardPara.uartConfig[number].value);
      // s->print(str);

      sprintf(str,"+UARTBAUD=%d,OK\r\n",number);
      dtuConfig.cfgCnt++;
    }else{

      sprintf(str,"+UARTBAUD=%d,FAIL\r\n",number);
    }
    s->print(str);
    return true;
}



int extractPara(const char *str, char *param1, char *param2) {
    // 初始化字符串为空
    param1[0] = '\0';
    param2[0] = '\0';
    char *ptr = str; // 查找'='符号的位置
    if (*ptr == '\0') {
        return 0;
    }
    char *comma = strchr(ptr, ','); // 查找第一个','符号的位置

    if (comma == NULL) {
        strncpy(param1, ptr, strlen(ptr)+1);
        return 1;
    } else {
        strncpy(param1, ptr, comma-ptr);
        param1[comma-ptr] = '\0';
        comma++; // 跳过','符号
        if (*comma != '\0') {
            strncpy(param2, comma, strlen(comma)+1);
            return 2;
        } else {
            return 1;
        }
    }
}

BOOL doATChan(void *param, pDFSerial s){
    const char *p = (const char *)param;
    LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){
      char atCh[30]="+ATCHAN:";
      char*usb = "USB";
      char*uart ="UART_TTL";
      uint8_t chanFlag = 0;
      if((dtuConfig.hardPara.atChannel & 0x01) == 1){
          strcat(atCh,usb);
          chanFlag = 1;
      }
      if((dtuConfig.hardPara.atChannel>>1)&0x01 == 1){
          if(chanFlag == 1){
              strcat(atCh,",");
          }
          chanFlag = 2;
          strcat(atCh,uart);
      }
      if(chanFlag == 0){
          strcat(atCh,"NULL");
      }
      s->print("+ATCHAN=");
      s->print(atCh);
      return true;
    }
    if((p[0] != '=') || (p[1] == '\0')){
      return false;
    }
    p++;
    char para1[10];
    char para2[10];
    uint8_t paraLen = extractPara(p,para1,para2);
    if(paraLen == 0){
        s->print("+ATCHAN=FAIL\r\n");
        return false;
    }
    dtuConfig.hardPara.atChannel = 0;
    if(strcmp(para1, "USB")==0 || strcmp(para2, "USB")==0){
        dtuConfig.hardPara.atChannel = dtuConfig.hardPara.atChannel | 0x01;
    }
    if(strcmp(para1, "UART_TTL")==0 || strcmp(para2, "UART_TTL")==0){
        dtuConfig.hardPara.atChannel = dtuConfig.hardPara.atChannel | 0x02;
    }
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
    s->print("+ATCHAN=OK\r\n");
    return true;
}

BOOL doManufacturer(void *param, pDFSerial s){

    const char *p = (const char *)param;
    //LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){

      s->print("+MANUFACTURER=DFROBOT\r\n");
      return true;
    }
    s->print("+MANUFACTURER=FAIL\r\n");
    return false;
}

BOOL doProduct(void *param, pDFSerial s){
    const char *p = (const char *)param;
    //LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){
      sprintf(str,"+PRODUCT=%s\r\n",dtuConfig.hardPara.product);
      s->print(str);
      return true;
    }
    s->print("+PRODUCT=FAIL\r\n");
    return false;
}

BOOL doSWVersion(void *param, pDFSerial s){
    const char *p = (const char *)param;
    //LoRaMacNvmData_t *nvm = GetNvmData();
    if(strcmp(p, "?") == 0){
      s->print("+SWVERSION="SWVERSION"\r\n");
      return true;
    }
    s->print("+SWVERSION=FAIL\r\n");
    return false;
}

//BOOL doHWVersion(void *param, pDFSerial s);

BOOL doSN(void *param, pDFSerial s){
    const char *p = (const char *)param;
    //LoRaMacNvmData_t *nvm = GetNvmData();
    DBG("------------sn=%02X%02X%02X%02X%02X%02X%02X%02X\n",dtuConfig.hardPara.sn[0],dtuConfig.hardPara.sn[1],dtuConfig.hardPara.sn[2],dtuConfig.hardPara.sn[3],dtuConfig.hardPara.sn[4],dtuConfig.hardPara.sn[5],dtuConfig.hardPara.sn[6],dtuConfig.hardPara.sn[7]);
    if(strcmp(p, "?") == 0){
      sprintf(str, "+SN=%02X%02X%02X%02X%02X%02X%02X%02X\r\n", dtuConfig.hardPara.sn[0], \
    		  dtuConfig.hardPara.sn[1], \
			  dtuConfig.hardPara.sn[2], \
			  dtuConfig.hardPara.sn[3], \
			  dtuConfig.hardPara.sn[4], \
			  dtuConfig.hardPara.sn[5], \
			  dtuConfig.hardPara.sn[6], \
			  dtuConfig.hardPara.sn[7]);
       s->print(str);
      return true;
    }
    s->print("+SN=FAIL\r\n");
    return false;
}

BOOL doRecovery(void *param, pDFSerial s){
    s->print("+RECOVERY=OK\r\n");
    dtuConfig.saveMask.recovery =1;
    return true;
}
void softReset()
{
    R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG1;
    R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG2;
    SAFEOPERATE;
    R16_INT32K_TUNE = 0xFFFF;
    R8_RST_WDOG_CTRL |= RB_SOFTWARE_RESET;
    R8_SAFE_ACCESS_SIG = 0;//进入后执行复位，复位类型为上电复位

}

BOOL doReboot(void *param, pDFSerial s){
    s->print("+REBOOT=OK\r\n");
    dtuConfig.cfgCnt++;
    NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
   // writeLog("[SET]AT+REBOOT\r\n",getSysTime());
    //NvmDataMgmtStore();
    NvmStoreDTUConfig();
   // DelayMs(100);
    softReset();
    return true;
}

__HIGH_CODE
void APPJumpBoot(void)   //此段代码必须运行在RAM中
{
  while(FLASH_ROM_ERASE(0,EEPROM_BLOCK_SIZE))
  {
    ;//ROM 擦4K1个单位，擦0地址起始
  }
  FLASH_ROM_SW_RESET();
  R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG1;
  R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG2;
  SAFEOPERATE;
  R16_INT32K_TUNE = 0xFFFF;
  R8_RST_WDOG_CTRL |= RB_SOFTWARE_RESET;
  R8_SAFE_ACCESS_SIG = 0;//进入后执行复位，复位类型为上电复位
  while(1);//营造空片的现象，启动时就会停在BOOT，等烧写，超时时间10s
}

BOOL doUpgrade(void *param, pDFSerial s){
    s->print("+UPGRADE=OK\r\n");
    DelayMs(10);
    APPJumpBoot();
    return true;
}

BOOL doRS485Baud(void *param, pDFSerial s){
    const char *p = (const char *)param;
    return true;
}

BOOL doGpio(void *param, pDFSerial s)
{
	return true;
}

void execAtCmd(pDFSerial serialData)
{
  if(AT == 0){
	return;
  }
  if(strncmp(serialData->recvBuffer,"AT+",3) != 0){
      if(strncmp(serialData->recvBuffer,"+++",3) != 0){
          //serialData->print("error\r\n");
          return ;
      }
  }
  const char *p1=serialData->recvBuffer+3,*p2=serialData->recvBuffer+3;
  while((*p2 != '=') && ((p2-p1) < 20) && (*p2 != '?')&&(*p2 != '\0')){
    if(*p2 == ' '){
      serialData->print("ERROR\r\n");
	  return;
	}
	p2++;

  }

  if(*p2 != '=' && *p2 != '?' && *p2 != '\0'){
      serialData->print("ERROR\r\n");
    return;
  }

  int len = p2-p1;
  uint8_t i = 0;
  int size = sizeof(doCmd)/sizeof(tAtCmd);
  uint8_t noDeal = 1;
  while(i<size)
  {
	if(memcmp(doCmd[i].cmdStr, p1, len) == 0){
	    //serialData->print("len =0\r\n");
	    noDeal = 0;
      if(len == strlen(doCmd[i].cmdStr)){
	     if(doCmd[i].func((void *)p2, serialData) == false){

	     }else{

	     }
	     break;
      } else {
          noDeal = 1;
      }
	}else{
	    //serialData->print("+NOCOMMAND\r\n");
	}

  	i++;
  }
  if(noDeal == 1){

      serialData->print("+NOCOMMAND\r\n");
      //command
  }

}

BOOL startAt(const char *p, pDFSerial s)
{
  if(strcmp(p, "AT") == 0){
      s->print("OK\r\n");
  }

  if(s->id == UART_INTTERFACE_NUM){
    if(strcmp(p, "+++") == 0){
        //TimerStop( &sleepTimer );
        //TimerSetValue( &sleepTimer, 8000);
        //TimerStart( &sleepTimer );
        dtuConfig.loraWanPara.uartMode = 0;
	    AT = 1;
	    s->print("OK\r\n");
        return true;
     }

  }else if(s->id == USB1_INTTERFACE_NUM) {
       if(dtuConfig.logPrint != 2){
         AT = 1;
       }else{
         AT = 0;
       }

       if(strcmp(p, "AT+EXIT") == 0)
       {
         s->print("+EXIT=OK\r\n");
         AT = 0;
         dtuConfig.defaultLogPrint = dtuConfig.logPrint;
         dtuConfig.logPrint = 2;
         return true;
       }
  }else if(s->id == LORAWAN_INTTERFACE_NUM) {
          AT = 1;
  }else if(s->id == NFC_INTTERFACE_NUM) {
      AT = 1;
  }

  if(s->id == UART_INTTERFACE_NUM){

    if(strcmp(p, "AT+EXIT") == 0)
    {
      s->print("+EXIT=OK\r\n");
	  AT = 0;
	  dtuConfig.loraWanPara.uartMode = 1;
	  return true;
    }

  }
    return false;
}

pDFSerial recvAt()
{
  const char *p=NULL;

  bufferLenth = 0;
  uint8_t i = 0;

  for(i = 0;i<SENUM-3 ;i++){
      if((dfserials[i].dataFlag ==1)){
    	  if((dfserials[i].recvBuffer[dfserials[i].datalength - 1] == '\n') \
    			  && (dfserials[i].recvBuffer[dfserials[i].datalength - 2] == '\r')){
    		  dfserials[i].id = i;
    		  dfserials[i].recvBuffer[dfserials[i].datalength - 2] = '\0'; //去掉\r\n
    		  p = dfserials[i].recvBuffer;
    		  dfserials[i].dataFlag = 0;
    		  dfserials[i].index = 0;
    		  // printf("str = %s\n",dfserials[i].recvBuffer);
    		  if(startAt(p, &dfserials[i])){
    			  ser = 0;
    			  break;
    		  }else{
    			  ser = 1;
    			  break;
    		  }
    	  }
      }
  }

  /*
  //USB透传的数据处理
  if(dfserials[3].dataFlag ==1 ){
      dfserials[3].dataFlag =0;
      //dfserials[3].recvBuffer[dfserials[3].datalenght-2] = '\0'; //去掉\r\n
      //AppData.Port = 2;
      //AppData.Buffer = dfserials[3].recvBuffer;
      //AppData.BufferSize = strlen(dfserials[3].recvBuffer);
      writeData(dfserials[3].recvBuffer,dfserials[3].datalenght);
      //sysLog("dataFalg=1\n");
      TimerSetValue( &transTimer, 100);
      TimerStart( &transTimer );
  }
  */

  if(startLine < endLine){
      if(startLine <= dtuConfig.hardPara.rowCsv){
         memset(str,0,110);
         flashRead(str,startLine,109);

         tempSerial->print(str);

      startLine++;
      if(dtuConfig.hardPara.rowCsv == startLine ) startLine  = endLine;
      }else{
          endLine = startLine;

      }
  }

  //RS485读取的数据处理
  if(dfserials[4].dataFlag >0 && tempSerial !=NULL){
	  char channel[5]={0};
      if(dfserials[4].dataFlag == 1){
          dfserials[4].dataFlag =0;

       int i, j = 0;
       //printf("dataLen=%d\n",dfserials[4].datalength);
       for (i = 0; i < dfserials[4].datalength; i++) {
           j += sprintf(str + j, "%02X", dfserials[4].recvBuffer[i]); // 格式化写入目标字符串
       }
       DBG(str);
       if(dfserials[4].datalength > 0){
    	  uint8_t len=dfserials[4].recvBuffer[2];
    	  //if((len == 2) || (len == 4)){
    	  //	  dfbcEvents.masks.modbusMask |= (1 << modbus_channel);
    	  //	  memcpy(dfbcEvents.RS485Value[modbus_channel], &dfserials[4].recvBuffer[3], len);
    	  //	  DBG("------value[0]= %02X value[1]= %02X\n",
    	  //			  dfbcEvents.RS485Value[modbus_channel][0],
		  //			  dfbcEvents.RS485Value[modbus_channel][1]);
    	  //}
    	  sprintf(channel,"%d,",modbus_channel);
          // sysLog("rs485Recv print\n");
          tempSerial->print("+RS485ITEM=");
          tempSerial->print(channel);
          tempSerial->print(str);
          tempSerial->print("\r\n");
          dfserials[4].datalength =0;
        }
     }else if(dfserials[4].dataFlag == 2){ //timeout
         dfserials[4].dataFlag =0;
         sprintf(str,"+RS485ITEM=%d,FAIL\r\n",modbus_channel);
         tempSerial->print(str);
     }

      TimerStop( &rs485TimeOutTimer );
      tempSerial = NULL;
  }

  if(AT == 0)
  {
      ser = 0;
  }

  if((dfserials[NFC_INTTERFACE_NUM].dataFlag ==1)){
      dfserials[NFC_INTTERFACE_NUM].recvBuffer[dfserials[NFC_INTTERFACE_NUM].datalength-2] = '\0'; //去掉\r\n
      p = dfserials[NFC_INTTERFACE_NUM].recvBuffer;
      dfserials[NFC_INTTERFACE_NUM].dataFlag = 0;
      ser = 1;
      i= NFC_INTTERFACE_NUM;
  }

   if( ser == 1 ){
    // printf("p =%d\n",i);
     if(i == 3) return NULL;
     return &dfserials[i];
   }else{
     //  sysLog("ser =0\n");
     return NULL;

   }
}

const char* arrtoStr(uint8_t data[], uint8_t num)
{	
  memset(str, 0, sizeof(str));
  uint8_t i;
  for (i = 0; i < num; i++) {
      sprintf(&str[i * 2], "%02X", data[i]);
  }
  str[num*2] = '\0';
  return str;
  
}

const char* inttoStr(uint8_t data)
{
    memset(str, 0, sizeof(str));
    sprintf(str, "%d", data);
    return str;
}
void transToTTL(uint8_t *buffer,uint16_t size){
    if( dtuConfig.loraWanPara.uartMode == 1 && dtuConfig.hardPara.loopTime==0 ){
        SendUartData(buffer,size);
    }
}
void uart1Print(const char *data)
{

    SendUartData(data,strlen(data));
}

void uart1Write8(uint8_t data)
{
	
}
void uart1Write16(uint16_t data)
{
	
}
void uart1Flush(void *data)
{
	
}

void LORAWANPrint(const char *data){
    uint8_t defaultPort = 0;
    if( LmHandlerIsBusy( ) == true )
    {
        return ;
    }
    //s->print(dataHex);

    AppData.Port = 2;
    AppData.Buffer = data;
    AppData.BufferSize = strlen(data);
    if(dtuConfig.loraWanPara.uartMode == 0x00){
        defaultPort =  dtuConfig.loraWanPara.port;
        dtuConfig.loraWanPara.port = 20 ;
    }else if (dtuConfig.loraWanPara.uartMode == 0x01){
        defaultPort = dtuConfig.loraWanPara.uartPort[0];
        dtuConfig.loraWanPara.uartPort[0] = 20 ;
    }

    if( LmHandlerSend( &AppData, false) == LORAMAC_HANDLER_SUCCESS )
    {

    }else{
       // return false;
    }

    if(dtuConfig.loraWanPara.uartMode == 0x00){
         dtuConfig.loraWanPara.port = defaultPort;

    }else if (dtuConfig.loraWanPara.uartMode == 0x01){
         dtuConfig.loraWanPara.uartPort[0] = defaultPort;

    }

}
void LORAWANWrite8(uint8_t data){

}
void LORAWANWrite16(uint16_t data){

}
void LORAWANFlush(void *data){

}
void USB1Print(const char *data)
{
   // printf("len=%d\n",strlen(data));
    //printf("data=%s\n",data);
    uint16_t len = strlen(data);
    while(len){
        DelayMs(1);
        USB_IRQProcessHandler();
        if(len > 64){
            SendUSBData1(data, 64);
            len -= 64;
            data += 64;
        }else{


            SendUSBData1(data,len);
            len = 0;
        }

    }
}

void USB1Write8(uint8_t data)
{
	
}
void USB1Write16(uint16_t data)
{
	
}
void USB1Flush(void *data)
{
	
}

void sysLog(const char *data){
   uint8_t str4[512];
   char formattedTime[30];
    formatTime(getSysTime(), formattedTime);
    sprintf(str4,"[%s] %s",formattedTime,data);
    if(dtuConfig.logPrint == 1){
      SendUartData(str4,strlen(str4));
      DelayMs(2);
      //SendUSBData1(data,strlen(data));
    }else if(dtuConfig.logPrint == 2){
        USB1Print(str4);
    }
}

void intMessage(const char *data){

    SendUartData(data,strlen(data));
    DelayMs(2);
    SendUSBData1(data,strlen(data));

}
void USB2Print(const char *data)
{
    //printf("AT=%s\n",data);
    uint16_t len = strlen(data);
    while(len){
        DelayMs(1);
        USB_IRQProcessHandler();
        if(len>36){
            SendUSBData2(data,36);
            len-=36;
            data+=36;
        }else{
            SendUSBData2(data,len);
            len = 0;
        }

    }


}

void USB2Write8(uint8_t data)
{

}
void USB2Write16(uint16_t data)
{

}
void USB2Flush(void *data)
{

}
void NFCPrint(void * data){

    nfcACK(1,data,strlen(data));
}

volatile int totalDataLength = 0;  // 全局变量，记录链表中所有数据的长度

uint8_t packetDequeue(uint8_t maxN, uint8_t *buffer)
{
    struct msgBuf *p;
    uint8_t*ptr = buffer;
    uint8_t totalLen = 0;

    while (maxN > 0 && (p = msgBufHead) != NULL)
    {

        if (p->len <= maxN)
        {
            // 如果当前数据包的长度小于等于所需长度len，则完全提取该数据包

            memcpy(ptr, p->value, p->len);

            //printf("len=%d\n",p->len);
            //printf("str1=%s\n",ptr);

            ptr += p->len;
            maxN -= p->len;
            totalLen += p->len;

            msgBufHead = p->next;
            free(p);
        }
        else
        {
            // 如果当前数据包的长度大于所需长度len，则部分提取该数据包
           // printf("str2=%s\n",p->value);
           // printf("len?=%d\n",p->len);
            memcpy(ptr, p->value, maxN);
            p->len -= maxN;


            memmove(p->value, p->value + maxN, p->len);

            ptr += maxN;
            totalLen += maxN;
            maxN = 0;
        }
    }
    totalDataLength -= totalLen;

    return totalLen;
}
/*********************************************************************
 * @fn      sappEnqueue
 *
 * @brief   Enqueue a HID report to be sent later.
 *
 * @param   id - HID report ID.
 * @param   type - HID report type.
 * @param   len - Length of report.
 * @param   pData - Report data.
 *
 * @return  None.
 */







extern char _end[];
extern char _heap_end[];
extern uint32_t _eusrstack;
extern char _ebss[];
static char *curbrk1 = NULL;

void sappEnqueue(uint8_t *pbuf, uint8_t len)
{
#if 1
    struct msgBuf *p;
    uint8_t          nextPacketLen = len;
    uint8_t          appendLen     = 0;


    if (msgBufHead != NULL) //存在头指针，
    {

        //tail还剩下的空位置
        appendLen     = BUFFER_SIZE - msgBufTail->len;
        //如果appendLen 大于要填充进来的长度，则appendLen
        appendLen     = appendLen > len ? len : appendLen; //选择较小的数据

        nextPacketLen = len - appendLen;

        //如果前一个包还有空间，则把tail的空间填满
        if (appendLen != 0)
        { // merge
            memcpy(msgBufTail->value + msgBufTail->len, pbuf, appendLen); //
            msgBufTail->len += appendLen;
        }
        //如果把前一个包填慢了，pbuf还有数据，则开辟下一个链表
        if (nextPacketLen != 0)
        {
            p = (struct msgBuf *)malloc(sizeof(struct msgBuf) + BUFFER_SIZE);
            if (p == NULL)
            {
                printf("r=%d\n",totalDataLength);
                return;
            }
           // printf("Stack end address: %p\n", _heap_end);
           // printf("_ebss: %p\n", _ebss);
           // printf("ram address: %p\n", &_eusrstack);
           // printf("_end address: %p\n", _end);
            p->next          = NULL;
            msgBufTail->next = p;  //把新申请的结构体填到链表尾部
            msgBufTail       = p;  //把尾部链表更新
            p->len           = nextPacketLen; //把尾部链表的长度更改
            p->handle        = 0;
            memcpy(p->value, pbuf + appendLen, nextPacketLen);//把尾部链表的数据更改
        }
    }
    else
    {
        p = (struct msgBuf *)malloc(sizeof(struct msgBuf) + BUFFER_SIZE);
        if (p == NULL)
        {
            //printf("NULL\n");
            return;
        }
        p->next    = NULL;//下一个为空
        msgBufHead = p; //头指针和尾指针都赋相同的值
        msgBufTail = p;
        p->len     = len;
        p->handle  = 0;

        memcpy(p->value, pbuf, len); //把value buffer赋值
    }


    totalDataLength += len;  // 更新全局变量的值
#else
    struct msgBuf *p;

    p = (struct msgBuf *)df_osal_mem_alloc(sizeof(struct msgBuf) + len);
    if (p == NULL)
    {
        return;
    }
    p->next = NULL;
    if (msgBufHead == NULL)
    {
        msgBufHead = p;
        msgBufTail = p;
    }
    else
    {
        msgBufTail->next = p;
        msgBufTail       = p;
    }
    p->len    = len;
    p->handle = 0;
    osal_memcpy(p->value, pbuf, len);
#endif
}
void *_sbrk(ptrdiff_t incr) {

  static char *curbrk = _end;
  if ((curbrk + incr < _end) || (curbrk + incr > _heap_end))
    return NULL - 1;
  curbrk1 = curbrk;
  curbrk += incr;
  return curbrk - incr;
}




uint8_t getloraMaxL(){

    MibRequestConfirm_t mibReq;
    mibReq.Type = MIB_CHANNELS_DATARATE;
    LoRaMacMibGetRequestConfirm( &mibReq );
    return GetMaxAppPayloadWithoutFOptsLength( mibReq.Param.ChannelsDatarate );
}

int getTotalDataLength() {

    return totalDataLength;
}

void clearTTL(){
    uint8_t dataLen = 1;
    uint8_t dataBuffer[20];

    while(dataLen > 0){
        dataLen = packetDequeue(20,dataBuffer);
    }

}


BOOL ttlData(){
  if(msgBufHead !=NULL){
      return true;
  }else{
      return false;
  }
}


//获取电池电量
uint8_t  getBatteryLevel(){
	//uint8_t result;
    //BQ25672_Setup( );
    /*uint16_t adc = BQ25672_getBatteryVoltage();
    uint8_t stat = BQ25672_read_bytes(0x1c,1) >> 5;
    int16_t current = BQ25672_getBatteryCurrent();
    uint8_t vbus = GPIOA_ReadPortPin(GPIO_Pin_6) != 0;
    uint8_t ext_vcc = BQ25672_read_bytes(0x1B,1) & 0x01;
    uint8_t charging = BQ25672_read_bytes(0x1C,1) >> 5;

    if(ext_vcc && charging){
    	if(stat == 0x07){
            DBG("charging bat full\n");
            adc = 4200;
        }
    }else if(ext_vcc){
    	if(stat == 0x07){
    		adc = 4200;
    		DBG("charging bat full\n");
       	}else if(current < 0 ){
    		DBG("no charging, battery output current=%d\n",current);
    	}else{
    		adc = 0;
    	}
    }
    if(adc > 4150){
        result = 100;
    }else if(adc >= 3900){
        result = 70;
    }else if(adc >= 3800){
        result = 40;
    }else if(adc >= 3690){
        result = 10;
    }else{
    	result = 0;
    }
*/
    return 100;
}

uint32_t burn_dfbc_file(const void *buf,uint32_t index, uint32_t len){
	if(index == 0){
		void tm_stop(void) ;
		tm_stop();
		//NvmmReset(2*1024, DFBC_ADDR);
		is_dfbc_valid = 0;
		FLASH_ROM_ERASE(DFBC_ADDR, 2*1024);
		NvmDataMgmtEvent1(LORAMAC_NVM_NOTIFY_FLAG_MAC_GROUP2);
		NvmStoreDTUConfig();
	}
	FLASH_ROM_WRITE(DFBC_ADDR + index, buf, len);
	uint8_t *p = (uint8_t *)buf;
	DBG("index=%d,len=%d\n",index,len);
	for(int i=0; i<len;i++){
		printf("%02X",p[i]);
	}
	printf("\n");
	p = DFBC_ADDR+index;
	for(int i=0; i<len;i++){
		printf("%02X",p[i]);
	}
	printf("\n");
	return 0;
}

