#include <string.h>

#include "MD5.h"
//这个适合单片机

typedef unsigned char BYTE;
typedef unsigned long UINT;
typedef UINT MD5_SUB_ARRAY[16];
typedef UINT MD5_TRANSORM_FUNC(UINT, UINT, UINT);
typedef struct {
   UINT abcd[4];
   MD5_SUB_ARRAY sub_array;
} MD5_TRANSFORM_PARAM;

const static UINT MD5_TRANSFORM_MATRIX[4][16][3] = { { { 0, 7, 1 }, { 1, 12, 2 }, { 2, 17, 3 }, { 3, 22, 4 }, { 4, 7, 5 }, { 5, 12, 6 }, { 6, 17, 7 }, { 7, 22, 8 }, { 8, 7, 9 }, { 9, 12, 10 }, { 10, 17, 11 }, { 11, 22, 12 }, { 12, 7, 13 }, { 13, 12, 14 }, { 14, 17, 15 }, { 15, 22, 16 }, },

{ { 1, 5, 17 }, { 6, 9, 18 }, { 11, 14, 19 }, { 0, 20, 20 }, { 5, 5, 21 }, { 10, 9, 22 }, { 15, 14, 23 }, { 4, 20, 24 }, { 9, 5, 25 }, { 14, 9, 26 }, { 3, 14, 27 }, { 8, 20, 28 }, { 13, 5, 29 }, { 2, 9, 30 }, { 7, 14, 31 }, { 12, 20, 32 }, },

{ { 5, 4, 33 }, { 8, 11, 34 }, { 11, 16, 35 }, { 14, 23, 36 }, { 1, 4, 37 }, { 4, 11, 38 }, { 7, 16, 39 }, { 10, 23, 40 }, { 13, 4, 41 }, { 0, 11, 42 }, { 3, 16, 43 }, { 6, 23, 44 }, { 9, 4, 45 }, { 12, 11, 46 }, { 15, 16, 47 }, { 2, 23, 48 }, },

{ { 0, 6, 49 }, { 7, 10, 50 }, { 14, 15, 51 }, { 5, 21, 52 }, { 12, 6, 53 }, { 3, 10, 54 }, { 10, 15, 55 }, { 1, 21, 56 }, { 8, 6, 57 }, { 15, 10, 58 }, { 6, 15, 59 }, { 13, 21, 60 }, { 4, 6, 61 }, { 11, 10, 62 }, { 2, 15, 63 }, { 9, 21, 64 }, }, };

const static UINT MD5_TRANSFORM_ARRAY[65] = { //
      //
            0, 0xd76aa478, 0xe8c7b756, 0x242070db, 0xc1bdceee, 0xf57c0faf, //
            0x4787c62a, 0xa8304613, 0xfd469501, 0x698098d8, 0x8b44f7af, 0xffff5bb1, //
            0x895cd7be, 0x6b901122, 0xfd987193, 0xa679438e, 0x49b40821, 0xf61e2562, //
            0xc040b340, 0x265e5a51, 0xe9b6c7aa, 0xd62f105d, 0x2441453, 0xd8a1e681, //
            0xe7d3fbc8, 0x21e1cde6, 0xc33707d6, 0xf4d50d87, 0x455a14ed, 0xa9e3e905, //
            0xfcefa3f8, 0x676f02d9, 0x8d2a4c8a, 0xfffa3942, 0x8771f681, 0x6d9d6122, //
            0xfde5380c, 0xa4beea44, 0x4bdecfa9, 0xf6bb4b60, 0xbebfbc70, 0x289b7ec6, //
            0xeaa127fa, 0xd4ef3085, 0x4881d05, 0xd9d4d039, 0xe6db99e5, 0x1fa27cf8, //
            0xc4ac5665, 0xf4292244, 0x432aff97, 0xab9423a7, 0xfc93a039, 0x655b59c3, //
            0x8f0ccc92, 0xffeff47d, 0x85845dd1, 0x6fa87e4f, 0xfe2ce6e0, 0xa3014314, //
            0x4e0811a1, 0xf7537e82, 0xbd3af235, 0x2ad7d2bb, 0xeb86d391 };

static inline UINT F(UINT x, UINT y, UINT z) {
   return ((x & y) | ((~x) & z));
}

static inline UINT G(UINT x, UINT y, UINT z) {
   return ((x & z) | (y & (~z)));
}

static inline UINT H(UINT x, UINT y, UINT z) {
   return (x ^ y ^ z);
}

static inline UINT I(UINT x, UINT y, UINT z) {
   return (y ^ (x | (~z)));
}

static void MD5_transform(MD5_TRANSFORM_PARAM* param, int ring, MD5_TRANSORM_FUNC func) {
   UINT a, b, c, d, s, k, i;
   UINT* abcd = param->abcd;
   UINT *X;
   const UINT* T;
   int index;
   X = param->sub_array;
   T = MD5_TRANSFORM_ARRAY;

   for (index = 0; index < 16; index++) {
      a = abcd[(3 * index + 0) & 3];
      b = abcd[(3 * index + 1) & 3];
      c = abcd[(3 * index + 2) & 3];
      d = abcd[(3 * index + 3) & 3];

      k = MD5_TRANSFORM_MATRIX[ring][index][0];
      s = MD5_TRANSFORM_MATRIX[ring][index][1];
      i = MD5_TRANSFORM_MATRIX[ring][index][2];

      a = a + func(b, c, d) + X[k] + T[i];
      a = (a << s) | (a >> (32 - s)); // 循环左移
      a = a + b;

      abcd[(3 * index + 0) & 3] = a;
   }
}

extern void md5_md5(const unsigned char* data, int len, unsigned char * md5Out) {
   int x, new_len;
   MD5_TRANSFORM_PARAM param;
   UINT ABCD[4] = { 0x67452301L, 0x1f123456L, 0x1f123458L, 0x10325476L };
   //UINT ABCD[4] = { 0x674523L, 40232334L, 0x98badcL, 0x103254L };
   //计算时的数据布局
   //1)原始数据
   //2)填充数据(如果需要,最后数据长度不是64字节对齐,就需要填充),第一字节为0x80,其它为0
   //3)长度bit数,就是len*8,占用8字节
   new_len = (((len + 8) >> 6) + 1) << 6;
   unsigned char* ts = (unsigned char*) param.sub_array;
   for (x = 0; x < new_len; x += 64) {
      memcpy(param.abcd, ABCD, 16);
      if (x + 64 <= len) {
         //数据
         memcpy(ts, &data[x], 64);
      }
      else {
         //1)剩余数据
         memcpy(ts, &data[x], len - x);
         //2)填充的第一字节0x80
         if (new_len - len > 9) {
            ts[len - x] = 0x80;
         }
         //2)填充0
         memset(&ts[len - x + 1], 0, new_len - len - 9);
         //3)附加长度数据bit放到最后
         *(UINT*) (ts + 56) = len * 8;
         memset(ts + 60, 0, 4);
      }
      MD5_transform(&param, 0, F);
      MD5_transform(&param, 1, G);
      MD5_transform(&param, 2, H);
      MD5_transform(&param, 3, I);

      ABCD[0] += param.abcd[0];
      ABCD[1] += param.abcd[1];
      ABCD[2] += param.abcd[2];
      ABCD[3] += param.abcd[3];
   }
   memcpy(md5Out, ABCD, 16);
}

void MD5(const void* ps,char *output) {
   int len = strlen((char*) ps);
   unsigned char rs[18]={0};
   md5_md5((unsigned char*) ps, len, rs);

   const static char CS[] = "0123456789ABCDEF";

   int io = 0;
   for (int i = 0; i < 16; i++) {
       output[io++] = CS[(rs[i] >> 4) & 0xF];
       output[io++] = CS[(rs[i] >> 0) & 0xF];
   }
   output[io++] = 0;
   //printf("%s => %s\n", (char*) ps, ss);

   return;

}
/*
 * 32-bit integer manipulation macros (little endian)
 */
#ifndef GET_ULONG_LE
#define GET_ULONG_LE(n, b, i)                                                                                          \
    {                                                                                                                  \
        (n) = ((unsigned long)(b)[(i)]) | ((unsigned long)(b)[(i) + 1] << 8) | ((unsigned long)(b)[(i) + 2] << 16) |   \
              ((unsigned long)(b)[(i) + 3] << 24);                                                                     \
    }
#endif

#ifndef PUT_ULONG_LE
#define PUT_ULONG_LE(n, b, i)                                                                                          \
    {                                                                                                                  \
        (b)[(i)]     = (unsigned char)((n));                                                                           \
        (b)[(i) + 1] = (unsigned char)((n) >> 8);                                                                      \
        (b)[(i) + 2] = (unsigned char)((n) >> 16);                                                                     \
        (b)[(i) + 3] = (unsigned char)((n) >> 24);                                                                     \
    }
#endif

/*
 * MD5 context setup
 */
void md5_starts(md5_context *ctx)
{
    ctx->total[0] = 0;
    ctx->total[1] = 0;

    ctx->state[0] = 0x67452301;
    ctx->state[1] = 0xEFCDAB89;
    ctx->state[2] = 0x98BADCFE;
    ctx->state[3] = 0x10325476;
}

static void md5_process(md5_context *ctx, const unsigned char data[64])
{
    unsigned long X[16], A, B, C, D;

    GET_ULONG_LE(X[0], data, 0);
    GET_ULONG_LE(X[1], data, 4);
    GET_ULONG_LE(X[2], data, 8);
    GET_ULONG_LE(X[3], data, 12);
    GET_ULONG_LE(X[4], data, 16);
    GET_ULONG_LE(X[5], data, 20);
    GET_ULONG_LE(X[6], data, 24);
    GET_ULONG_LE(X[7], data, 28);
    GET_ULONG_LE(X[8], data, 32);
    GET_ULONG_LE(X[9], data, 36);
    GET_ULONG_LE(X[10], data, 40);
    GET_ULONG_LE(X[11], data, 44);
    GET_ULONG_LE(X[12], data, 48);
    GET_ULONG_LE(X[13], data, 52);
    GET_ULONG_LE(X[14], data, 56);
    GET_ULONG_LE(X[15], data, 60);

#define S(x, n) ((x << n) | ((x & 0xFFFFFFFF) >> (32 - n)))

#define P(a, b, c, d, k, s, t)                                                                                         \
    {                                                                                                                  \
        a += F(b, c, d) + X[k] + t;                                                                                    \
        a = S(a, s) + b;                                                                                               \
    }

    A = ctx->state[0];
    B = ctx->state[1];
    C = ctx->state[2];
    D = ctx->state[3];

#define F(x, y, z) (z ^ (x & (y ^ z)))

    P(A, B, C, D, 0, 7, 0xD76AA478);
    P(D, A, B, C, 1, 12, 0xE8C7B756);
    P(C, D, A, B, 2, 17, 0x242070DB);
    P(B, C, D, A, 3, 22, 0xC1BDCEEE);
    P(A, B, C, D, 4, 7, 0xF57C0FAF);
    P(D, A, B, C, 5, 12, 0x4787C62A);
    P(C, D, A, B, 6, 17, 0xA8304613);
    P(B, C, D, A, 7, 22, 0xFD469501);
    P(A, B, C, D, 8, 7, 0x698098D8);
    P(D, A, B, C, 9, 12, 0x8B44F7AF);
    P(C, D, A, B, 10, 17, 0xFFFF5BB1);
    P(B, C, D, A, 11, 22, 0x895CD7BE);
    P(A, B, C, D, 12, 7, 0x6B901122);
    P(D, A, B, C, 13, 12, 0xFD987193);
    P(C, D, A, B, 14, 17, 0xA679438E);
    P(B, C, D, A, 15, 22, 0x49B40821);

#undef F

#define F(x, y, z) (y ^ (z & (x ^ y)))

    P(A, B, C, D, 1, 5, 0xF61E2562);
    P(D, A, B, C, 6, 9, 0xC040B340);
    P(C, D, A, B, 11, 14, 0x265E5A51);
    P(B, C, D, A, 0, 20, 0xE9B6C7AA);
    P(A, B, C, D, 5, 5, 0xD62F105D);
    P(D, A, B, C, 10, 9, 0x02441453);
    P(C, D, A, B, 15, 14, 0xD8A1E681);
    P(B, C, D, A, 4, 20, 0xE7D3FBC8);
    P(A, B, C, D, 9, 5, 0x21E1CDE6);
    P(D, A, B, C, 14, 9, 0xC33707D6);
    P(C, D, A, B, 3, 14, 0xF4D50D87);
    P(B, C, D, A, 8, 20, 0x455A14ED);
    P(A, B, C, D, 13, 5, 0xA9E3E905);
    P(D, A, B, C, 2, 9, 0xFCEFA3F8);
    P(C, D, A, B, 7, 14, 0x676F02D9);
    P(B, C, D, A, 12, 20, 0x8D2A4C8A);

#undef F

#define F(x, y, z) (x ^ y ^ z)

    P(A, B, C, D, 5, 4, 0xFFFA3942);
    P(D, A, B, C, 8, 11, 0x8771F681);
    P(C, D, A, B, 11, 16, 0x6D9D6122);
    P(B, C, D, A, 14, 23, 0xFDE5380C);
    P(A, B, C, D, 1, 4, 0xA4BEEA44);
    P(D, A, B, C, 4, 11, 0x4BDECFA9);
    P(C, D, A, B, 7, 16, 0xF6BB4B60);
    P(B, C, D, A, 10, 23, 0xBEBFBC70);
    P(A, B, C, D, 13, 4, 0x289B7EC6);
    P(D, A, B, C, 0, 11, 0xEAA127FA);
    P(C, D, A, B, 3, 16, 0xD4EF3085);
    P(B, C, D, A, 6, 23, 0x04881D05);
    P(A, B, C, D, 9, 4, 0xD9D4D039);
    P(D, A, B, C, 12, 11, 0xE6DB99E5);
    P(C, D, A, B, 15, 16, 0x1FA27CF8);
    P(B, C, D, A, 2, 23, 0xC4AC5665);

#undef F

#define F(x, y, z) (y ^ (x | ~z))

    P(A, B, C, D, 0, 6, 0xF4292244);
    P(D, A, B, C, 7, 10, 0x432AFF97);
    P(C, D, A, B, 14, 15, 0xAB9423A7);
    P(B, C, D, A, 5, 21, 0xFC93A039);
    P(A, B, C, D, 12, 6, 0x655B59C3);
    P(D, A, B, C, 3, 10, 0x8F0CCC92);
    P(C, D, A, B, 10, 15, 0xFFEFF47D);
    P(B, C, D, A, 1, 21, 0x85845DD1);
    P(A, B, C, D, 8, 6, 0x6FA87E4F);
    P(D, A, B, C, 15, 10, 0xFE2CE6E0);
    P(C, D, A, B, 6, 15, 0xA3014314);
    P(B, C, D, A, 13, 21, 0x4E0811A1);
    P(A, B, C, D, 4, 6, 0xF7537E82);
    P(D, A, B, C, 11, 10, 0xBD3AF235);
    P(C, D, A, B, 2, 15, 0x2AD7D2BB);
    P(B, C, D, A, 9, 21, 0xEB86D391);

#undef F

    ctx->state[0] += A;
    ctx->state[1] += B;
    ctx->state[2] += C;
    ctx->state[3] += D;
}

/*
 * MD5 process buffer
 */
void md5_update(md5_context *ctx, const unsigned char *input, int ilen)
{
    int           fill;
    unsigned long left;

    if (ilen <= 0)
        return;

    left = ctx->total[0] & 0x3F;
    fill = 64 - left;

    ctx->total[0] += ilen;
    ctx->total[0] &= 0xFFFFFFFF;

    if (ctx->total[0] < (unsigned long)ilen)
        ctx->total[1]++;

    if (left && ilen >= fill)
    {
        memcpy((void *)(ctx->buffer + left), input, fill);
        md5_process(ctx, ctx->buffer);
        input += fill;
        ilen -= fill;
        left = 0;
    }

    while (ilen >= 64)
    {
        md5_process(ctx, input);
        input += 64;
        ilen -= 64;
    }

    if (ilen > 0)
    {
        memcpy((void *)(ctx->buffer + left), input, ilen);
    }
}

static const unsigned char md5_padding[64] = {0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                              0,    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                              0,    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

/*
 * MD5 final digest
 */
void md5_finish(md5_context *ctx, unsigned char output[16])
{
    unsigned long last, padn;
    unsigned long high, low;
    unsigned char msglen[8];

    high = (ctx->total[0] >> 29) | (ctx->total[1] << 3);
    low  = (ctx->total[0] << 3);

    PUT_ULONG_LE(low, msglen, 0);
    PUT_ULONG_LE(high, msglen, 4);

    last = ctx->total[0] & 0x3F;
    padn = (last < 56) ? (56 - last) : (120 - last);

    md5_update(ctx, md5_padding, padn);
    md5_update(ctx, msglen, 8);

    PUT_ULONG_LE(ctx->state[0], output, 0);
    PUT_ULONG_LE(ctx->state[1], output, 4);
    PUT_ULONG_LE(ctx->state[2], output, 8);
    PUT_ULONG_LE(ctx->state[3], output, 12);
}

/*
 * output = MD5( input buffer )
 */
void md5(unsigned char *input, int ilen, unsigned char output[16])
{
    md5_context ctx;
    memset(&ctx, 0, sizeof(md5_context));
    md5_starts(&ctx);
    md5_update(&ctx, input, ilen);
    md5_finish(&ctx, output);
}
