#ifndef __TLA2022_H
#define __TLA2022_H
/*
#define TLA20XX_CONV_REG 0x00
#define TLA20XX_CONF_REG 0x01

#define TLA20XX_I2C_ADDR 0x48
#include "CH58x_common.h"

typedef enum {
	TLA2022_DR_128SPS = 0x0,
	TLA2022_DR_250SPS = 0x1,
	TLA2022_DR_490SPS = 0x2,
	TLA2022_DR_920SPS = 0x3,
	TLA2022_DR_1600SPS = 0x4,
	TLA2022_DR_2400SPS = 0x5,
	TLA2022_DR_3300SPS = 0x6,
}TLA2022_DR;

typedef enum {
	TLA2022_FSR_6_144V = 0x0,
	TLA2022_FSR_4_096V = 0x1,
	TLA2022_FSR_2_048V = 0x2,
	TLA2022_FSR_1_024V = 0x3,
	TLA2022_FSR_0_512V = 0x4,
	TLA2022_FSR_0_256V = 0x5,
}TLA2022_FSR;

typedef enum {
	TLA2022_OP_CONTINUOUS = 0,
	TLA2022_OP_SINGLE = 1
}TLA2022_MODE;

void tla2022Begin(void);
int16_t tla2022ReadAdc();
void tla2022SetFSR(TLA2022_FSR fsr);
void tla2022SetMode(TLA2022_MODE mode);
void tla2022SetDR(TLA2022_DR rate);

void tla2022WriteReg(uint8_t reg_addr, uint16_t data);
uint16_t tla2022ReadReg(uint8_t reg_addr);
*/



#include "CH58x_common.h"
#include "app_i2c.h"

#define TLA202X_DATA_REG 0x00
#define TLA202X_CONF_REG 0x01
#define TLA202X_I2C_ADDR 0x48

enum OperatingMode {
    OP_CONTINUOUS = 0,
    OP_SINGLE = 1
};

enum DataRate {
    DR_128SPS = 0x0,
    DR_250SPS = 0x1,
    DR_490SPS = 0x2,
    DR_920SPS = 0x3,
    DR_1600SPS = 0x4,
    DR_2400SPS = 0x5,
    DR_3300SPS = 0x6,
};

enum FullScaleRange {
    FSR_6_144V = 0x0,
    FSR_4_096V = 0x1,
    FSR_2_048V = 0x2,
    FSR_1_024V = 0x3,
    FSR_0_512V = 0x4,
    FSR_0_256V = 0x5,
};

enum MultiplexerConfig {
    MUX_AIN0_AIN1 = 0x0,
    MUX_AIN0_AIN3 = 0x1,
    MUX_AIN1_AIN3 = 0x2,
    MUX_AIN2_AIN3 = 0x3,
    MUX_AIN0_GND = 0x4,
    MUX_AIN1_GND = 0x5,
    MUX_AIN2_GND = 0x6,
    MUX_AIN3_GND = 0x7,
};
extern enum FullScaleRange currentFSR;
extern enum OperatingMode currentMode_ ;

extern uint16_t currentConf;
extern uint8_t channelToRead ;


BOOL TLA202xBegin(void);

void setFullScaleRange(enum FullScaleRange range);
void tla202xSetDR(enum DataRate rate);
int16_t tla202xADC0();
void tla202xSetOperatingMode(enum OperatingMode mode) ;
void tla202xSetMuxConfig(enum MultiplexerConfig option, bool write);

int16_t analogRead(uint8_t channel);
int16_t read_adc() ;
float getCurrentFullRangeVoltage();
float getVoltageResolution();

float voltageRead(uint8_t channel);
uint16_t tla202xReadReg(uint8_t reg);

int tla202xWriteReg(uint8_t reg,uint16_t value);

#endif
