#include "NDEF_TEXT.h"

const sNDEFTextSettings_t NDEFTextDefaultSettings = {'T', {(UTF8 << 7) | 2, 'e', 'n'}};

eNDEFStatus_t NDEF_Text_Init(sNDEFTLV_t *pMsg, uint8_t *pDat, size_t len)
{
    if ((len + 3) > NDEF_RECORD_PAYLOAD_BUFFER_SIZE)
    {
        return NDEF_ERROR_BUFFER_OVERFLOW;
    }

    memset(pMsg, 0, sizeof(pMsg));
    if (len < (0xFC))
    {
        pMsg->record.shortRecord = 1;
    }
    else if (len < 0x3FC)
    {
        pMsg->record.shortRecord = 0;
    }
    else
    {
        // 涓嶆敮鎸佸垎鍖哄潡 NDEF 娑堟伅
        return NDEF_ERROR;
    }

    pMsg->record.messageBegin   = 1;
    pMsg->record.messageEnd     = 1;
    pMsg->record.chunkFlag      = 0;
    pMsg->record.idLengthFlag   = 0;
    pMsg->record.typeNameFormat = WELL_KNOWN_TYPE;
    pMsg->record.typeLength     = 1;
    pMsg->record.payloadLength  = len + 3;
    pMsg->record.id             = NULL;
    recordType[0]               = 'T';

    memcpy(recordPayload, NDEFTextDefaultSettings.NDEFTextStatus, sizeof(NDEFTextDefaultSettings.NDEFTextStatus));
    memcpy(recordPayload + sizeof(NDEFTextDefaultSettings.NDEFTextStatus), pDat, len);

    return NDEF_Init(pMsg);
}
