#ifndef NDEF_TEXT_H
#define NDEF_TEXT_H

#include "NDEF.h"

/*
 * NDEF NFC-TAG 在 E2PROM 中按照下列格式保存
 *
 * +---------------+
 * |    CCFile     |
 * +---------------+
 * |    NDEF 1     |
 * |    NDEF 2     |
 * |      ...      |
 * +---------------+
 * |     Term      |
 * +---------------+
 *
 * CCFile NDEF Term 都使用 TLV 进行封装
 */

typedef enum
{
    UTF8  = 0,
    UTF16 = 1
} eEncodeing_t;

typedef struct
{
    uint8_t NDEFTextType;
    uint8_t NDEFTextStatus[3];
} sNDEFTextSettings_t;

extern const sNDEFTextSettings_t NDEFTextDefaultSettings;

// 初始化一个 NDEF Text 消息，只支持单个 Record
eNDEFStatus_t NDEF_Text_Init(sNDEFTLV_t *pMsg, uint8_t *pDat, size_t len);

#endif