#ifndef FLASH_H
#define FLASH_H
#include "CH58x_common.h"
#include "csv.h"
#define WRITE_ENABLE 0x06
#define WRITE_DISABLE 0x04
#define PAGE_PROGRAM 0x02
#define READ_STATUS_REGISTER_1 0x05
#define READ_DATA 0x03
#define CHIP_ERASE 0xC7
#define POWER_DOWN 0xB9
#define RELEASE_POWER_DOWN 0xAB
#define MANUFACTURER_ID 0x90
#define W25Q_BLOCK_ADDR_START  0x000000
//W25Q内存结束地址
#define W25Q_BLOCK_ADDR_END    0xFFFFFF
#define W25Q_SECTOR_NUMBER  4096
//W25Q系列的块的数量
#define W25Q_BLOCK_NUMBER  256
#define W25Q_CMD_SECTOR_ERASE       0x20
//W25Q系列的页大小为256字节
#define W25Q_PAGE_SIZE 256
//W25Q系列的扇区大小为4KB = 4096Bytes
#define W25Q_SECTOR_SIZE 4096
    void flashInit();
    void write(unsigned int page, int pageAddress, int val);
    uint8_t read(unsigned int page, int pageAddress);
    //void initStreamWrite(unsigned int page, byte pageAddress);
    //void streamWrite(UINT8 val);
    //void closeStreamWrite();
    //void initStreamRead(unsigned int page, byte pageAddress);
    //UINT8 streamRead();
    //void closeStreamRead();
    void spiFlashPowerDown();
    void releasePowerDown();
    void chipErase();
    uint8_t manufacturerID();
    void notBusy();
    void writeEnable();
    void writeDisable();


    void readFlash(uint32_t addr,void*pBuf,uint16_t len);
    void writeFlash(uint32_t addr,void*pBuf,uint16_t len);
    void eraseSector(uint32_t addr, BOOL isFirstAddr);
    void SPI_Flash_Erase_Sector(uint32_t Dst_Addr);
    void SPI_Flash_Read(uint8_t *pBuffer, uint32_t ReadAddr, uint16_t size);
    void SPI_Flash_Write_Page(uint8_t *pBuffer, uint32_t WriteAddr, uint16_t size);
    void SPI_Flash_Write_NoCheck(uint8_t *pBuffer, uint32_t WriteAddr, uint16_t size);
    void SPI_Flash_Write(uint8_t *pBuffer, uint32_t WriteAddr, uint16_t size);
    void SPI_Flash_Erase_Chip(void);
#endif
