#include "diskio.h"
#include "string.h"
#include "flash.h"
#include "usbIo.h"
//#define FLASH_START_ADDR  0x00040000 /*addr start from 256k */
#define FLASH_START_ADDR  0x00000000 /*addr start from 256k */
#define FLASH_BLOCK_SIZE  4096
#define FLASH_BLOCK_COUNT 1024

int USB_disk_status(void)
{
    if( manufacturerID(  ) == 0xef )
    {
        return 0;
    }
    return 1;
}
int USB_disk_initialize(void)
{
    flashInit(  );
    return RES_OK;
}
int USB_disk_read(uint8_t *buff, uint32_t sector, uint32_t count)
{
    SPI_Flash_Read( (uint8_t *)buff, FLASH_START_ADDR + sector * FLASH_BLOCK_SIZE, count );
    return 0;
}
int USB_disk_write(const uint8_t *buff, uint32_t sector, uint32_t count)
{
    SPI_Flash_Erase_Sector(FLASH_START_ADDR + sector * FLASH_BLOCK_SIZE);
    SPI_Flash_Write( (uint8_t *)buff, FLASH_START_ADDR + sector * FLASH_BLOCK_SIZE, count);
    return 0;
}
int USB_disk_ioctl(uint8_t cmd, void *buff)
{
    int result = 0;

    switch (cmd) {
        case CTRL_SYNC:
            result = RES_OK;
            break;

        case GET_SECTOR_SIZE:
            *(uint16_t *)buff = FLASH_BLOCK_SIZE;
            result = RES_OK;
            break;

        case GET_BLOCK_SIZE:
            *(uint32_t *)buff = 1;
            result = RES_OK;
            break;

        case GET_SECTOR_COUNT:
            *(uint32_t *)buff = FLASH_BLOCK_COUNT;
            result = RES_OK;
            break;

        default:
            result = RES_PARERR;
            break;
    }

    return result;
}
