# 设置目录列表
$directories = @("./src", "./UserPeriphDriver", "./AT")

# 遍历每个目录
foreach ($directory in $directories) {
    # 获取目录下的所有 .c、.cpp、.h 文件
    $files = Get-ChildItem -Path $directory -Recurse -Include *.c,*.cpp,*.h | Where-Object { -not $_.PSIsContainer }

    # 遍历每个文件
    foreach ($file in $files) {
        # 使用 clang-format 格式化文件
        ./clang-format.exe -i --style=google $file.FullName
        Write-Host "Formatted file: $($file.FullName)"
    }
}

Write-Host "Formatting complete."
