/*!
 * \file      eeprom-board.c
 *
 * \brief     Target board EEPROM driver implementation
 *
 * \copyright Revised BSD License, see section \ref LICENSE.
 *
 * \code
 *                ______                              _
 *               / _____)             _              | |
 *              ( (____  _____ ____ _| |_ _____  ____| |__
 *               \____ \| ___ |    (_   _) ___ |/ ___)  _ \
 *               _____) ) ____| | | || |_| ____( (___| | | |
 *              (______/|_____)_|_|_| \__)_____)\____)_| |_|
 *              (C)2013-2017 Semtech
 *
 * \endcode
 *
 * \author    Miguel Luis ( Semtech )
 *
 * \author    Gregory Cristian ( Semtech )
 */
#include "utilities.h"
#include "eeprom-board.h"
#include "HAL.h"
LmnStatus_t EepromMcuWriteBuffer( uint16_t addr, uint8_t *buffer, uint16_t size )
{
    LmnStatus_t status = LMN_STATUS_ERROR;
    uint8_t s = 0;
  //  assert_param( ( 0 + addr ) >= 0 );
   // assert_param( buffer != NULL );
   // assert_param( size < ( 4096) );
   // printf("write addr = %d\n",addr);

    CRITICAL_SECTION_BEGIN( );
    s = EEPROM_ERASE(addr, EEPROM_BLOCK_SIZE);

    if(s == 0){
        status = LMN_STATUS_OK;
    }
    s = EEPROM_WRITE(addr, buffer, size);
    if(s == 0){

        status = LMN_STATUS_OK;

    }
    CRITICAL_SECTION_END( );


    //printf("status =%d\n",status);

   // EEPROM_READ(0, buffer, size);
    return status;
}

LmnStatus_t EepromMcuReadBuffer( uint16_t addr, uint8_t *buffer, uint16_t size )
{
   // assert_param( ( 0 + addr ) >= 0 );
   // assert_param( buffer != NULL );
   // assert_param( size < ( 4096) );
   // printf("read addr = %d\n",addr);
    EEPROM_READ(addr, buffer, size);
    //printf("%d\n",buffer[1]);
   // printf("%d\n",buffer[2]);
   // printf("%d\n",buffer[3]);
    //printf("%d\n",buffer[4]);

    return LMN_STATUS_OK;


}

void EepromMcuSetDeviceAddr( uint8_t addr )
{
    assert_param( LMN_STATUS_ERROR );
}

LmnStatus_t EepromMcuGetDeviceAddr( void )
{

    assert_param( LMN_STATUS_ERROR );
    return 0;
}
