#ifndef __COMM_H
#define __COMM_H

#include "utils.h"
/*
+--------------------------------------------------+--------------+
|    FW0              start: 0x00000000  (200KB)   |              |
|                     end :  0x00031FFF            |              |
+--------------------------------------------------|  CODE FLASH  |
|    FW1              start: 0x00032000 (200KB)    |   (448KB)    |
|                     end:   0x00063FFF            |              |
+--------------------------------------------------|              |
|    RESERVED         start:   0x00064000 (48KB)   |              |
|    FOR CSV                   0x0006FFFF          |              |
+--------------------------------------------------+--------------+
|    BOOT             start: 0x00070000   (8KB)    |              |
|                            0x00071FFF            |              |
+--------------------------------------------------|              |
|    CONFIG        start: 0x00072000  (2KB)        |  DATA FLASH  |
|                         0x000727FF               |   (32KB)     |
+--------------------------------------------------|              |
|    DFBC             start: 0x00072800   (2KB)    |              |
|                            0x00072FFF            |              |
+--------------------------------------------------|              |
|    LOG              start: 0x00073000   (20KB)   |              |
|                            0x00077FFF            |              |
+--------------------------------------------------+--------------+
*/

#define BOOT_CODE_ADDR      0x00070000
#define CONFIG_ADDR         0x00072000
#define APP_CODE_START_ADDR 0x00032000
#define APP_CODE_END_ADDR   0x00063FFF
#define DFBC_ADDR           0x00072800
#define DF_BOOT_SIZE   8*1024

#define    DF_LORAMAC_REGION_AS923 0
#define    DF_LORAMAC_REGION_AU915 1
#define    DF_LORAMAC_REGION_CN470 2
#define    DF_LORAMAC_REGION_CN779 3
#define    DF_LORAMAC_REGION_EU433 4
#define    DF_LORAMAC_REGION_EU868 5
#define    DF_LORAMAC_REGION_KR920 6
#define    DF_LORAMAC_REGION_IN865 7
#define    DF_LORAMAC_REGION_US915 8
#define    DF_LORAMAC_REGION_RU864 9


#define SWVERSION  "V0.7.5"
#define SN_AS_EUI
//#define DFROBOT_DUTYCYCLE_ON
#define ACTIVE_REGION DF_LORAMAC_REGION_EU868
//#define ACTIVE_REGION DF_LORAMAC_REGION_US915


#if (ACTIVE_REGION == DF_LORAMAC_REGION_EU868)
	#define ACTIVE_REGION_STR "EU868"
#elif (ACTIVE_REGION == DF_LORAMAC_REGION_US915)
	#define ACTIVE_REGION_STR "US915"
#elif (ACTIVE_REGION == DF_LORAMAC_REGION_CN470)
	#define ACTIVE_REGION_STR "CN470"
#endif


#endif
