

#include "csv.h"


BOOL spiFlashWork =FALSE;
#ifdef     CSV_ENABLE
uint8_t csvBuffer[4096];
#endif
uint32_t lastRowAddr = 0;

#define  PART1_STARTADDR  0x64000

#define  PART2_STARTADDR  0x00000

#define  PART1_LEN  0xC000
#define  PART2_LEN  0x5000

#define  ITEM_LEN  109
void uint_to_centered_string(uint32_t num, char *buffer, size_t buffer_size) {
    // 计算数字字符串的长度
    int num_length = snprintf(NULL, 0, "%u", num);

    // 计算左侧和右侧的空格数量
    int left_padding = (buffer_size - num_length) / 2;
    int right_padding = buffer_size - num_length - left_padding;

    // 使用 snprintf 将数字格式化为居中的字符串
    snprintf(buffer, buffer_size, "%*s%u%*s", left_padding, " ", num, right_padding+1, " ");
}

void csvWrite(sCsvData_t csvData)
{

#ifdef     CSV_ENABLE
  char csvString[120];
  memset(csvString,0,120);
  //printf("unixEpoch=%d\n",dtuConfig.hardPara.unixEpoch);


  //时间戳数据为字符串，并居中
  csvData.timeStamp = dtuConfig.hardPara.unixEpoch;
  uint_to_centered_string(csvData.timeStamp,csvString,10);



  csvString[strlen(csvString)]=  ',';

  //ADC
  for(uint8_t i=0 ; i< 2 ;i++){
    if(dtuConfig.loopOperation.adc[i].enable){

        char floatString[10];
        floatToString(csvData.AI[i],floatString,2);
        memcpy(csvString+strlen(csvString),floatString,4);
        //sprintf(csvString+strlen(csvString),"%f\n",3.14);

    }else{
       memcpy(csvString+strlen(csvString),"   ",3);

    }
    csvString[strlen(csvString)]=  ',';
  }
  //IOIN
  for(uint8_t i =0;i<4;i++){
    if(dtuConfig.loopOperation.ioIn[i].enable){
       if(dtuConfig.loopOperation.ioIn[i].pinValue == 1){
           memcpy(csvString+strlen(csvString),"    H    ",9);
       }else {
           memcpy(csvString+strlen(csvString),"    L    ",9);
       }

    }//IOCNT
    else if(dtuConfig.loopOperation.ioCount[i].enable){

        //itoa(csvData.DI[i],csvString+strlen(csvString),10);
        uint_to_centered_string(csvData.DI[i],csvString+strlen(csvString),10);

    }else{

        memcpy(csvString+strlen(csvString),"         ",9);

    }

    csvString[strlen(csvString)]=  ',';
  }

  //RS485
  for(uint8_t i =0;i<8;i++){

      if(dtuConfig.loopOperation.rs485item[i].enable){
         // itoa(csvData.RS485[i],csvString+strlen(csvString),10);
          uint_to_centered_string(csvData.RS485[i],csvString+strlen(csvString),6);
      }else{
          memcpy(csvString+strlen(csvString),"     ",5);
      }
      csvString[strlen(csvString)]=  ',';
  }

  itoa(csvData.upload,csvString+strlen(csvString),10);

  csvString[strlen(csvString)]= 0x0d;
  csvString[strlen(csvString)]=  0x0a;



  //NvmmWrite(&dtuConfig,sizeof(sDtuConfig_t),DF_BOOT_SIZE);
  //memcpy(csvString+strlen(csvString),' ',ITEM_LEN- strlen(csvString));
  //写入csv
  flashWrite(csvString,dtuConfig.hardPara.addr,ITEM_LEN);
  dtuConfig.hardPara.rowCsv++;
  lastRowAddr = dtuConfig.hardPara.addr;
  dtuConfig.hardPara.addr += ITEM_LEN;
#endif
}
static uint8_t part = 1;
void dataFlash_Write(uint8_t *pBuffer, uint32_t WriteAddr, uint16_t len)
{
#ifdef     CSV_ENABLE
    uint32_t write_len = len;
    uint32_t section = 0;
    uint32_t offset = 0;
    uint32_t remain = 0;
   // printf("write_len=%d\n",write_len);
    while (len > 0)
    {
        if(WriteAddr >= 0xC000){

            part = 2;

        }else{

            part = 1;
        }

        section = WriteAddr / 4096;
        offset = WriteAddr % 4096;
        remain = 4096 - offset;
        if (len > remain)
        {
            write_len = remain;
        }
        else
        {
            write_len = len;
        }

        if(part == 1){


           uint8_t *data       = (uint8_t *)(PART1_STARTADDR +section * 4096);
           for (int j = 0; j < 4096; j++)
           {
               csvBuffer[j] = data[j];
           }
           FLASH_ROM_ERASE(PART1_STARTADDR +section * 4096, 4096);
         //  printf("erase =0x%x\r\n",PART1_STARTADDR +section * 4096);


        }else if(part == 2){

            EEPROM_READ(section * 4096 -PART1_LEN, csvBuffer, 4096);
            EEPROM_ERASE(section * 4096 -PART1_LEN,4096);
        }

        for (uint32_t j = 0; j < write_len; j++)
        {
                csvBuffer[offset + j] = pBuffer[j];
        }

        if(part == 1){

           // printf("write =0x%x\r\n",PART1_STARTADDR +section * 4096);
            FLASH_ROM_WRITE(PART1_STARTADDR +section * 4096, csvBuffer, 4096);
        //W25QXX_Write_NoCheck(csvBuffer, section * 1024, 1024);
        }else if(part == 2){
            EEPROM_WRITE(section * 4096 -PART1_LEN, csvBuffer, 4096);
        }
        len -= write_len;
        pBuffer += write_len;
        WriteAddr += write_len;
        if(len == 0) break;
    }
#endif
}


void W25QXX_Write(uint8_t *pBuffer, uint32_t WriteAddr, uint16_t len)
{
#ifdef     CSV_ENABLE
    uint32_t write_len = len;
    uint32_t section = 0;
    uint32_t offset = 0;
    uint32_t remain = 0;
    uint8_t erase = 0;
    while (len > 0)
    {
        erase = 0;
        section = WriteAddr / 4096;
        offset = WriteAddr % 4096;
        remain = 4096 - offset;
        if (len > remain)
        {
            write_len = remain;
        }
        else
        {
            write_len = len;
        }
            readFlash(section * 4096 ,csvBuffer,4096);

            eraseSector(section*4096,true); //擦除这个扇区
            for (uint32_t j = 0; j < write_len; j++)
            {
                csvBuffer[offset + j] = pBuffer[j];
            }

            //printf("WriteAddr =%d\r\n",WriteAddr);


            for(uint16_t i=0;i<4096;i+=256){
             writeFlash(section * 4096 +i,csvBuffer+i,256);
            }

        len -= write_len;
        pBuffer += write_len;
        WriteAddr += write_len;
    }
#endif

}
uint8_t flashWrite(uint8_t*buffer,uint32_t addr,uint16_t len){

     //先读取 addr 扇区的4096个字节到 csvBuffer
     //把要写的数据放到 csvBuffer对应位置
     //再把原数据放回去
    if(spiFlashWork == TRUE){
         //如果最后一个条目写入超过了存储区的大小，则从第一行开始覆写
        if((addr +ITEM_LEN)>0x400000){

            dtuConfig.hardPara.addr = ITEM_LEN;
            addr = ITEM_LEN;
            dtuConfig.hardPara.rowCsv = 1;
        }

       //w25q 写入函数

        W25QXX_Write(buffer,addr,len);
    }else{
        if((addr +ITEM_LEN)>0x11000){

            dtuConfig.hardPara.addr = ITEM_LEN;
            addr = ITEM_LEN;
            dtuConfig.hardPara.rowCsv = 1;
        }

        dataFlash_Write(buffer,addr,len);

    }


}
uint8_t flashRead(uint8_t*buffer,uint32_t row,uint16_t len){

    uint32_t addr =  row*ITEM_LEN;
    if(spiFlashWork == TRUE){
        if((addr +ITEM_LEN)>0x400000) return 0;
        readFlash(addr,buffer,len);


    }else{

        if((addr +ITEM_LEN)>0x11000) return 0;


        if( addr <  0xC000){
           // printf("read =0x%x\r\n",PART1_STARTADDR +addr);
            uint8_t *data       = (uint8_t *)(PART1_STARTADDR +addr);
            for (int j = 0; j < len; j++)
            {
                buffer[j] = data[j];
            }

        }else{
            EEPROM_READ(addr -PART1_LEN, buffer, len);

        }

    }

  return 1;
}
uint8_t flashReadAddr(uint8_t*buffer,uint32_t addr,uint16_t len){
    if(spiFlashWork == TRUE){
        if((addr +ITEM_LEN)>0x400000) return 0;
        readFlash(addr,buffer,len);


    }else{

        if((addr +ITEM_LEN)>0x11000) return 0;


        if( addr <  0xC000){
           // printf("read =0x%x\r\n",PART1_STARTADDR +addr);
            uint8_t *data       = (uint8_t *)(PART1_STARTADDR +addr);
            for (int j = 0; j < len; j++)
            {
                buffer[j] = data[j];
            }

        }else{
            EEPROM_READ(addr -PART1_LEN, buffer, len);

        }

    }

  return 1;
}
BOOL charISexist(char *str,char cha){


    for(uint8_t i=0;i<10; i++){


      if(str[i] == cha){

          return TRUE;
      }

    }
    return FALSE;
}


uint8_t getUploadFlag(uint32_t row){
    char dataStr[109];
    flashRead(dataStr,row,109);

    uint8_t flag = atoi(dataStr[106]);


    return dataStr[106] - 0x30;
}

void setUploadFlag(uint32_t row,uint8_t isSuccess)
{
   //printf("setFlag\n");
    char dataStr[109];
    flashRead(dataStr,row,109);
    dataStr[106] = '1';

    if(spiFlashWork == TRUE){
        W25QXX_Write(dataStr,row*109,109);
    }else{
        dataFlash_Write(dataStr,row*109,109);
    }


}
//获取下一个需要补传的条目
uint32_t getNextRetrans(uint32_t lastReRow)
{

  for(uint32_t i = lastReRow;i < dtuConfig.hardPara.rowCsv; i++){

      if(!getUploadFlag(i)){
         // printf("i=%d\n",i);
           dtuConfig.loopOperation.lastRow = i;
         return i;
      }
  }
  return 0xFFFFFFFF;
}

//把csv文件转化为hex数组
uint8_t  csvItemToHex(uint32_t row,uint8_t *dataBuffer)
{
    char dataStr[109]=" ";
    sCsvData_t csvDataB;
    uint8_t dataLen;
    char *p;
    char p1[4][10];
    uint8_t ioFlag = 0;

    flashRead(dataStr,row,109);

    //通过','分割每一个参数
    p = strtok(dataStr,",");



    if(p){
        csvDataB.timeStamp = atoi(p);
    }

    dataBuffer[dataLen++] = dtuConfig.loopOperation.adcMask;

    //adc
    for(uint8_t i=0 ; i< 2 ;i++){
      if(dtuConfig.loopOperation.adc[i].enable){
          uint8_t floatString[10];
          p = strtok(NULL,",");
          if(p){
             float adc =  strtod(p,NULL);

              dtuConfig.loopOperation.adc[i].adc1Value = adc*1000;
          }
          dataBuffer[dataLen++] = dtuConfig.loopOperation.adc[i].adc1Value&0xFF;
          dataBuffer[dataLen++] = dtuConfig.loopOperation.adc[i].adc1Value>>8;
      }else{
          p = strtok(NULL,",");
      }
    }

    dataBuffer[dataLen++]=dtuConfig.loopOperation.countMask;
    //IOCNT

    for(uint8_t i =0;i<4;i++){
        p = strtok(NULL,",");
        memcpy(p1[i],p,10);
        if(dtuConfig.loopOperation.ioCount[i].enable){
          if(p){
            csvDataB.DI[i] = atoi(p);
          }
          dataBuffer[dataLen++] = csvDataB.DI[i];
          dataBuffer[dataLen++] = csvDataB.DI[i]&0xff;
          dataBuffer[dataLen++] = csvDataB.DI[i]&0xff;
          dataBuffer[dataLen++] = csvDataB.DI[i]&0xff;
      }
    }

    dataBuffer[dataLen++] = dtuConfig.loopOperation.ioMask;
    //IOIN
       for(uint8_t i =0;i<4;i++){

        if(dtuConfig.loopOperation.ioIn[i].enable){
            ioFlag = 1;
            if(p1[i]){
                if(charISexist(p1[i],'H')){
                    csvDataB.DI[i] = 1;
                }else{
                    csvDataB.DI[i] = 0;
                }
                dtuConfig.loopOperation.ioValue = dtuConfig.loopOperation.ioValue | (csvDataB.DI[i]<<i);


            }
        }

    }
   if(ioFlag == 1){
      dataBuffer[dataLen++] = dtuConfig.loopOperation.ioValue;
   }

    dataBuffer[dataLen++]=dtuConfig.loopOperation.rs485Mask;
    dataBuffer[dataLen++]=dtuConfig.loopOperation.rs485Mask >> 8 ;

    //RS485
    for(uint8_t i =0;i<8;i++){
        p = strtok(NULL,",");

        if(dtuConfig.loopOperation.rs485item[i].enable){
            if(p){
                csvDataB.RS485[i] = atoi(p);
            }
            dataBuffer[dataLen++] = 0xC2;
            dataBuffer[dataLen++] = csvDataB.RS485[i];
            dataBuffer[dataLen++] = csvDataB.RS485[i]>>8;
        }
    }

    //电池
    dataBuffer[dataLen++]=0x03;
    dataBuffer[dataLen++]=getBatteryPower();

    //时间戳
    dataBuffer[dataLen++] = csvDataB.timeStamp;
    dataBuffer[dataLen++] = csvDataB.timeStamp>>8;
    dataBuffer[dataLen++] = csvDataB.timeStamp>>16;
    dataBuffer[dataLen++] = csvDataB.timeStamp>>24;
 return  dataLen;
}



void csvInit()
{

#ifdef     CSV_ENABLE
     // 写文件头
     if(dtuConfig.hardPara.addr == 0){
      char head[120]="time,AI1,AI2,DI1,DI2,DI3,DI4,RS485-1 ,RS485-2 ,RS485-3 ,RS485-4 ,RS485-5 ,RS485-6,RS485-7,RS485-8,uploaded \r\n";
      printf("size=%d\n",strlen(head));
      //memcpy(head+strlen(head),' ',111- strlen(head));
      dtuConfig.hardPara.rowCsv = 0;
      dtuConfig.hardPara.addr = 0;
      flashWrite(head,0,ITEM_LEN);
      dtuConfig.hardPara.rowCsv++;
      dtuConfig.loopOperation.lastRow = 1;
      dtuConfig.hardPara.addr += ITEM_LEN;
    }
#endif
}

void resetLastRow(){

  dtuConfig.hardPara.addr = lastRowAddr;
  dtuConfig.hardPara.rowCsv--;

}

