#include <LmHandlerTypes.h>
#include <timeScheduler.h>
#include "board.h"

uint8_t is_dfbc_valid = 0;
uint8_t is_io_count = 0;

void enable3V3(){
    GPIOA_ModeCfg(GPIO_Pin_3, GPIO_ModeOut_PP_20mA);
    GPIOA_SetBits(GPIO_Pin_3);
}

void disable3V3(){
	if(!(is_dfbc_valid || is_io_count)){
		GPIOA_ModeCfg(GPIO_Pin_3, GPIO_ModeIN_Floating);
	}
}

static LmHandlerAppData_t AppData = {
    .Port = 0,
};

void lorawan_send(void * buf, size_t len) {
	AppData.Buffer = buf;
	AppData.BufferSize = len;
	if(LmHandlerJoinStatus( ) != LORAMAC_HANDLER_SET) {
		return;
	}
    if( LmHandlerSend( &AppData, dtuConfig.loraWanPara.isTxConfirmed ) == LORAMAC_HANDLER_SUCCESS ){
        setPackCount();
        data_blink(300);
    } else {
        sysLog("[log] send fail\r\n");
        dtuConfig.loopOperation.reTranNum++;
    }
}
