#include "modbus.h"
uint8_t modbuslock = 0;

int8_t execModbusItem(uint8_t i, uint8_t *rawdata, uint8_t *rawdatalen, float *retf){
	int8_t ret = 0;
	uint8_t dataLen;
	uint8_t buf[20];
	uint8_t index = 0;
	DBG("dtuConfig.loopOperation.rs485Mask=0x%04X\n",dtuConfig.loopOperation.rs485Mask);
    //最大支持八个指令，多测几个 和不同的数据类型
    //是否接收到传感器的回复
    uint8_t noReturn = 1;
    // 获取重试次数，每发一条指令，如果没有返回则会重传retry次
    uint8_t retry = 3;//dtuConfig.loopOperation.rs485Retry;
    //留一个位置给 表示(寄存器类型/错误码/数据类型)
    enable3V3();
    DelayMs(50);
    //错误处理 AT指令处理
    do {
        //在中断里面将接收的数据位置 置零
        uart0Iint( dtuConfig.loopOperation.rs485Baud[i],dtuConfig.loopOperation.rs485Config[i].value);
        rs485Flush();
        UART0_SendString(dtuConfig.loopOperation.rs485item[i].item, dtuConfig.loopOperation.rs485item[i].len);

        //接收超时时间，如果接收到数据就直接处理下一条指令
        uint32_t timeOut = dtuConfig.loopOperation.rs485item[i].nextDelay;
        TimerTime_t cur = getSysTime();
        do {
                    //安装outpower处理
                    processImmediate();
                    DelayMs(2);

                    //接收到传感器回复，recvDataFlag，表示接收到一个完整的包
                    if (dfserials[RS485_INTTERFACE_NUM].dataFlag == 1) {
                        dfserials[RS485_INTTERFACE_NUM].dataFlag = 0;
                        //数据长度
                        dataLen = dfserials[4].regLen;
                        DBG("---- dfserials[RS485_INTTERFACE_NUM].datalength=%d\n", dfserials[RS485_INTTERFACE_NUM].datalength);
                        if(rawdata){
                        	*rawdatalen = dfserials[RS485_INTTERFACE_NUM].datalength;
                        	memcpy(rawdata, dfserials[RS485_INTTERFACE_NUM].recvBuffer, dfserials[RS485_INTTERFACE_NUM].datalength);
                        	for(int k=0; k<dfserials[RS485_INTTERFACE_NUM].datalength; k++) {
                        		printf("%02X ", dfserials[RS485_INTTERFACE_NUM].recvBuffer[k]);
                        	}
                        }
                        printf("\n");
                        //将传感器寄存器的数据写入待上传的数据包
                        float result;
                        uint32_t _data;
                        uint8_t *_p = &_data;
                        memcpy(_p, &dfserials[RS485_INTTERFACE_NUM].recvBuffer[3], dataLen);
                        if(dtuConfig.loopOperation.rs485item[i].dataType == 'U') {
                        	if(dataLen == 2){
                    		    uint16_t data;
                        	    if(dtuConfig.loopOperation.rs485item[i].byteOrder == MODBUS_BYTEORDER_AB) {
                        		    memcpy(&data, _p, 2);
                        		    data = swap16(data);
                        		    DBG("--unsigned---data=0x%04X\n", data);
                        	    }
                        	    result = data * dtuConfig.loopOperation.rs485item[i].param1 + dtuConfig.loopOperation.rs485item[i].param2;
                        	}else if(dataLen == 4) {
                    		    uint32_t data;
                    		    memcpy(&data, _p, 4);
                    		    if(dtuConfig.loopOperation.rs485item[i].byteOrder == MODBUS_BYTEORDER_ABCD){
                        		    data = swap32(data);
                        		    DBG("-signed----data=0x%04X\n", data);
                        	    }
                                result = data * dtuConfig.loopOperation.rs485item[i].param1 + dtuConfig.loopOperation.rs485item[i].param2;
                        	}
                        }else if(dtuConfig.loopOperation.rs485item[i].dataType == 'S') {
                        	if(dataLen == 2){
                    		    int16_t data;
                    		    memcpy(&data, _p, 2);
                    		    if(dtuConfig.loopOperation.rs485item[i].byteOrder == MODBUS_BYTEORDER_AB){
                    		    	//DBG("---------signed----data=0x%04X   p[0]=%x p[1]=%x\n", data, _p[0], _p[1]);
                    		    	data = _p[0]*256 + _p[1];//swap16(data);
                        		    DBG("-----swap----signed----data=0x%04X\n", data);
                        	    }
                                result = data * dtuConfig.loopOperation.rs485item[i].param1 + dtuConfig.loopOperation.rs485item[i].param2;
                        	}else if(dataLen == 4) {
                    		    int32_t data;
                    		    memcpy(&data, _p, 4);
                    		    if(dtuConfig.loopOperation.rs485item[i].byteOrder == MODBUS_BYTEORDER_ABCD){
                        		    data = swap32(data);
                        		    DBG("-signed----data=0x%04X\n", data);
                        	    }
                                result = data * dtuConfig.loopOperation.rs485item[i].param1 + dtuConfig.loopOperation.rs485item[i].param2;
                        	}
                        }else if(dtuConfig.loopOperation.rs485item[i].dataType == 'F') {
                        	DBG("dataType=======F  dataLen=%d\n",dataLen);
                            if(dataLen == 4) {
                    		    float data;
                    		    memcpy(&data, _p, 4);
                    		    if(dtuConfig.loopOperation.rs485item[i].byteOrder == MODBUS_BYTEORDER_ABCD){
                        		    uint32_t tmp;
                        		    memcpy(&tmp, _p, 4);
                                    tmp = swap32(tmp);
                                    memcpy(&data, &tmp, 4);
                        	    }
                                result = data * dtuConfig.loopOperation.rs485item[i].param1 + dtuConfig.loopOperation.rs485item[i].param2;
                        	}
                        }
                        DBG("dtuConfig.loopOperation.rs485item[i].param1=%.2f\n",dtuConfig.loopOperation.rs485item[i].param1);
                        DBG("dtuConfig.loopOperation.rs485item[i].param2=%.2f\n",dtuConfig.loopOperation.rs485item[i].param2);
                        DBG("result=%.3f\n",result);
                        DBG("Modubs i=%d  dtuConfig.loopOperation.rs485item[i].dataType=%c\n",i,dtuConfig.loopOperation.rs485item[i].dataType);
                        //index++;
                        DBG("index=%d\n",index);
                        _p = (uint8_t *)&result;
                        buf[index++] = (1<<6) + (dtuConfig.loopOperation.rs485item[i].byteOrder << 3) + 4;
                        for(uint8_t i = 0; i < 4; i++){
                        	printf("%02X ",_p[i]);
                            buf[index++] = _p[i];
                        }
                        *retf = result;
                        DBG("index=%d\n",index);
                        printf("\n");
                        //接收到回复
                        noReturn = 0;
                        break;
                    } else {
                    	//DBG("dfserials[RS485_INTTERFACE_NUM].dataFlag=%d\n",dfserials[RS485_INTTERFACE_NUM].dataFlag);
                    }
                }while ((getSysTime() - cur) < timeOut);
                if (timeOut != 0) {
                    break;
                }
                if(noReturn == 0) break;
            } while (retry-- > 0);

    		disable3V3();
            //(寄存器类型/错误码/数据类型)数据处理
            if(noReturn == 1){
                uint8_t dataInf = 0;
                //数据长度
                dataInf =0;
                //错误类型
                dataInf =dataInf | (MODBUS_BYTEORDER_ERROR<<3);
                //01H 读线圈寄存器
                //02H 读离散输入寄存器
                //03H 读保持寄存器
                //04H 读输入寄存器
                //功能码表示寄存器类型
                dataInf =dataInf | (1<<6);
                buf[index++] = dataInf;
                DBG("index=%d\n",index);
                DBG("i=%d dataInf=0x%x\n", i, dataInf);
                ret = -1;
            }else{
                //uint8_t dataInf = 0;
                //数据长度
                //dataInf = dfserials[4].regLen;
                //dataInf |= ((dfserials[RS485_INTTERFACE_NUM].recvBuffer[1]-1)<<6);
                //dataInf |= (dtuConfig.loopOperation.rs485item[i].byteOrder << 3);
                //buf[index-3] = dataInf;
                //DBG("index=%d\n",index);
                //DBG("i=%d dataInf=0x%x\n", i, dataInf);
            }
    return ret;
}
