/*
 * test.c
 *
 *  Created on: May 23, 2024
 *      Author: Administrator
 */
#include "test.h"
#include "CH58x_common.h"
#include "DFLora_At.h"
#include "LmHandlerTypes.h"
#include "comm.h"
#include "dfbc.h"

extern volatile sDFBCEvents_t dfbcEvents;

void printPacket(LmHandlerAppData_t * packet){
    uint8_t str[200]={0};//最大的长度为57
    sprintf(str,"appData: ");
    uint8_t strllen = strlen(str);
    for(uint8_t i = 0 ;i<packet->BufferSize; i++){
        sprintf(str+strllen+3*i, "%2x,",packet->Buffer[i]);
    }
    str[strlen(str)]='\n';
    DBG("%s",str);
}

void processCharging(void){
    uint16_t mV = BQ25672_getBatteryVoltage();
	uint8_t reg13 = BQ25672_read_bytes(0x13,1);
	DBG("reg13=%02X\n",reg13);
    if(reg13 & 0xC0){
	   	if(mV >3000){
	   	  if(reg13 & 0x40){
	   	    uint8_t mppt= 0xab;
	   	    BQ25672_write_bytes(0x15, mppt, 1);
	   	  }
	      DBG("start charging...........battery=%d mV\n",mV);
	      BQ25672_write_bytes(0x0F, 0xB2, 1);
	    }
	}else{
		DBG("end charging...........battery=%d mV\n",mV);
		BQ25672_write_bytes(0x0F, 0x42, 1);
	}
}

void test_BQ25672(void){
    extern volatile uint8_t bqint;
    bqint = 0;
    /*
    DBG("------------------ BATTERY ------------------------\n");
	GPIOA_ModeCfg(GPIO_Pin_6, GPIO_ModeIN_PD);
	uint8_t reg14 = BQ25672_read_bytes(0x14,1);
	BQ25672_write_bytes(0x14, reg14|(1<<7), 1);


    GPIOB_ModeCfg(GPIO_Pin_3,GPIO_ModeIN_PU);
    GPIOB_ITModeCfg(GPIO_Pin_3,GPIO_ITMode_RiseEdge);
    PFIC_EnableIRQ(GPIO_B_IRQn);


    while(1){
        uint16_t val = BQ25672_getBatteryVoltage();
        uint8_t stat = BQ25672_read_bytes(0x1c,1) >> 5;
        int16_t current = BQ25672_getBatteryCurrent();
        uint8_t vbus = GPIOA_ReadPortPin(GPIO_Pin_6);
        DBG("-----------------------------------------\n");
        DBG("battery = %d mV  stat=0x%x  current=%d mA   vbus=%d\n", val, stat, current, (vbus!=0));
        uint8_t reg13 = BQ25672_read_bytes(0x13,1);
        DBG("reg13=%02X\n",reg13);
        uint8_t reg0f = BQ25672_read_bytes(0x0f,1);
        DBG("reg0f=%02X\n",reg0f);
        uint8_t reg22 = BQ25672_read_bytes(0x22,1);
        DBG("reg22=%02X\n",reg22);
        reg14 = BQ25672_read_bytes(0x14,1);
        DBG("reg14=%02X\n",reg14);
        uint8_t reg10 = BQ25672_read_bytes(0x10,1);
        DBG("reg10=%02X\n",reg10);
        uint8_t reg28 = BQ25672_read_bytes(0x28,1);
        DBG("reg28=%02X\n",reg28);
        uint8_t reg29 = BQ25672_read_bytes(0x29,1);
        DBG("reg29=%02X\n",reg29);
        uint8_t reg2A = BQ25672_read_bytes(0x2A,1);
        DBG("reg2A=%02X\n",reg2A);
        uint8_t reg2B = BQ25672_read_bytes(0x2B,1);
        DBG("reg2B=%02X\n",reg2B);
        uint8_t reg2C = BQ25672_read_bytes(0x2C,1);
        DBG("reg2C=%02X\n",reg2C);
        uint8_t reg2D = BQ25672_read_bytes(0x2D,1);
        DBG("reg2D=%02X\n",reg2D);
        uint8_t ext_vcc = BQ25672_read_bytes(0x1B,1) & 0x01;
        uint8_t charging = BQ25672_read_bytes(0x1C,1) >> 5;

        uint8_t mppt = BQ25672_read_bytes(0x15,1);
        DBG("MPPT=0x%02x\n", mppt);

        if(ext_vcc && charging){
        	if(stat == 0x07){
                DBG("charging bat full\n");
            }else if((stat == 0x00) || (stat == 0x01)){
        		BQ25672_write_bytes(0x0F, 0x42, 1);
        		uint8_t reg10 = BQ25672_read_bytes(0x10,1);
        		reg10 &= ~0x7;
        		BQ25672_write_bytes(0x10, reg10, 1);
            }else{
        	    DBG("charging bat current=%d mA\n", current);
        	}
        }else if(ext_vcc){
        	if(stat == 0x07){
        		DBG("charging bat full\n");
           	}else if(current < 0 ){
        		DBG("no charging, battery output current=%d\n",current);
        	}else{
        		DBG("ext vcc, no battery\n");
        		BQ25672_write_bytes(0x0F, 0x42, 1);
        		uint8_t reg10 = BQ25672_read_bytes(0x10,1);
        		reg10 &= ~0x7;
        		BQ25672_write_bytes(0x10, reg10, 1);
        	}
        }else if(( ext_vcc == 0 ) && ( charging == 0 )){
        	DBG("battery only current=%d mA\n",current);
        }

        for(int x=0; x<800; x++){
        	if(bqint){
        		bqint = 0;
                uint8_t reg13 = BQ25672_read_bytes(0x13,1);
                DBG("reg13=%02X\n",reg13);
                uint16_t mV = BQ25672_getBatteryVoltage();
                if(reg13 & 0xC0){
                	if(mV >2000){
                	  if(reg13 & 0x40){
                		  BQ25672_setMpptEnabled(true);
                	  }
                	  DBG("start charging...........battery=%d\n",mV>1000);
                	  BQ25672_write_bytes(0x0F, 0xB2, 1);
                	}
                }else{
                	DBG("end charging...........battery=%d\n",mV>1000);
                	BQ25672_write_bytes(0x0F, 0x42, 1);
                }
        	}
        	DelayMs( 10 );
        }
    }*/
}

void test_TLA2022(void){
    DBG("------------------ ADC ------------------------\n");
    tla202xBegin();
    int16_t val;

    while(1){
    	val = tla202xADC0();
        DBG("adc = %d mV \n", val*5);
        DelayMs( 300 );
    }
}

void test_VBUS(void){

}
#include "dfbc.h"
void test_DFBC(void){

}

extern uint8_t loralock;
uint8_t gmd5[35]={0};

void checkMD5(void){
    char md5[33] ={0};
    NvmmRead(gmd5,33,1024+512+DF_BOOT_SIZE);
    sprintf(str, "%02X%02X%02X%02X%02X%02X%02X%02X", dtuConfig.hardPara.sn[0], dtuConfig.hardPara.sn[1], dtuConfig.hardPara.sn[2], dtuConfig.hardPara.sn[3], dtuConfig.hardPara.sn[4], dtuConfig.hardPara.sn[5], dtuConfig.hardPara.sn[6], dtuConfig.hardPara.sn[7]);
    MD5(str,md5);
    DBG("md5=%s\n",md5);
    if(strcmp(gmd5, md5) == 0){
     	loralock = 0;
    }else{
        writeLog("[ERROR]Wrong MD5\r\n", getSysTime());
        loralock = 1;
    }
    loralock = 0;
}

void power12V( uint8_t on ){
    GPIOB_ModeCfg(GPIO_Pin_3, GPIO_ModeOut_PP_5mA);
    if(on) {
    	GPIOB_SetBits(GPIO_Pin_3);
    } else {
    	GPIOB_ResetBits(GPIO_Pin_3);
    }
}

void pollHW( void ){
    if(dtuConfig.loopOperation.adc[0].enable == 1){
    	tla202xBegin();
        dfbcEvents.ADC0 = tla202xADC0() * 5;
        disable3V3();
    	dfbcEvents.masks.hw0Mask.bits.ADC0 = 1;
    }

    if(dtuConfig.loopOperation.ioCount[0].enable == 1) {
    	dfbcEvents.masks.hw0Mask.bits.IOCNT0 = 1;
       	dfbcEvents.IOCNT0 = dtuConfig.loopOperation.ioCount[0].Count;
    }

    if(dtuConfig.loopOperation.ioCount[1].enable == 1) {
    	dfbcEvents.masks.hw0Mask.bits.IOCNT1 = 1;
       	dfbcEvents.IOCNT1 = dtuConfig.loopOperation.ioCount[1].Count;
    }

    if(dtuConfig.loopOperation.ioIn[0].enable == 1) {
    	dfbcEvents.masks.hw0Mask.bits.IOIN0 = 1;
    	dfbcEvents.IOIN0 = !(GPIOB_ReadPortPin(dtuConfig.loopOperation.ioIn[0].pin) != 0);
    }

    if(dtuConfig.loopOperation.ioIn[1].enable == 1) {
    	dfbcEvents.masks.hw0Mask.bits.IOIN1 =  1;
    	dfbcEvents.IOIN1 = !(GPIOB_ReadPortPin(dtuConfig.loopOperation.ioIn[1].pin) != 0);
    }
}

void pollModbus( void ){
	uint8_t ret = 0;
	uint8_t index = 0;
	uint8_t dataLen;
	//DBG("---dtuConfig.loopOperation.rs485Mask=0x%04X\n",dtuConfig.loopOperation.rs485Mask);
	//最大支持八个指令，多测几个 和不同的数据类型
	for (uint8_t i = 0; i < 8; i++) {
	    if (dtuConfig.loopOperation.rs485item[i].enable == 1) {
	    	dfbcEvents.masks.modbusMask |= (1<<i);
	    	float value;
        	uint8_t rawdata[30],rawdatalen;
        	if(execModbusItem(i, rawdata, &rawdatalen, &value) == 0) {
        		dfbcEvents.RS485Value[i] = value;
        		DBG("dfbcEvents.RS485Value[%d] = %.2f\n",i,dfbcEvents.RS485Value[i]);
        	} else {
        		uint32_t tmp = 0x80000000;
        		memcpy(&dfbcEvents.RS485Value[i], &tmp, 4);
        		DBG("dfbcEvents.RS485Value[%d] = %.2f\n",i,dfbcEvents.RS485Value[i]);
        	}
	    }
	}
}
