#include "timeScheduler.h"
#include <stdio.h>
#include <stdbool.h>
#include "CH58x_common.h"
#include <stdlib.h>
#include "radio.h"
//我要根据什么来调节 我的时间 ,近一段时间的重传比例
//如何调节，在loopTime的(前十秒)和后十秒
//每次调节500ms，调节之后，根据
static uint8_t adjustNum = 0; //调节次数
static int16_t adjustOffset = 0; //调节偏移
#define  MAXOFFSET        15  //最大调节偏移
#define  MAXPACK         3  //多少个包检测一次

#define  ACKTHRESHOLD   2    //ACK阈值
#define  RETRYTHRESHOLD   4  //重传阈值

#include "sx126x.h"
static int16_t maxOffset = -MAXOFFSET; //调节偏移范围


static uint16_t ackCount = 0; //ack个数  ，最大的ack的个数为3
static int16_t PackCount = 0; //包个数 ，3个包调节一次
static uint16_t retryCount = 0; //重传次数 最大的重传次数为6



volatile uint8_t WDOGNUM = 0;
volatile uint8_t loopNum = 0;

static uint16_t txtimeoutFlag = 0;
static uint8_t resetSX126x = 0;

void setAckCount(){
    ackCount++; // = ackcount;
}

void setPackCount(){
    if(PackCount % MAXPACK == 0){
        ackCount = 0;
        retryCount = 0;
    }
    PackCount ++;
}

void setRetryCount(){
    retryCount++;
}


uint32_t getNextTime(sTimerType_t type){
    uint32_t delayTime;

    uint8_t adjustFlag = 0;
    int8_t adjustDir= 0;
    if(PackCount % MAXPACK == 0){
       // printf("PackCount: %d retryCount: %d ackCount: %d\n",PackCount,retryCount,ackCount);
      if(retryCount > RETRYTHRESHOLD && ackCount< ACKTHRESHOLD){
          sprintf(str,"adjustOffset=%d\n",adjustOffset);
          sysLog(str);
          adjustFlag = 1;
      }
    }

    if(adjustFlag == 1){

       if( maxOffset == MAXOFFSET && adjustOffset < maxOffset ){
         adjustOffset++;
         adjustDir = 1;
         if(adjustOffset == MAXOFFSET){
             maxOffset = -MAXOFFSET;
         }
       }else if((maxOffset == -MAXOFFSET) && adjustOffset> maxOffset){
          adjustDir = -1;
          adjustOffset--;
          if(adjustOffset == -MAXOFFSET){
              maxOffset = MAXOFFSET;
          }
       }

        delayTime= dtuConfig.hardPara.loopTime + ((randr( (dtuConfig.hardPara.loopTime/30)-1000, dtuConfig.hardPara.loopTime/30 ))*adjustDir);
        adjustFlag = 0;
    }else{
        delayTime = dtuConfig.hardPara.loopTime;
    }
    return delayTime;
}


void startCad(uint8_t sf ,uint32_t bw,uint32_t frq ){

    // MibRequestConfirm_t mibReq;
    // mibReq.Type = MIB_CHANNELS_DATARATE;
    // dtuConfig.loraWanPara.dataRate = dr;
    // mibReq.Param.ChannelsDatarate = dr;
     //LoRaMacMibSetRequestConfirm( &mibReq );
    //Radio.SetChannel(868);
    //SX126xSetCadParams(0x04, 12 + 13, 10, LORA_CAD_ONLY, 300000);
    //Radio.SetRxConfig(MODEM_LORA,(uint32_t)_bandwidth, _SF, 1, 0, 8, 0, false, 0, true, 0, 0, false, true);
    //setSpreadingFactor
    Radio.StartCad();
}
void cadGetNextFrq(){



}
void resetWdog(){
#ifdef  WWDG_ENABLE

    WWDG_SetCounter(0);
    WDOGNUM = 0;
#endif
}

void startWdog(){
#ifdef  WWDG_ENABLE
    //看门狗使能
    WWDG_ITCfg(ENABLE);
   // printf("start\n");0.5s
    WWDG_SetCounter(0);
    WWDG_ResetCfg(0);
    PFIC_EnableIRQ(WDOG_BAT_IRQn);
#endif
}
void stopWdog(){

    //看门狗使能
    WWDG_ITCfg(DISABLE);

}
__INTERRUPT//中断函数
__HIGH_CODE
void WDOG_BAT_IRQHandler(void)
{
  WWDG_ClearFlag();

  WDOGNUM++;
  printf("W=%d\n",WDOGNUM);
  if(WDOGNUM > 16){
      printf("----WDOG reset\n");
      DelayMs(100);
      WWDG_ResetCfg(1);
      WDOGNUM = 0;
  }
  //WWDG_SetCounter(0);

}

void handleTxtimeout(){
    if(resetSX126x == 1 && txtimeoutFlag > 16){
       //重置sx126x
        printf("softReset\n");
        DelayMs(100);
        softReset();
    }

    if(resetSX126x == 0 && txtimeoutFlag >= 3){
        radioReset();
        resetSX126x = 1;
        printf("resetSX126x\n");
    }
}


void setTxtimeout()
{

    txtimeoutFlag++;

}

void resetTxtimeout(){
    txtimeoutFlag = 0;
    resetSX126x =0;

}


