#ifndef __UTILS__H
#define __UTILS__H
#include <stdio.h>
#include <stdbool.h>

#define DEBUG_USER
#ifdef  DEBUG_USER
#define DBG(...) printf(" DBG(%s, %s(), %d): ", __FILE__, __FUNCTION__, __LINE__); printf(__VA_ARGS__)
#else
#define DBG(...)
#endif


#define DEBUG_MAC
#ifdef  DEBUG_MAC
#define DBGMAC(...) printf(" DBGMAC(%s, %s(), %d): ", __FILE__, __FUNCTION__, __LINE__); printf(__VA_ARGS__)
#else
#define DBGMAC(...)
#endif


#define DEBUG_AT
#ifdef  DEBUG_AT
#define DBGAT(...) printf(" DBGAT(%s, %s(), %d): ", __FILE__, __FUNCTION__, __LINE__); printf(__VA_ARGS__)
#else
#define DBGAT(...)
#endif


void relay(uint8_t value);
void floatToString(float number, char *str, int precision);

typedef struct lora_packet {
    struct lora_packet *next;
    uint8_t *buf;
    uint8_t len;
    uint8_t confirmed;
} lora_packet_t;

extern void lora_packet_list_append(uint8_t *buf, uint8_t len, uint8_t confirmed);
extern void lora_packet_list_del_head();
extern void lora_packet_list_print();
extern lora_packet_t * lora_packet_get_head();
extern uint8_t lora_packet_list_length();

#endif
